<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : DataObjectsProperties.xsl

Notes       :

Open Issues :

$revision_history$
18-nov-2003   Steven Davelaar
  1.7         Changed header in property file
17-apr-2003   STEVEN DAVELAAR
  1.6         cleaned up revisions history
Date          Author
  Version     Notes
16-apr-2003   STEVEN DAVELAAR
  1.4         Added support for queryType
17-mrt-2003   STEVEN DAVELAAR
  1.3         .
23-okt-2002   Peter Ebell
  1.2         Use viewObjectUsage attribute instead of viewObject (viewObject as fallback 
              for backward compatibility
14-mei-2002   Peter Ebell
  1.1         Pre-prod release

17-mar-2003   Steven Davelaar
  1.3         
23-oct-2002   Peter Ebell
  1.2         Use viewObjectUsage attribute instead of viewObject (viewObject as fallback 
              for backward compatibility
14-may-2002   Peter Ebell
  1.1         Pre-prod release
22-feb-2002   Peter Ebell
  1.0         Initial creation
*******************************************************************************
$add_to_revision_history
$
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="text"/>

  <xsl:variable name="list" select="Service//Group | Service//Lookup"/>

  <xsl:key name="dataObjects-index" match="Service//Group | Service//Lookup" use="concat(@dataObject,@queryType)"/>

  <xsl:variable name="modelBase" select="Service/@modelBase"/> 

  <xsl:template match="/">
<xsl:text>#  Mapping between a dataobject (querytype) and a ViewObject
</xsl:text>
    <xsl:for-each select="$list[generate-id(.)=generate-id(key('dataObjects-index',concat(@dataObject,@queryType)))]">
      <xsl:variable name="viewUsage">
        <xsl:choose>
          <xsl:when test="@viewObjectUsage!=''">
            <xsl:value-of select="@viewObjectUsage"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="@viewObject"/>
          </xsl:otherwise>
        </xsl:choose>  
      </xsl:variable>

      <!-- key depends on queryType being set -->
      <xsl:variable name="key">
        <xsl:choose>
          <xsl:when test="@queryType!=''">
            <xsl:value-of select="concat($modelBase,'.',@dataObject,'.',@queryType)"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="concat($modelBase,'.',@dataObject)"/>
          </xsl:otherwise>
        </xsl:choose>  
      </xsl:variable>

      <xsl:value-of select="$key"/>=<xsl:value-of select="$viewUsage"/>
      
<xsl:text>
</xsl:text>
    </xsl:for-each>
  </xsl:template>

</xsl:stylesheet>
