<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : DataObjectsProperties.xsl

Notes       :

Open Issues :

$revision_history$
18-nov-2003   Steven Davelaar
  1.3         Changed header in property file
17-mar-2003   Steven Davelaar
  1.2         
14-may-2002   Peter Ebell
  1.1         Pre-prod release
22-feb-2002   Peter Ebell
  1.0         Initial creation
*******************************************************************************
$add_to_revision_history
$
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="text"/>

  <xsl:variable name="list" select="Service//Group | Service//Lookup"/>
  <xsl:variable name="modelBase" select="Service/@modelBase"/> 
  <xsl:variable name="provider" select="concat(Service/@name,'Provider')"/> 

  <xsl:key name="dataObjects-index" match="Service//Group | Service//Lookup" use="@dataObject"/>


<xsl:template match="/">
<xsl:text># Mapping between a dataobject and its provider, as defined in cle-providers.xml
</xsl:text>

<xsl:for-each select="$list[generate-id(.)=generate-id(key('dataObjects-index',@dataObject))]">
      <xsl:value-of select="concat($modelBase,'.',@dataObject)"/>=<xsl:value-of select="$provider"/>
<xsl:text>
</xsl:text>
</xsl:for-each>
</xsl:template>

</xsl:stylesheet>
