<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : HandlerImpl.xsl

Notes       :

Open Issues :

$revision_history$
16-feb-2004   Peter Ebell
  2.4         Use getDataObjectInterface and getHandlerClass methods on XSLTUtils.
17-mar-2003   Steven Davelaar
  2.3         
10-jun-2002   Peter Ebell
  2.2         Pass the dataObjectName in as a parameter so that we don't have to search groups and
              lookups based on passed group or lookup names for something we already know when
              invoking this template. Also fixes bug with double handler text for lookups with identical
              names.
14-may-2002   Peter Ebell
  2.1         - Generate empty handlers for MVC Framework v2
              - Use this stylesheet both for Group and Lookup handlers.
28-mrt-2002   Peter Ebell
  2.0         Rewritten for JHeadstart 9i. Now generated empty HandlerImpl classes.
              Deleted obsolete revision history.
18-apr-2001   Steven Davelaar
  1.0         Initial creation
*******************************************************************************
$add_to_revision_history
$
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:jheadstart="http://www.oracle.com/jheadstart"
  xmlns:utils="http://www.oracle.com/XSL/Transform/java/oracle.jheadstart.tools.util.XSLTUtils"
  exclude-result-prefixes="utils"   
  >
  <xsl:output method="text"/>
  <xsl:param name="dataObjectName"></xsl:param>

  <xsl:variable name="modelImplementationBase">
    <xsl:value-of select="Service/@modelImplementationBase"/>
  </xsl:variable>

  <xsl:variable name="modelBase">
    <xsl:value-of select="concat(Service/@modelBase,'.')"/>
  </xsl:variable>

  <xsl:variable name="superClass">
    <xsl:choose>
      <xsl:when test="Service/@handlerSuperClass!=''">
        <xsl:value-of select="Service/@handlerSuperClass"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="'oracle.jheadstart.model.bc4j.handler.DataObjectHandlerImpl'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:variable name="class">
    <xsl:value-of select="utils:getHandlerClassName($dataObjectName)"/>
  </xsl:variable>

  <xsl:variable name="fullDataObjectName">
    <xsl:value-of select="utils:getDataObjectInterface($modelBase,$dataObjectName)"/>
  </xsl:variable>


  <xsl:template match="/">

/*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : <xsl:value-of select="$class"/>.java

Classes     : <xsl:value-of select="$class"/>

Notes       : Handler for the <xsl:value-of select="$fullDataObjectName"/> dataObject

Open Issues :

Revision History
$date 17-mar-2003$   JHeadstart Application Generator
  1.0    Initial creation
******************************************************************************/

package <xsl:value-of select="$modelImplementationBase"/>.handler;

public class <xsl:value-of select="$class"/>
       extends <xsl:value-of select="$superClass"/>
{

}

</xsl:template>

</xsl:stylesheet>
