<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : JSPFormLib.xsl

Notes       :

TODO: Region headers should be JSP include.

$revision_history$
16-feb-2004   Peter Ebell
  1.19        - With Regions, use width of form layout also on the html table for the non-region items.
              - Bigger space before region headers
18-jan-2004   Peter Ebell
  1.18        Regions are used in Form layout
26-oct-2003   Aard-Jan van Kesteren
  1.17        Rewrote Boolean.TRUE and Boolean.FALSE occurences
14-aug-2003   Aard-Jan van Kesteren
  1.16        
12-aug-2003   Aard-Jan van Kesteren
  1.15        Solved bug 3067383: Use lovTitle instead of displayTitle as value for LOV_TITLE
07-aug-2003   Aard-Jan van Kesteren
  1.14        Use the new getNlsKey also for the LOV_TITLE
07-aug-2003   Aard-Jan van Kesteren
  1.13        Generate nls key FIND_BUTTON_LABEL_(group name) instead of just FIND_BUTTON_LABEL
07-aug-2003   Aard-Jan van Kesteren
  1.12        Only add the new key label to the nls bundle if new key is displayed.
06-aug-2003   Steven Davelaar
  1.11        
05-aug-2003   Aard-Jan van Kesteren
  1.10        - Refactored the title of lov's
01-aug-2003   Aard-Jan van Kesteren
  1.9         - refactored attributes of jsp include heading1
              - refactored attributes of jsp include buttonsFindForm
29-jul-2003   Aard-Jan van Kesteren
  1.8         - dropped hidden input event and added hidden inputs targetCondition
                and targetConditionValue
              - Made changes necesarry for using form.js instead of jspForm.js
25-jul-2003   Aard-Jan van Kesteren
  1.7         - Solved bug 3067383. Make use of the title attribute of a lookup.
                (Changes in findFormLayout)
22-jul-2003   Aard-Jan van Kesteren
  1.6         - Solved Bug 2411381. Don't show a new button in case of table layout
22-jul-2003   Aard-Jan van Kesteren
  1.5         - Solved Bug 3057888. I deleted all the stuff that had to do 
                with regions. I didn't  comment it out, because I hate commented out code.
14-mrt-2003   Aard-Jan van Kesteren
  1.0         Initial creation (based on UIXFormLib)

*******************************************************************************
$add_to_revision_history
$
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:utils="http://www.oracle.com/XSL/Transform/java/oracle.jheadstart.tools.util.XSLTUtils"
  xmlns:string="http://www.oracle.com/XSL/Transform/java/java.lang.String"      
  exclude-result-prefixes="utils string"
>
  <xsl:import href="JSPLibrary.xsl"/>

  <xsl:output method="xml" indent="yes" />

  <xsl:template name="formLayout">
    <xsl:param name="columns"/>
    <xsl:param name="voDoc"/>
    <xsl:param name="layoutStyle"/>
    
    <xsl:variable name="width">
      <xsl:choose>
        <xsl:when test="@formWidth!=''">
          <xsl:value-of select="@formWidth"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'10%'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

  <table width="{$width}">

    <logic___notEqual name="{concat(@name, 'Bean')}" value="true" property="{concat(@name, 'IsInserting')}">
      <xsl:call-template name="jspInclude">
        <xsl:with-param name="page" select="'formScrollButtons.jsp'"/>
        <xsl:with-param name="param1Name" select="'setName'"/>
        <xsl:with-param name="param1Value" select="concat(@name, 'Set')"/>
      </xsl:call-template>        
   </logic___notEqual>


    <tr>
    <td>
<!--   <table class="form" width="100%"> -->
      <xsl:variable name="dummy">
        <xsl:value-of select="utils:declareCounter('columnsCounter')"/>        
      </xsl:variable>
      <xsl:variable name="dummy2">
        <xsl:value-of select="utils:declareCounter('itemsCounter')"/>        
      </xsl:variable>      
      <xsl:call-template name="formItems">
        <xsl:with-param name="voDoc" select="$voDoc"/>
        <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
        <xsl:with-param name="columns" select="$columns"/>
        <xsl:with-param name="width" select="$width"/>
        <xsl:with-param name="formName" select="concat(@name, 'Bean')"/>
      </xsl:call-template>
<!--    </table>  -->
    </td>
    </tr>
  </table>
 
  </xsl:template>

  <xsl:template name="findFormLayout">
    <xsl:param name="columns"/>
    <xsl:param name="voDoc"/>
    <xsl:param name="layoutStyle"/>
    <xsl:param name="name"><xsl:value-of select="concat('Find', @name)"/></xsl:param>
    <xsl:param name="formWidth"/>
    <xsl:param name="lovTitle"/>

    <xsl:variable name="width">
      <xsl:choose>
        <xsl:when test="$formWidth != ''">
          <xsl:value-of select="$formWidth"/>
        </xsl:when>
        <xsl:when test="@formWidth!=''">
          <xsl:value-of select="@formWidth"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'10%'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="displayTitle">
      <xsl:call-template name="getDisplayTitle"/>
    </xsl:variable>

    <xsl:call-template name="jspInclude">
      <xsl:with-param name="page" select="'jhsInfo.jsp'"/>
    </xsl:call-template>
      
    <html___form>
      <xsl:attribute name="name">
        <xsl:value-of select="$name"/>
      </xsl:attribute>
      <xsl:attribute name="action">
        <xsl:value-of select="concat('/Start', /Service/@name)"/>
      </xsl:attribute>
      <xsl:attribute name="type">
        <xsl:text>oracle.jheadstart.view.struts.JhsDynaActionForm</xsl:text>
      </xsl:attribute>
      <xsl:attribute name="scope">
        <xsl:text>session</xsl:text>
      </xsl:attribute>

      <script>ignoreChanges=true;</script>
      <input type="hidden" name="targetCondition"/>
      <input type="hidden" name="targetConditionValue"/>
      <!-- The hidden input value is necessary if the findFormLayout
           template is used for a lov screen -->
      <input type="hidden" name="value"/>
      <input type="hidden" name="source"/>
      <xsl:call-template name="targetGroupHiddenFields"/>      

      <xsl:call-template name="jspInclude">
        <xsl:with-param name="page" select="'heading1.jsp'"/>
        <xsl:with-param name="param1Name" select="'key'"/>
        <xsl:with-param name="param1Value">
          <xsl:choose>

            <xsl:when test="$lovTitle != ''">
                      <xsl:value-of select="utils:getNlsKey('LOV_TITLE',$lovTitle, concat('LOV_TITLE_',@name))"/>          
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="utils:getNlsKey('SEARCH_TITLE',$displayTitle, concat('SEARCH_TITLE_',@name))"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:with-param> 
      </xsl:call-template>

      <table class="findForm" width="{$width}">
        <xsl:variable name="dummy">
          <xsl:value-of select="utils:declareCounter('itemsCounter')"/>
        </xsl:variable>
        <xsl:variable name="dummy2">
          <xsl:value-of select="utils:declareCounter('columnsCounter')"/>
        </xsl:variable>
      
         <xsl:call-template name="findFormItems">
           <xsl:with-param name="voDoc" select="$voDoc"/>
           <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
           <xsl:with-param name="hiddenDisplay" select="'false'"/>
           <xsl:with-param name="formName" select="$name"/>
           <xsl:with-param name="columns" select="$columns"/>
         </xsl:call-template>
      </table>

      <xsl:variable name="newKey">
        <xsl:choose>
          <xsl:when test="not($layoutStyle='lov' or @layoutStyle='table') and (@insert = 'true')">
            <xsl:value-of select="utils:getNlsKey('NEW_BUTTON_LABEL', $displayTitle, concat('NEW_BUTTON_LABEL_',@name))"/>
          </xsl:when>
          <xsl:otherwise>
            no new button
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

      <xsl:call-template name="jspInclude">
        <xsl:with-param name="page" select="'buttonsFindForm.jsp'"/>
        <xsl:with-param name="param1Name" select="'findKey'"/>
        <xsl:with-param name="param1Value" select="utils:getNlsKey('FIND_BUTTON_LABEL',$displayTitle,concat('FIND_BUTTON_LABEL_',@name))"/>
        <xsl:with-param name="param2Name" select="'newKey'"/>
        <xsl:with-param name="param2Value" select="$newKey"/>
        <xsl:with-param name="addParam2" select="not($layoutStyle='lov' or @layoutStyle='table') and (@insert = 'true')"/>  
        <xsl:with-param name="param3Name" select="'formName'"/>
        <xsl:with-param name="param3Value" select="$name"/>
      </xsl:call-template>      
      
  </html___form>
  
  </xsl:template>


  <xsl:template name="formItems">
    <xsl:param name="voDoc"/>
    <xsl:param name="layoutStyle"/>
    <xsl:param name="columns">1</xsl:param>
    <xsl:param name="width"/>
    <xsl:param name="formName">noName (formItems)</xsl:param>

    <!-- we need to store the group node in a variable because we will
         loose the "Group" context from here on
    -->
    <xsl:variable name="group" select="current()"/>
    <xsl:variable name="resourceName" select="@name"/>

    <xsl:choose>
      <xsl:when test="not(Region)">
        <!-- If there are no regions defined on this group, process all viewAttributes -->
        <table class="form" width="100%">
          <xsl:variable name="viewAttributes" select="$voDoc/ViewObject/ViewAttribute[not(Properties/Property[@Name='REGION']/@Value)]"/>
          <xsl:call-template name="handleItemRows">
            <xsl:with-param name="voDoc" select="$voDoc"/>
            <xsl:with-param name="viewAttributes" select="$viewAttributes"/>
            <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
            <xsl:with-param name="group" select="$group"/>
            <xsl:with-param name="resourceName" select="$resourceName"/>
            <xsl:with-param name="formName" select="$formName"/>
            <xsl:with-param name="columns" select="$columns"/>
          </xsl:call-template> 
        </table>
      </xsl:when>  
      <xsl:otherwise>
<!--    <xsl:message>We have regions in group <xsl:value-of select="@name"/></xsl:message> -->
        <!-- First display the items that do not belong to a region -->
        <table class="form" width="{$width}">
          <xsl:variable name="viewAttributes" select="$voDoc/ViewObject/ViewAttribute[not(Properties/Property[@Name='REGION']/@Value)]"/>
          <xsl:call-template name="handleItemRows">
            <xsl:with-param name="voDoc" select="$voDoc"/>
            <xsl:with-param name="viewAttributes" select="$viewAttributes"/>
            <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
            <xsl:with-param name="group" select="$group"/>
            <xsl:with-param name="resourceName" select="$resourceName"/>
            <xsl:with-param name="formName" select="$formName"/>
            <xsl:with-param name="columns" select="$columns"/>
          </xsl:call-template> 
        </table>

        <!-- Loop over all the regions, and display only the fields in these regions -->
        <xsl:for-each select="Region">
          <xsl:variable name="regionTitle" select="@title"/>
          <xsl:variable name="regionName" select="@name"/>
          <xsl:variable name="regionWidth">
            <xsl:choose>
              <xsl:when test="@width">
                <xsl:value-of select="@width"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="'10%'"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:variable>
          <xsl:variable name="regionColumns" select="@columns"/>
          <xsl:variable name="regionTitleKey">
            <xsl:value-of select="string:toUpperCase(concat($group/@name,'_REGION_',$regionName))"/>
          </xsl:variable>


          <table class="heading1" width="100%">
            <!-- Only display if there is a title -->
            <xsl:if test="$regionTitle">
              <tr><td height="10"></td></tr>
              <tr>
                <td>
                  <xsl:call-template name="nlsTextAttribute">
                    <xsl:with-param name="key">
                      <xsl:value-of select="$regionTitleKey"/>
                    </xsl:with-param>
                    <xsl:with-param name="value">
                      <xsl:value-of select="$regionTitle"/>
                    </xsl:with-param>
                    <xsl:with-param name="addToNlsBundle">true</xsl:with-param>
                  </xsl:call-template>
                </td>
              </tr>
            </xsl:if>  
            <tr><td height="10"></td></tr>
          </table>

          <table class="form" width="{$regionWidth}">
            <xsl:variable name="regionViewAttributes" select="$voDoc/ViewObject/ViewAttribute[Properties/Property[@Name='REGION' and @Value=$regionName]]"/>

            <xsl:variable name="dummy1">
              <xsl:value-of select="utils:resetCounter('itemsCounter')"/>
            </xsl:variable>
            <xsl:variable name="dummy2">
              <xsl:value-of select="utils:resetCounter('columnsCounter')"/>
            </xsl:variable>   
            <xsl:call-template name="handleItemRows">
              <xsl:with-param name="voDoc" select="$voDoc"/>
              <xsl:with-param name="viewAttributes" select="$regionViewAttributes"/>
              <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
              <xsl:with-param name="group" select="$group"/>
              <xsl:with-param name="resourceName" select="$resourceName"/>
              <xsl:with-param name="formName" select="$formName"/>
              <xsl:with-param name="columns" select="$regionColumns"/>
            </xsl:call-template> 
           </table>  
         </xsl:for-each>
       </xsl:otherwise>
     </xsl:choose>
  </xsl:template>

  <xsl:template name="handleItemRows">
    <xsl:param name="voDoc"/>
    <xsl:param name="viewAttributes"/>
    <xsl:param name="layoutStyle"/>
    <xsl:param name="group"/>
    <xsl:param name="resourceName"/>
    <xsl:param name="formName"/>
    <xsl:param name="columns"/>

    <xsl:variable name="counter">
      <xsl:value-of select="utils:readCounter('itemsCounter')"/>
    </xsl:variable>

    <xsl:if test="count($viewAttributes) != $counter">
      <xsl:variable name="dummy">
        <xsl:value-of select="utils:resetCounter('columnsCounter')"/>
      </xsl:variable>    
      <tr>
        <xsl:call-template name="handleItemRow">
          <xsl:with-param name="voDoc" select="$voDoc"/>
          <xsl:with-param name="viewAttributes" select="$viewAttributes"/>
          <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
          <xsl:with-param name="group" select="$group"/>
          <xsl:with-param name="resourceName" select="$resourceName"/>
          <xsl:with-param name="formName" select="$formName"/>
          <xsl:with-param name="columns" select="$columns"/>        
        </xsl:call-template>
      </tr>
      
      <xsl:call-template name="handleItemRows">
        <xsl:with-param name="voDoc" select="$voDoc"/>
        <xsl:with-param name="viewAttributes" select="$viewAttributes"/>
        <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
        <xsl:with-param name="group" select="$group"/>
        <xsl:with-param name="resourceName" select="$resourceName"/>
        <xsl:with-param name="formName" select="$formName"/>
        <xsl:with-param name="columns" select="$columns"/>
      </xsl:call-template>  
    </xsl:if>  
  </xsl:template>

  <xsl:template name="handleItemRow">
    <xsl:param name="voDoc"/>
    <xsl:param name="viewAttributes"/>    
    <xsl:param name="layoutStyle"/>
    <xsl:param name="group"/>
    <xsl:param name="resourceName"/>
    <xsl:param name="formName"/>
    <xsl:param name="columns"/>

    <xsl:variable name="counter">
      <xsl:value-of select="utils:readCounter('columnsCounter')"/>
    </xsl:variable>
    <xsl:variable name="itemsCounter">
      <xsl:value-of select="utils:readCounter('itemsCounter')"/>
    </xsl:variable>    

    <xsl:for-each select="$viewAttributes[position() = $itemsCounter + 1]">
      <xsl:call-template name="handleItem">
        <xsl:with-param name="voDoc" select="$voDoc"/>
        <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
        <xsl:with-param name="group" select="$group"/>
        <xsl:with-param name="resourceName" select="$resourceName"/>
        <xsl:with-param name="formName" select="$formName"/>
        <xsl:with-param name="table" select="'td'"/>
      </xsl:call-template> 
      <xsl:variable name="dummy">
        <xsl:value-of select="utils:increaseCounter('itemsCounter')"/>
      </xsl:variable>
    </xsl:for-each>

    <xsl:variable name="counterAfter">
      <xsl:value-of select="utils:readCounter('columnsCounter')"/>
    </xsl:variable>
    <xsl:variable name="itemsCounterAfter">
      <xsl:value-of select="utils:readCounter('itemsCounter')"/>
    </xsl:variable>

    <xsl:if test="    (count($viewAttributes) != $itemsCounterAfter)  
                  and ($columns != $counterAfter)">
      <xsl:call-template name="handleItemRow">
        <xsl:with-param name="voDoc" select="$voDoc"/>
        <xsl:with-param name="viewAttributes" select="$viewAttributes"/>
        <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
        <xsl:with-param name="group" select="$group"/>
        <xsl:with-param name="resourceName" select="$resourceName"/>
        <xsl:with-param name="formName" select="$formName"/>
        <xsl:with-param name="columns" select="$columns"/>        
      </xsl:call-template>
    </xsl:if>
    
  </xsl:template>



  <!-- Template to hande a single form item. -->
  <xsl:template name="handleItem">
    <xsl:param name="voDoc"/>
    <xsl:param name="layoutStyle"/>
    <xsl:param name="group"/>
    <xsl:param name="resourceName"/>
    <xsl:param name="hiddenDisplay"/>
    <xsl:param name="table">tr</xsl:param>
    <xsl:param name="formName">noName (handleItem)</xsl:param>

      <xsl:variable name="eoFile">
        <xsl:call-template name="getEoFileName">
          <xsl:with-param name="voDoc" select="$voDoc"/>
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="entityUsage" select="@EntityUsage"/>
      <xsl:variable name="eoAttributeName" select="@EntityAttrName"/>
      <xsl:variable name="eoDoc" select="document($eoFile)"/>
      <xsl:variable name="entityAttributeNode"  select="$eoDoc/Entity/Attribute[$entityUsage!='' and @Name=$eoAttributeName]|current()[$entityUsage='']"/>

      <xsl:variable name="display">
        <xsl:call-template name="getCustomProperty">
          <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
          <xsl:with-param name="propertyName" select="'DISPLAY'"/>
          <xsl:with-param name="defaultValue" select="'true'"/>
        </xsl:call-template>
      </xsl:variable>

      <xsl:choose>
      <xsl:when test="$display != 'false'">  
<!--        <xsl:when test="$display='true' or $display='hidden'"> -->
          <xsl:call-template name="createFormElement">
            <xsl:with-param name="attributeName" select="@Name"/>
            <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
            <xsl:with-param name="operator" select="''"/>
            <xsl:with-param name="isFindElement">false</xsl:with-param>
            <xsl:with-param name="display" select="$display"/>
            <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
            <xsl:with-param name="group" select="$group"/>
            <xsl:with-param name="resourceName" select="$resourceName"/>
            <xsl:with-param name="formName" select="$formName"/>
            <xsl:with-param name="table" select="$table"/>
          </xsl:call-template>
        </xsl:when>
      </xsl:choose>
  </xsl:template>    

  <xsl:template name="findFormItems">
    <xsl:param name="voDoc"/>
    <xsl:param name="layoutStyle"/>
    <xsl:param name="hiddenDisplay"/>  
    <xsl:param name="formName">noName</xsl:param>
    <!-- we need to store the group node in a variable because we will
         loose the "Group" context from here on
    -->
    <xsl:param name="group" select="current()"/>
    <xsl:param name="resourceName" select="@dataObject"/>
    <xsl:param name="columns"/>

    <xsl:variable name="counter">
      <xsl:value-of select="utils:readCounter('itemsCounter')"/>
    </xsl:variable>

    <xsl:if test="count($voDoc/ViewObject/ViewAttribute[not(@IsQueriable='false')]) != $counter">
      <xsl:variable name="dummy">
        <xsl:value-of select="utils:resetCounter('columnsCounter')"/>
      </xsl:variable>  
      <tr>
        <xsl:call-template name="handleFindItemRow">
          <xsl:with-param name="voDoc" select="$voDoc"/>
          <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
          <xsl:with-param name="group" select="$group"/>
          <xsl:with-param name="resourceName" select="$resourceName"/>
          <xsl:with-param name="formName" select="$formName"/>
          <xsl:with-param name="columns" select="$columns"/>        
        </xsl:call-template>
      </tr>
      
      <xsl:call-template name="findFormItems">
          <xsl:with-param name="voDoc" select="$voDoc"/>
          <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
          <xsl:with-param name="group" select="$group"/>
          <xsl:with-param name="resourceName" select="$resourceName"/>
          <xsl:with-param name="formName" select="$formName"/>
          <xsl:with-param name="columns" select="$columns"/>        
      </xsl:call-template>  
    </xsl:if>  
  </xsl:template>

  <xsl:template name="handleFindItemRow">
    <xsl:param name="voDoc"/>
    <xsl:param name="layoutStyle"/>
    <xsl:param name="hiddenDisplay"/>  
    <xsl:param name="formName"/>
    <xsl:param name="group"/>
    <xsl:param name="resourceName"/>
    <xsl:param name="columns"/>

    <xsl:variable name="counter">
      <xsl:value-of select="utils:readCounter('columnsCounter')"/>
    </xsl:variable>
    <xsl:variable name="itemsCounter">
      <xsl:value-of select="utils:readCounter('itemsCounter')"/>
    </xsl:variable>    

    <xsl:for-each select="$voDoc/ViewObject/ViewAttribute[not(@IsQueriable='false')][position() = $itemsCounter + 1]">
      <xsl:call-template name="handleFindItem">
          <xsl:with-param name="voDoc" select="$voDoc"/>
          <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
          <xsl:with-param name="group" select="$group"/>
          <xsl:with-param name="resourceName" select="$resourceName"/>
          <xsl:with-param name="formName" select="$formName"/>
          <xsl:with-param name="columns" select="$columns"/>  
          <xsl:with-param name="table" select="'td'"/>
      </xsl:call-template> 
      <xsl:variable name="dummy">
        <xsl:value-of select="utils:increaseCounter('itemsCounter')"/>
      </xsl:variable>
    </xsl:for-each>

    <xsl:variable name="counterAfter">
      <xsl:value-of select="utils:readCounter('columnsCounter')"/>
    </xsl:variable>
    <xsl:variable name="itemsCounterAfter">
      <xsl:value-of select="utils:readCounter('itemsCounter')"/>
    </xsl:variable>

    <xsl:if test="    (count($voDoc/ViewObject/ViewAttribute[not(@IsQueriable='false')]) != $itemsCounterAfter)  
                  and ($columns != $counterAfter)">
      <xsl:call-template name="handleFindItemRow">
        <xsl:with-param name="voDoc" select="$voDoc"/>
        <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
        <xsl:with-param name="group" select="$group"/>
        <xsl:with-param name="resourceName" select="$resourceName"/>
        <xsl:with-param name="formName" select="$formName"/>
        <xsl:with-param name="columns" select="$columns"/>        
      </xsl:call-template>
    </xsl:if>
    
  </xsl:template>

  <xsl:template name="handleFindItem">
    <xsl:param name="voDoc"/>
    <xsl:param name="layoutStyle"/>
    <xsl:param name="hiddenDisplay"/>  
    <xsl:param name="formName"/>
    <xsl:param name="group"/>
    <xsl:param name="resourceName"/>
    <xsl:param name="columns"/>

      <xsl:variable name="eoFile">
        <xsl:call-template name="getEoFileName">
          <xsl:with-param name="voDoc" select="$voDoc"/>
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="entityUsage" select="@EntityUsage"/>
      <xsl:variable name="eoAttributeName" select="@EntityAttrName"/>
      <xsl:variable name="eoDoc" select="document($eoFile)"/>
      <xsl:variable name="entityAttributeNode"  select="$eoDoc/Entity/Attribute[$entityUsage!='' and @Name=$eoAttributeName]|current()[$entityUsage='']"/>
      
      <xsl:variable name="isQueriable" select="$entityAttributeNode/@IsQueriable"/>

      <xsl:variable name="display">
        <xsl:call-template name="getCustomProperty">
          <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
          <xsl:with-param name="propertyName" select="'DISPLAY'"/>
          <xsl:with-param name="defaultValue" select="'true'"/>
        </xsl:call-template>
      </xsl:variable>

      <!-- check whether IsQueriable flag is set to false at EO level -->
      <xsl:if test="not ($isQueriable='false') and not ($display='false')">

        <xsl:variable name="rangeQuery">
        <!--
          <xsl:call-template name="getCustomProperty">
            <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
            <xsl:with-param name="propertyName" select="'RANGE_QUERY'"/>
            <xsl:with-param name="defaultValue" select="'false'"/>
          </xsl:call-template>
        -->
        <!-- In this version, we don't support range queries yet. So the
             value for this variable will always be false
        -->
          <xsl:value-of select="'false'"/>
         
        </xsl:variable>

        <xsl:variable name="queryOperator">
          <xsl:call-template name="getCustomProperty">
            <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
            <xsl:with-param name="propertyName" select="'QUERY_OPERATOR'"/>
            <xsl:with-param name="defaultValue" select="'like'"/>
          </xsl:call-template>
        </xsl:variable>

        <xsl:choose>
          <xsl:when test="$rangeQuery='true'">
            <xsl:call-template name="createRangeAttributes">
              <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
              <xsl:with-param name="display" select="$display"/>
              <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
              <xsl:with-param name="group" select="$group"/>
              <xsl:with-param name="resourceName" select="$resourceName"/>
            </xsl:call-template>    
          </xsl:when>
          <xsl:otherwise>
            <xsl:call-template name="createFormElement">
              <xsl:with-param name="attributeName" select="concat($findItemPrefix,@Name)"/>
              <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
              <xsl:with-param name="operator" select="$queryOperator"/>
              <xsl:with-param name="isFindElement">true</xsl:with-param>
              <xsl:with-param name="display" select="$display"/>
              <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
              <xsl:with-param name="group" select="$group"/>
              <xsl:with-param name="resourceName" select="$resourceName"/>
              <xsl:with-param name="formName" select="$formName"/>
              <xsl:with-param name="table" select="'td'"/>
            </xsl:call-template>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:if>
 
  </xsl:template>

  <xsl:template name="createRangeAttributes">
    <xsl:param name="entityAttribute"/>
    <xsl:param name="display"/>
    <xsl:param name="layoutStyle"/>
    <xsl:param name="group"/>
    <xsl:param name="resourceName"/>

    <!-- set variable that holds prompt name -->
    <xsl:variable name="prompt">
      <xsl:call-template name="getCustomProperty">
        <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
        <xsl:with-param name="propertyName" select="'PROMPT'"/>
        <xsl:with-param name="defaultValue" select="@Name"/>
      </xsl:call-template>
    </xsl:variable>
    <!-- create from attribute -->
    <!-- we first create a variable promptFrom and then pass it as
         template parameter. If we directly use the utils:getNlsKey
         construct within xsl:param we get error XSL-1008: Namespace prefix
         utils used but not declared -->
    <xsl:variable name="promptFrom"
       select="utils:getNlsKey('SEARCH_FROM',$prompt,concat('SEARCH_FROM_',@Name))"/>

    <xsl:call-template name="createFormElement">
      <xsl:with-param name="attributeName" select="concat($findItemPrefix,@Name,'From')"/>
      <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
      <xsl:with-param name="elementPrompt" select="$promptFrom"/>
      <xsl:with-param name="operator" select="'gt'"/>
      <xsl:with-param name="isFindElement">true</xsl:with-param>
      <xsl:with-param name="display" select="$display"/>
      <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
      <xsl:with-param name="group" select="$group"/>
      <xsl:with-param name="resourceName" select="$resourceName"/>
    </xsl:call-template>
    <!-- create to attribute -->
    <!-- we first create a variable promptTo and then pass it as
         template parameter. If we directly use the utils:getNlsKey
         construct within xsl:param we get error XSL-1008: Namespace prefix
         utils used but not declared -->
    <xsl:variable name="promptTo"
       select="utils:getNlsKey('SEARCH_TO',$prompt, concat('SEARCH_TO_',@Name))"/>

    <xsl:call-template name="createFormElement">
      <xsl:with-param name="attributeName" select="concat($findItemPrefix,@Name,'To')"/>
      <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
      <xsl:with-param name="elementPrompt" select="$promptTo"/>
      <xsl:with-param name="operator" select="'lt'"/>
      <xsl:with-param name="isFindElement">true</xsl:with-param>
      <xsl:with-param name="display" select="$display"/>
      <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
      <xsl:with-param name="group" select="$group"/>
      <xsl:with-param name="resourceName" select="$resourceName"/>
    </xsl:call-template>

  </xsl:template>

</xsl:stylesheet>
