<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : JSPLibrary.xsl

Notes       :

$revision_history$
21-jul-2004   Lucas Jellema (AMIS)
  1.18AMIS1.5 - support for ON_CLICK, ON_DBLCLICK, ON_FOCUS, ON_CHANGE
20-jul-2004   Lucas Jellema (AMIS)
  1.18AMIS1.4 - support for ON_BLUR and RESTRICT_CASE
20-jul-2004   Lucas Jellema (AMIS)
  1.18AMIS1.3 - support for radioMatrixSize
19-jul-2004   Lucas Jellema (AMIS)
  1.18AMIS1.2 - small support for hyperlink
19-jul-2004   Lucas Jellema (AMIS)
  1.18AMIS1.1 - modified template createFormElement:
                - changed call to template htmlText:
                  - add support PROMPT_STYLE_CLASS 
                  - add support NULL_VALUE_LABEL
                  - add support RADIO_STYLE
                  - add support TABLE_DISPLAY_TYPE
18-jul-2004   Lucas Jellema (AMIS)
  1.18AMIS1.0 - modified template setDisplayType 
                - add radioValues
              - modified template createFormElement:
                - add variable lookupRadioValues; changed call to template setDisplayType
                - changed call to template htmlText:
                  - add support for TABLE_PROPMT and FIND_PROMPT
                  - add support STYLE_CLASS and STYLE_ID
26-apr-2004   Steven Davelaar
  1.18        Prefix targetGroup with lov when we are generating lov page
26-apr-2004   Steven Davelaar
  1.17        targetGroup hidden field now hardcoded tpo curtrent group name, fix for
              bug 3592838
16-feb-2004   Peter Ebell
  1.16        Use custom property MANDATORY for required fields
14-nov-2003   Steven Davelaar
  1.15        Added templates checkMultipartAttributes and checkGroupMultipartAttributes
              Added logic to set display type to fileUpload, fileDownload or image
20-okt-2003   Steven Davelaar
  1.14        Pass isFindElement param to htmlText template
29-aug-2003   Steven Davelaar
  1.13        Removed unused valueBinding and lovAttribute templates, these where
              template with UIX code in it, copied over from UIXLibrary
21-aug-2003   Peter Ebell
  1.12        Replaced all occurences of static URL pattern "file://" by a call to
              utils:getURL, to allow for compatibility with Linux.
14-aug-2003   Aard-Jan van Kesteren
  1.11        
11-aug-2003   Steven Davelaar
  1.10        Removed code that checks for PERSISTS custom property.
              Instead, improved algorithm to determine updatability. 
              We now check whether attribute is lookup attribute of
              readOnly EO, which means it is non updatable as well.
              This fixes bug 3080053 UIX WITH LOV ON LOOKUP FIELD: WHEN SAVING 
              RECORD, GET JBO-27008 ERROR as well.
05-aug-2003   Aard-Jan van Kesteren
  1.9         - Dropped all templates with dataBoundAttribute
              - Dropped template textAttribute
              - Dropped all templates with boundAttribute
              
05-aug-2003   Aard-Jan van Kesteren
  1.8         Refactored targetGroupHiddenFields: No more javascript and use session to
              fill targetGroup hidden field
01-aug-2003   Aard-Jan van Kesteren
  1.7         - Added forcedAddToNls attribute to nlsTextAttribute
              - Added addParam1 attributes to the jspInclude template
29-jul-2003   Steven Davelaar
  1.6         Set maximumLength and size for datetimefield to 20
23-jul-2003   Aard-Jan van Kesteren
  1.5         - Solved Bug No. 3056114. Changed template setDisplayType. Even if updatable
                = false, then the displayType should be LOV in case of an lov.
22-jul-2003   Aard-Jan van Kesteren
  1.4         - Solved Bug No. 3037195. Make the isReadOnly parameter in the htmlText call also
                true if update is fall in the application structure file.
20-jun-2003   STEVEN DAVELAAR
  1.3         - Commented out code that conditionally adds javascript and hidden field
              for targetCondition, causes errors in table-form layout
              - custom property DISPLAY_WIDTH was ignored
              - custom property PROMPT not picked up for form layout
              - maximumLength for date fields was set to 0, now set to 11
              - size of datefield set to 11 instead of 10 (to support dd-mon-yyyy)
14-mrt-2003  Aard-Jan van Kesteren
  1.0         Initial creation (based on UIXLibrary.xsl)

*******************************************************************************
$add_to_revision_history
$
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:utils="http://www.oracle.com/XSL/Transform/java/oracle.jheadstart.tools.util.XSLTUtils"
  xmlns:string="http://www.oracle.com/XSL/Transform/java/java.lang.String"      
  exclude-result-prefixes="utils string"
>

  <xsl:import href="JSPInput.xsl"/>  
  
  <xsl:output method="xml" indent="yes" />

  <xsl:variable name="nls" select="Service/@nls"/>  

  <xsl:template name="createFormElement">
    <xsl:param name="attributeName" select="@Name"/>   
    <xsl:param name="entityAttribute"/>
    <xsl:param name="isFindElement">false</xsl:param>
    <xsl:param name="elementPrompt"/>
    <xsl:param name="operator"/>
    <xsl:param name="display"/>
    <xsl:param name="layoutStyle"/>
    <xsl:param name="group"/>
    <xsl:param name="resourceName"/>
    <xsl:param name="formName">noName (createFormElement)</xsl:param>
    <xsl:param name="table">tr</xsl:param>
    <xsl:param name="withIndex"/>
    <xsl:param name="elementName"><xsl:value-of select="$formName"/></xsl:param>

    <xsl:variable name="tableDataSet" select="concat($resourceName,'Set')"/>
    <xsl:variable name="voAttribute" select="@Name"/>

    
    <xsl:variable name="eoAttributeName" select="@EntityAttrName"/>
    <xsl:variable name="columnType" select="$entityAttribute/@ColumnType"/>
    <xsl:variable name="eoDisplayType" select="$entityAttribute/Properties/Property[@Name='DISPLAY_TYPE']/@Value"/>
    <xsl:variable name="voDisplayType" select="Properties/Property[@Name='DISPLAY_TYPE']/@Value"/>
    <!-- LJ use overall displayType, derived through all of TABLE_DISPLAY_TYPE, DISPLAY_TYPE, EO and VO -->
    <xsl:variable name="allDisplayType">
      <xsl:choose>
        <xsl:when test="$layoutStyle ='table'">
          <xsl:call-template name="getCustomProperty">
            <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
            <xsl:with-param name="propertyName" select="'TABLE_DISPLAY_TYPE'"/>
            <xsl:with-param name="alternativePropertyName" select="'DISPLAY_TYPE'"/>
            <xsl:with-param name="defaultValue" select="''"/>
          </xsl:call-template>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="getCustomProperty">
            <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
            <xsl:with-param name="propertyName" select="'DISPLAY_TYPE'"/>
            <xsl:with-param name="defaultValue" select="''"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:variable name="showHyperlink"
      select="$allDisplayType = 'textInputHyperlink'">
     </xsl:variable>

    <xsl:variable name="listValidator"
      select="$entityAttribute/ListValidationBean/AttrArray/Item">
     </xsl:variable>

    <xsl:variable name="entityUsage" select="@EntityUsage"/>
    <!--
       S. Davelaar: 10-08-2003 
       Find elements are always updatable.
       Lookup attributes part of readOnly EO usage are always non updatable
    -->
    <xsl:variable name="updateable">
      <xsl:choose>
        <xsl:when test="$isFindElement='true'">
          <xsl:value-of select="'true'"/>
        </xsl:when>
        <xsl:when test="/ViewObject/EntityUsage[@Name=$entityUsage]/@ReadOnly='true'">
          <xsl:value-of select="'false'"/>
        </xsl:when>
        <xsl:when test="@IsUpdateable!=''">
          <xsl:value-of select="@IsUpdateable"/>
        </xsl:when>
        <xsl:otherwise>true</xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!-- The check whether a Lookup is defined for
    the current attribute, depends on the Lookup displayType.
    If the displayType is lov, we match with the baseDisplayAttribute,
    otherwise we match with the baseValueAttribute -->

    <xsl:variable name="lookupLovValues"
      select="$group/Lookup[@displayType='lov' and @baseDisplayAttribute=$voAttribute]"/>

    <xsl:variable name="lookupRadioValues"
      select="$group/Lookup[@displayType='radio' and @baseDisplayAttribute=$voAttribute]"/><!-- LJ -->

    <xsl:variable name="lookupChoiceValues"
      select="$group/Lookup[not(@displayType='lov') and @baseValueAttribute=$voAttribute]"/>

    <xsl:variable name="domain">
      <xsl:call-template name="getCustomProperty">
        <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
        <xsl:with-param name="propertyName" select="'DOMAIN'"/>
        <xsl:with-param name="defaultValue" select="''"/>
      </xsl:call-template>
    </xsl:variable>

    <xsl:variable name="displayType">
      <xsl:call-template name="setDisplayType">
        <xsl:with-param name="lookupLovValues" select="$lookupLovValues"/>
        <xsl:with-param name="lookupRadioValues" select="$lookupRadioValues"/> <!-- LJ -->
        <xsl:with-param name="updateable" select="$updateable"/>
        <xsl:with-param name="voDisplayType" select="$voDisplayType"/>
        <xsl:with-param name="eoDisplayType" select="$eoDisplayType"/>
        <!-- LJ use overall displayType, derived through all of TABLE_DISPLAY_TYPE, DISPLAY_TYPE, EO and VO -->
        <xsl:with-param name="displayType" select="$allDisplayType"/>
        <xsl:with-param name="columnType" select="$columnType"/>
        <xsl:with-param name="listValidator" select="$listValidator"/>
        <xsl:with-param name="lookupChoiceValues" select="$lookupChoiceValues"/>
        <xsl:with-param name="domain" select="$domain"/>
        <xsl:with-param name="isFindElement" select="$isFindElement"/>
        <xsl:with-param name="display" select="$display"/>
      </xsl:call-template>
    </xsl:variable>

<!--    <xsl:message>Attribute: <xsl:value-of select="$attributeName"/>, display type = <xsl:value-of select="$displayType"/></xsl:message> -->

    <xsl:variable name="required">
      <xsl:choose>
        <xsl:when test="$layoutStyle  = 'find' or $layoutStyle = 'lov'">
          <xsl:value-of select="false"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="getCustomProperty">
            <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
            <xsl:with-param name="propertyName" select="'MANDATORY'"/>
            <xsl:with-param name="defaultValue" select="$entityAttribute/@IsNotNull"/>
          </xsl:call-template>        
        </xsl:otherwise>        
      </xsl:choose>
    </xsl:variable>

    <!-- Create the appropriate form element based on the display type  -->

    <xsl:variable name="customSize">
      <xsl:call-template name="getCustomProperty">
        <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
        <xsl:with-param name="propertyName" select="'DISPLAY_WIDTH'"/>
        <xsl:with-param name="defaultValue" select="$entityAttribute/@Precision"/>

      </xsl:call-template>
    </xsl:variable>


    <xsl:variable name="persistentAttribute">
      <xsl:call-template name="getCustomProperty">
        <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
        <xsl:with-param name="propertyName" select="'PERSISTENT_ATTRIBUTE'"/>
        <xsl:with-param name="defaultValue" select="$voAttribute"/>
      </xsl:call-template>
    </xsl:variable>  
 
        <xsl:call-template name="htmlText">
          <xsl:with-param name="name" select="$elementName"/>
          <xsl:with-param name="property" select="$voAttribute"/>
          <xsl:with-param name="table" select="$table"/>
          <xsl:with-param name="isFindElement" select="$isFindElement"/>
          <xsl:with-param name="withIndex" select="$withIndex"/>

          <xsl:with-param name="size">
            <xsl:choose>
              <xsl:when test="$displayType='choice'">1</xsl:when>
              <xsl:when test="$customSize!='' and $customSize!='0'">
                <xsl:value-of select="$customSize"/>
              </xsl:when>
              <xsl:when test="$displayType='dateField'">11</xsl:when>
              <xsl:when test="$displayType='datetimeField'">20</xsl:when>
              <xsl:when test="$displayType='fileUpload'">30</xsl:when>
              <!-- if display width not specified for image, we want
                   to display it on real size, so we don't set the width -->
              <xsl:when test="$displayType='image'"></xsl:when>
              <xsl:otherwise>20</xsl:otherwise>
            </xsl:choose>

          </xsl:with-param>
          <xsl:with-param name="required" select="$required"/>      
          <xsl:with-param name="group" select="$group"/>
          <xsl:with-param name="hintText">
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'HINT_TEXT'"/>
              <xsl:with-param name="defaultValue" select="''"/>
            </xsl:call-template>
          </xsl:with-param>
          <xsl:with-param name="displayType" select="$displayType"/>
          <xsl:with-param name="updateable" select="$updateable"/>
          <xsl:with-param name="isReadOnly">          
            <xsl:choose>        
              <xsl:when test="$layoutStyle != 'find' and $layoutStyle != 'lov'
                              and ($entityAttribute/@IsUpdateable='while_insert'
                              or  @IsUpdateable='while_insert'
                              or $group/@update = 'false')">true</xsl:when>
              <xsl:otherwise>false</xsl:otherwise>
            </xsl:choose>
          </xsl:with-param>        
          <xsl:with-param name="optionsName"     select="concat($lookupChoiceValues/@name ,'Bean')"/>    
          <xsl:with-param name="optionsProperty" select="$lookupChoiceValues/@lookupValueAttribute"/>    
          <xsl:with-param name="optionsLabelName" select="concat($lookupChoiceValues/@name ,'Bean')"/>    
          <xsl:with-param name="optionsLabelProperty" select="$lookupChoiceValues/@lookupDisplayAttribute"/>                 
          <xsl:with-param name="domain" select="$domain"/>
          <xsl:with-param name="maximumLength">
            <xsl:choose>
              <xsl:when test="$displayType='dateField'">20</xsl:when>
              <xsl:when test="$displayType='datetimeField'">20</xsl:when>
              <xsl:when test="$displayType='fileUpload'">100</xsl:when>
              <xsl:otherwise>
                <xsl:call-template name="maximumLengthAttribute">
                  <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:with-param>
          <xsl:with-param name="displayHeight">
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'DISPLAY_HEIGHT'"/>
              <xsl:with-param name="defaultValue" select="'1'"/>
            </xsl:call-template>
          </xsl:with-param>      
          <xsl:with-param name="formName" select="$formName"/>
          <xsl:with-param name="lookupLovValues" select="$lookupLovValues"/>
          <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
          <xsl:with-param name="showHyperlink" select="$showHyperlink"/>
          <!-- LJ -->
          <xsl:with-param name="styleClass" >
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'STYLE_CLASS'"/>
            </xsl:call-template>
          </xsl:with-param>      

          <xsl:with-param name="styleId" >
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'STYLE_ID'"/>
            </xsl:call-template>
          </xsl:with-param>
          <xsl:with-param name="promptStyleClass" >
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'PROMPT_STYLE_CLASS'"/>
            </xsl:call-template>
          </xsl:with-param>      
          <xsl:with-param name="nullValueLabel" >
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'NULL_VALUE_LABEL'"/>
            </xsl:call-template>
          </xsl:with-param>      
          <xsl:with-param name="radioStyle" >
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'RADIO_STYLE'"/>
            </xsl:call-template>
          </xsl:with-param>      
          <xsl:with-param name="radioMatrixSize" >
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'RADIO_MATRIX_SIZE'"/>
            </xsl:call-template>
          </xsl:with-param>      
          <xsl:with-param name="restrictCase" >
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'RESTRICT_CASE'"/>
            </xsl:call-template>
          </xsl:with-param>      
          <xsl:with-param name="onBlur" >
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'ON_BLUR'"/>
            </xsl:call-template>
          </xsl:with-param>      
          <xsl:with-param name="onFocus" >
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'ON_FOCUS'"/>
            </xsl:call-template>
          </xsl:with-param>      
          <xsl:with-param name="onChange" >
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'ON_CHANGE'"/>
            </xsl:call-template>
          </xsl:with-param>      
          <xsl:with-param name="onClick" >
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'ON_CLICK'"/>
            </xsl:call-template>
          </xsl:with-param>      
          <xsl:with-param name="onDblClick" >
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'ON_DBLCLICK'"/>
            </xsl:call-template>
          </xsl:with-param>      
          <!-- end LJ -->
          <xsl:with-param name="listValidator" select="$listValidator"/>

          <!-- LJ -->
          
          <!-- LJ when layoutstyle = find then if it has been specified we should use the property FIND_PROMPT, otherwise just prompt -->
          <!-- LJ when layoutstyle = table then if it has been specified we should use the property TABLE_PROMPT, otherwise just prompt -->
          <xsl:with-param name="prompt">
            <xsl:choose>                    
              <xsl:when test="$layoutStyle = 'find' ">
                <xsl:call-template name="getCustomProperty">
                  <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
                  <xsl:with-param name="propertyName" select="'FIND_PROMPT'"/>
                  <xsl:with-param name="alternativePropertyName" select="'PROMPT'"/>
                  <xsl:with-param name="defaultValue" select="@Name"/>
                </xsl:call-template>                              
              </xsl:when>
              <xsl:when test="$layoutStyle = 'table' ">
                <xsl:call-template name="getCustomProperty">
                  <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
                  <xsl:with-param name="propertyName" select="'TABLE_PROMPT'"/>
                  <xsl:with-param name="alternativePropertyName" select="'PROMPT'"/>
                  <xsl:with-param name="defaultValue" select="@Name"/>
                </xsl:call-template>                              
              </xsl:when>
              <xsl:otherwise>                
                <xsl:call-template name="getCustomProperty">
                  <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
                  <xsl:with-param name="propertyName" select="'PROMPT'"/>
                  <xsl:with-param name="defaultValue" select="@Name"/>
                </xsl:call-template>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:with-param>      
          <xsl:with-param name="persistentAttribute" select="$persistentAttribute"/>
        </xsl:call-template>


  </xsl:template> <!-- end template createFormElement -->

  <xsl:template name="setDisplayType">
    <xsl:param name="lookupLovValues"/>
    <xsl:param name="lookupRadioValues"/> <!-- LJ -->
    <xsl:param name="updateable"/>
    <xsl:param name="voDisplayType"/>
    <xsl:param name="eoDisplayType"/>
    <xsl:param name="displayType"/>
    <xsl:param name="columnType"/>
    <xsl:param name="listValidator"/>
    <xsl:param name="lookupChoiceValues"/>
    <xsl:param name="domain"/>
    <xsl:param name="isFindElement"/>
    <xsl:param name="display"/>

    <xsl:variable name="customDisplayType">
      <xsl:choose>
        <!-- LJ use overall displayType, derived through all of TABLE_DISPLAY_TYPE, DISPLAY_TYPE, EO and VO -->
        <xsl:when test="$displayType!=''">
          <xsl:value-of select="$displayType"/>
        </xsl:when>
        <xsl:when test="$voDisplayType!=''">
          <xsl:value-of select="$voDisplayType"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$eoDisplayType"/>
        </xsl:otherwise>
      </xsl:choose>  
    </xsl:variable>  

    <xsl:choose>

      <xsl:when test="$display = 'hidden'">hidden</xsl:when>

      <!-- set display type to lov when Lookup associated with
           this attribute that has displayType set to Lov -->
      <!-- LJ I do not like this override of VO Attribute level display type that might be quite valid
           especially when table display type is choice and display type is radio -->
<!--
      <xsl:when test="count($lookupLovValues)!=0">lov</xsl:when>
      <xsl:when test="count($lookupRadioValues)!=0">radio</xsl:when>
-->
      <xsl:when test="$updateable='false' and $isFindElement='false' 
                      and $customDisplayType!='image'
                      and $customDisplayType!='fileDownload'">
                      and $customDisplayType!='hyperlink'">
        <xsl:value-of select="'displayField'"/>
      </xsl:when>
      
      <!-- a checkbox cannot be used on find page, because the user cannot
           see not indicate the difference between selecting the unchecked
           value as query criterium versus not using the checkbox attribute 
           as query criterium at all. Thereforem we use choice instead
           of checkbox on find page -->
      <xsl:when test="$customDisplayType!=''">
        <xsl:choose>
          <xsl:when test="$customDisplayType='checkBox' and $isFindElement='true'">
            <xsl:value-of select="'choice'"/>
          </xsl:when>
          <xsl:when test="$customDisplayType='textInputHyperlink'">
            <xsl:value-of select="'textInput'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$customDisplayType"/>
          </xsl:otherwise>
        </xsl:choose>  
      </xsl:when>

      <!-- if display type not set, and underlying EO attribute column
           is a date, than set display type to dateField
           NOTE: dateField must be directly enclosed with the xsl:when
           tags, to prevent spaces being added to the value of displayType!!!
      -->
      <xsl:when test="$columnType='DATE'">dateField</xsl:when>

      <!-- if display type not set, and underlying EO attribute column
           is a BLOB, than set display type to uploadFile if vo attribute
           is updatavble. If not updatable, set to fileDownload
       -->
      <xsl:when test="$columnType='BLOB' and $updateable='false'">fileDownload</xsl:when>
      <xsl:when test="$columnType='BLOB' and $updateable='true'">fileUpload</xsl:when>

      <!-- default display type to textInput -->

      <!-- if no display type is set, default to choice if the attribute
      either has a listValidator, domain or Lookup with displayType<> lov
      -->

      <xsl:when test="count($listValidator)!=0">choice</xsl:when>
      <xsl:when test="count($lookupRadioValues)!=0">radio</xsl:when>
      <xsl:when test="count($lookupChoiceValues)!=0">choice</xsl:when>
      <xsl:when test="$domain!=''">choice</xsl:when>

      <!-- if display type not set, and underlying EO attribute column
           is a number, than set display type to numberField
      -->
<!-- numberField commented out for now for two reaosns: results in ugly
     javascript error box with escape character, and , worse, this error
     is also raised on empty UiOnly REQUIRED number field which is undesirable, 
     in particula in table layout

        <xsl:when test="$columnType='NUMBER'">numberField</xsl:when>
-->
        <!-- default display type to textInput -->
        <xsl:otherwise>textInput</xsl:otherwise>
      </xsl:choose>
  </xsl:template> <!-- end setDisplayType -->

  <xsl:template name="listValidatorOption">
     <xsl:param name="listValidator"/>
     <contents>
      <!-- add one dummy option to show empty row in poplist -->
      <option value="" text=""/>
      <xsl:for-each select="$listValidator">
        <option>
          <xsl:attribute name="value">
           <xsl:value-of select="@Value"/>
         </xsl:attribute>
          <xsl:attribute name="text">
            <xsl:value-of select="@Value"/>
          </xsl:attribute>
        </option>
      </xsl:for-each>
     </contents>
  </xsl:template>

  <xsl:template name="domainOption">
    <xsl:param name="domain"/>
    
     <contents>
      <!-- add one dummy option to show empty row in poplist -->
      <option value="" text=""/>
      <xsl:for-each select="$domainDef/DomainSet/Domain[@name=$domain]/AllowableValue">
        <option>
          <xsl:attribute name="value">
           <xsl:value-of select="@value"/>
         </xsl:attribute>
          <xsl:attribute name="text">
            <xsl:value-of select="@meaning"/>
          </xsl:attribute>
        </option>
      </xsl:for-each>
     </contents>
  </xsl:template>

  <!-- set property -->
  <xsl:template name="setProperty">
    <xsl:attribute name="{$attributeName}">
      <xsl:value-of select="$propertyValue"/>
    </xsl:attribute>
  </xsl:template>

  <xsl:template name="getCustomProperty">
    <xsl:param name="entityAttribute"/>
    <xsl:param name="propertyName"/>
    <xsl:param name="alternativePropertyName"/>
    <xsl:param name="defaultValue"/>

    <xsl:variable name="eoType" select="$entityAttribute/@Type"/> 
    <xsl:variable name="eoProperty" select="$entityAttribute/Properties/Property[@Name=$propertyName]/@Value"/> 
    <xsl:variable name="voProperty" select="Properties/Property[@Name=$propertyName]/@Value"/>

    <!-- Figure out the value of the display height, First check the VO attribute
         for the custom property, then check the EO attribute for
         the same property. If both properties donot exist/are null, then
         assign defaultValue
    -->
      <xsl:choose>
        <xsl:when test="$voProperty!=''">
          <xsl:value-of select="$voProperty"/>
        </xsl:when>
        <xsl:when test="$eoProperty!=''">
          <xsl:value-of select="$eoProperty"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:choose>
            <xsl:when test="$alternativePropertyName!=''">
                <xsl:call-template name="getCustomProperty">
                  <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
                  <xsl:with-param name="propertyName" select="$alternativePropertyName"/>
                  <xsl:with-param name="defaultValue" select="$defaultValue"/>
                </xsl:call-template>                              
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$defaultValue"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:otherwise>
      </xsl:choose>

  </xsl:template> <!-- end get custom property template -->

  <!-- Set custom property
   -->
  <xsl:template name="customProperty">
    <xsl:param name="entityAttribute"/>
    <xsl:param name="attributeName"/>
    <xsl:param name="propertyName"/>
    <xsl:param name="defaultValue"/>

    <xsl:variable name="propertyValue">
      <xsl:call-template name="getCustomProperty">
        <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
        <xsl:with-param name="propertyName" select="$propertyName"/>
        <xsl:with-param name="defaultValue" select="$defaultValue"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:attribute name="{$attributeName}">
       <xsl:value-of select="$propertyValue"/>
    </xsl:attribute>

  </xsl:template> <!-- end custom property template -->

  <!-- set attributes for type in support for LOVs -->
  <xsl:template name="lovTypeInSupport">
    <xsl:param name="entityAttribute"/>
    <xsl:param name="updateable"/>
    
      <!-- if the lov field ends up being 'updateable', this means we
           need to enable type in support, otherwise prevent access to the field.
      -->
      <xsl:choose>
        <xsl:when test="$updateable='false'">

          <xsl:attribute name="onFocus">this.blur();alert(getMessage('mustUseLov'));return false</xsl:attribute>

        </xsl:when>
        <xsl:otherwise>
          <xsl:call-template name="maximumLengthAttribute">
            <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>

  </xsl:template>



  <!-- set prompt attribute -->
  <xsl:template name="promptAttribute">
    <!-- prompt to use can be specified as parameter so
         we can specify from and to prompts for range search
         in find form -->
    <xsl:param name="prompt"/>
    <xsl:param name="entityAttribute"/>
    
    <xsl:attribute name="promptAndAccessKey">
      <!-- test whether prompt is null, somehow the default value
           does not work with getCustomProperty used within xsl:param
           element -->
      <xsl:choose>
        <xsl:when test="$prompt=''">
          <xsl:variable name="customPrompt">
            <!-- get prompt from custom property when not specified -->
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
              <xsl:with-param name="propertyName" select="'PROMPT'"/>
              <xsl:with-param name="defaultValue" select="@Name"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:value-of disable-output-escaping="yes" select="concat('&amp;amp;',$customPrompt)"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of disable-output-escaping="yes" select="concat('&amp;amp;',$prompt)"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:attribute>
  </xsl:template>


  <!-- set size attribute -->
  <xsl:template name="sizeAttribute">
    <xsl:param name="entityAttribute"/>

    <xsl:call-template name="customProperty">
      <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
      <xsl:with-param name="attributeName" select="'size'"/>
      <xsl:with-param name="propertyName" select="'DISPLAY_HEIGHT'"/>
      <xsl:with-param name="defaultValue" select="'5'"/>
    </xsl:call-template>
  </xsl:template>

  <!-- set columns attribute -->
  <xsl:template name="columnsAttribute">
    <xsl:param name="entityAttribute"/>

    <xsl:call-template name="customProperty">
      <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
      <xsl:with-param name="attributeName" select="'columns'"/>
      <xsl:with-param name="propertyName" select="'DISPLAY_WIDTH'"/>
      <xsl:with-param name="defaultValue" select="$entityAttribute/@Precision"/>
    </xsl:call-template>
  </xsl:template>

  <!-- set maximumLength attribute -->
  <xsl:template name="maximumLengthAttribute">
    <xsl:param name="entityAttribute"/>

    <xsl:call-template name="getCustomProperty">
      <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
      <xsl:with-param name="attributeName" select="'maximumLength'"/>
      <xsl:with-param name="propertyName" select="'MAXIMUM_LENGTH'"/>
      <xsl:with-param name="defaultValue" select="$entityAttribute/@Precision"/>
    </xsl:call-template>
  </xsl:template>


  <!-- Set value of readOnly binding
       This value depends on wehther the form element is within a table
       or not. Outside a table, we have to include the namespace and
       dataobject in the binding. Within a table, this is inherited from
       the table data set.
   -->

  <xsl:template name="getEoFileName">
    <xsl:param name="voDoc"/>
    <xsl:variable name="entityUsageName" select="@EntityUsage"/>
    <xsl:choose>
      <xsl:when test="$entityUsageName!=''">
        <xsl:variable name="entityUsage" select="$voDoc/ViewObject/EntityUsage[@Name=$entityUsageName]/@Entity"/>
        <xsl:variable name="entityUsagePath" select="translate($entityUsage,'.','/')"/>
        <xsl:value-of select="utils:getURL(concat($sourceDir,$entityUsagePath,'.xml'))"/>
      </xsl:when> 
      <xsl:otherwise>
        <xsl:value-of select="$domainfile"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="getDisplayTitle">
    <xsl:variable name="tabName">
      <xsl:choose>
        <xsl:when test="@tabName!=''">
          <xsl:value-of select="@tabName"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="@dataObject"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="displayTitle">
      <xsl:choose>
        <xsl:when test="@displayTitle!=''">
          <xsl:value-of select="@displayTitle"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$tabName"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>
    <xsl:value-of select="$displayTitle"/>
  </xsl:template>

  <xsl:template name="jspInclude">
    <xsl:param name="page"/>
    <xsl:param name="param1Name"/>
    <xsl:param name="param1Value"/>
    <xsl:param name="addParam1">true</xsl:param>
    <xsl:param name="param2Name"/>
    <xsl:param name="param2Value"/>
    <xsl:param name="addParam2">true</xsl:param>    
    <xsl:param name="param3Name"/>
    <xsl:param name="param3Value"/>    
    <xsl:param name="addParam3">true</xsl:param>    
    <xsl:param name="param4Name"/>
    <xsl:param name="param4Value"/>  
    <xsl:param name="addParam4">true</xsl:param>
    <xsl:param name="param5Name"/>
    <xsl:param name="param5Value"/>   
    <xsl:param name="addParam5">true</xsl:param>    
    <xsl:param name="param6Name"/>
    <xsl:param name="param6Value"/>         
    <xsl:param name="addParam6">true</xsl:param>    
    <xsl:param name="param7Name"/>
    <xsl:param name="param7Value"/>         
    <xsl:param name="addParam7">true</xsl:param>    
    <xsl:param name="param8Name"/>
    <xsl:param name="param8Value"/>         
    <xsl:param name="addParam8">true</xsl:param>    
    <xsl:param name="param9Name"/>
    <xsl:param name="param9Value"/>         
    <xsl:param name="addParam9">true</xsl:param>    

    <jsp___include>

      <xsl:attribute name="page">
        <xsl:value-of select="concat($jspIncludesVirtualDir, $page)"/>
     </xsl:attribute>

     <xsl:attribute name="flush">
       <xsl:value-of select="'true'"/>
     </xsl:attribute>

    <xsl:if test="$param1Name != '' and $addParam1 = 'true'">
      <jsp___param name="{$param1Name}" value="{$param1Value}"/>
    </xsl:if>
    <xsl:if test="$param2Name != '' and $addParam2 = 'true'">
      <jsp___param name="{$param2Name}" value="{$param2Value}"/>
    </xsl:if>    
    <xsl:if test="$param3Name != '' and $addParam3 = 'true'">
      <jsp___param name="{$param3Name}" value="{$param3Value}"/>
    </xsl:if>
    <xsl:if test="$param4Name != '' and $addParam4 = 'true'">
      <jsp___param name="{$param4Name}" value="{$param4Value}"/>
    </xsl:if>    
    <xsl:if test="$param5Name != '' and $addParam5 = 'true'">
      <jsp___param name="{$param5Name}" value="{$param5Value}"/>
    </xsl:if>        
    <xsl:if test="$param6Name != '' and $addParam6 = 'true'">
      <jsp___param name="{$param6Name}" value="{$param6Value}"/>
    </xsl:if>            
    <xsl:if test="$param7Name != '' and $addParam7 = 'true'">
      <jsp___param name="{$param7Name}" value="{$param7Value}"/>
    </xsl:if>            
    <xsl:if test="$param8Name != '' and $addParam8 = 'true'">
      <jsp___param name="{$param8Name}" value="{$param8Value}"/>
    </xsl:if>            
    <xsl:if test="$param9Name != '' and $addParam9 = 'true'">
      <jsp___param name="{$param9Name}" value="{$param9Value}"/>
    </xsl:if>            
   </jsp___include>

  </xsl:template>

  <xsl:template name="targetGroupHiddenFields">

    <!-- fix for bug 3592838 -->
    <input type="hidden" name="targetGroup">
       <xsl:attribute name="value">
         <xsl:if test="$layoutMode='lov'">
           <xsl:value-of select="'Lov'"/>
         </xsl:if>
         <xsl:value-of select="@name"/>
       </xsl:attribute>
    </input>
    

  </xsl:template>

  <xsl:template name="nlsTextAttribute">
    <xsl:param name="attributeName"/>
    <xsl:param name="key"/>
    <xsl:param name="value" select="$key"/>
    <xsl:param name="addToNlsBundle" select="'false'"/>
    <xsl:param name="outputAsAttributeValue" select="'false'"/>
    <xsl:param name="forceAddToNlsBundle" select="'false'"/>

      <xsl:choose>
        <xsl:when test="$nls='true'">

         <!-- add entry to bundle, we use the key as value  -->
         <xsl:if test="$addToNlsBundle='true' or $forceAddToNlsBundle='true'">
            <!-- add key value pair in XSLTUtils, so we can generate
                 resource bundle from it -->
            <xsl:variable name="dummy">
            <!--
              <xsl:value-of select="utils:addNlsText(string:toUpperCase($key),$value)"/>
            -->
              <xsl:value-of select="utils:addNlsText($key,$value)"/>            
            </xsl:variable>
         </xsl:if>

        <xsl:choose>
          <xsl:when test="$outputAsAttributeValue = 'false'">
            <bean___message key="{$key}"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$key"/>
          </xsl:otherwise>
        </xsl:choose>
       
      </xsl:when>
      <xsl:otherwise>

          <xsl:value-of select="$value"/>

      </xsl:otherwise>
     </xsl:choose> 
  </xsl:template>


  <xsl:template name="checkMultipartAttributes">
     <!-- first check for multi part aiitrbiutes of current group, then
          check for multipart attrbutes in child groups displayed on the
          same page -->
      <xsl:variable name="voFile" select="utils:getURL(concat($bc4jDir,@viewObject,'.xml'))"/>
      <xsl:call-template name="checkGroupMultipartAttributes">
        <xsl:with-param name="voFile"  select="$voFile"/>
      </xsl:call-template>

    <!-- loop over same page child groups -->
    <xsl:for-each select="Group[@samePage='true']">
      <xsl:variable name="voFile" select="utils:getURL(concat($bc4jDir,@viewObject,'.xml'))"/>
      <xsl:call-template name="checkGroupMultipartAttributes">
        <xsl:with-param name="voFile"  select="$voFile"/>
      </xsl:call-template>
    </xsl:for-each>
  
  </xsl:template>

  <xsl:template name="checkGroupMultipartAttributes">
    <xsl:param name="voFile"/>

      <xsl:variable name="voDoc" select="document($voFile)"/>
      <xsl:for-each select="$voDoc/ViewObject/ViewAttribute[not(@IsUpdateable='false')]">

        <xsl:variable name="eoFile">
          <xsl:call-template name="getEoFileName">
            <xsl:with-param name="voDoc" select="$voDoc"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="entityUsage" select="@EntityUsage"/>
        <xsl:variable name="eoAttributeName" select="@EntityAttrName"/>
        <xsl:variable name="eoDoc" select="document($eoFile)"/>
        <xsl:variable name="entityAttributeNode"  select="$eoDoc/Entity/Attribute[$entityUsage!='' and @Name=$eoAttributeName]|current()[$entityUsage='']"/>

        <xsl:variable name="display">
          <xsl:call-template name="getCustomProperty">
            <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
            <xsl:with-param name="propertyName" select="'DISPLAY'"/>
            <xsl:with-param name="defaultValue" select="'true'"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="displayType">
              <xsl:call-template name="getCustomProperty">
                <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
                <xsl:with-param name="propertyName" select="'DISPLAY_TYPE'"/>
                <xsl:with-param name="defaultValue" select="''"/>
              </xsl:call-template>
        </xsl:variable>

        <xsl:if test="$display='true' and ($displayType='fileUpload' or $entityAttributeNode/@ColumnType='BLOB')">
           <xsl:value-of select="@Name"/>
        </xsl:if>

      </xsl:for-each>
  
  </xsl:template>
  
</xsl:stylesheet>
