 <!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : JSPLovLib.xsl

Notes       :

$revision_history$
19-dec-2003   Jan Kettenis
  1.14        Renamed parameters for lovSearchResults due to usage of readOnlyBean and to reflect that more descriptor items can be shown.
20-nov-2003   Sandra Muller
  1.13        Prefix stylesheet location with requestContextPath to support submodules
21-aug-2003   Peter Ebell
  1.12        Replaced all occurences of static URL pattern "file://" by a call to
              utils:getURL, to allow for compatibility with Linux.
14-aug-2003   Aard-Jan van Kesteren
  1.11        - Moved js includes to routerForm.jspinclude
              - Replaced all taglibs with tablibs.jspinclude
07-aug-2003   Aard-Jan van Kesteren
  1.10        Dropped lovKey
07-aug-2003   Aard-Jan van Kesteren
  1.9         Added session taglib
05-aug-2003   Aard-Jan van Kesteren
  1.8         Use the title of a love specified in the application structure file
01-aug-2003   Aard-Jan van Kesteren
  1.7
01-aug-2003   Aard-Jan van Kesteren
  1.6         - Include routerForm.jsp
29-jul-2003   Aard-Jan van Kesteren
  1.5         - Use form.js instead jspForm.js
25-jul-2003   Aard-Jan van Kesteren
  1.4         - Solved bug 3067383. Make use of the title attribute of a lookup
14-mrt-2003   Aard-Jan van Kesteren
  1.0         Initial creation

*******************************************************************************
$add_to_revision_history
$
-->

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:utils="http://www.oracle.com/XSL/Transform/java/oracle.jheadstart.tools.util.XSLTUtils"
  xmlns:string="http://www.oracle.com/XSL/Transform/java/java.lang.String"
  exclude-result-prefixes="utils string"
>

  <xsl:output method="xml" indent="yes" />

  <xsl:template name="lovLayout">

    <xsl:variable name="vofile" select="utils:getURL(concat($bc4jDir,@viewObject,'.xml'))"/>
    <xsl:variable name="voDoc" select="document($vofile)"/>

<xsl:value-of select="concat('jspO@ include file=``', $jspIncludesVirtualDir, 'taglibs.jsp`` jspC')"/>
<xsl:text>&#xa;</xsl:text>
<xsl:text>&#xa;</xsl:text>

<html>
<head>
  <link rel="stylesheet" type="text/css">
    <xsl:attribute name="href">
      <xsl:value-of select="concat('jspO= application.getAttribute(``requestContextPath``)+``/', /Service/@jspStylesheetUrl, '``jspC')"/>
    </xsl:attribute>
  </link>
</head>
<body>

  <xsl:call-template name="jspInclude">
    <xsl:with-param name="page" select="'routerForm.jsp'"/>
  </xsl:call-template>

   <xsl:variable name="columns">
     <xsl:choose>
       <xsl:when test="@columns != ''">
         <xsl:value-of select="@columns"/>
       </xsl:when>
       <xsl:otherwise>
         <xsl:value-of select="'1'"/>
       </xsl:otherwise>
    </xsl:choose>
   </xsl:variable>

    <xsl:variable name="displayTitle">
      <xsl:call-template name="getDisplayTitle"/>
    </xsl:variable>

    <xsl:variable name="lovTitle">
      <xsl:choose>
        <xsl:when test="@title != ''">
          <xsl:value-of select="@title"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="concat('Look up ', $displayTitle)"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <xsl:call-template name="findFormLayout">
      <xsl:with-param name="voDoc" select="$voDoc"/>
      <xsl:with-param name="layoutStyle" select="'lov'"/>
      <xsl:with-param name="columns" select="$columns"/>
      <xsl:with-param name="name" select="concat('Lov', @name, 'FindBean')"/>
      <!-- Always width 100%. Gives the nices result -->
      <xsl:with-param name="formWidth" select="'100%'"/>
      <xsl:with-param name="lovTitle" select="$lovTitle"/>
    </xsl:call-template>

    <logic___present name="{concat('Lov', @name, 'Set')}">
      <bean___define id="{concat('Lov', @name, 'Set')}" name="{concat('Lov', @name, 'Set')}" type="oracle.jheadstart.model.DataObjectSet" scope="session"/>

      <table width="100%">
        <xsl:call-template name="jspInclude">
          <xsl:with-param name="page" select="'tableScrollButtons.jsp'"/>
          <xsl:with-param name="param1Name" select="'formName'"/>
          <xsl:with-param name="param1Value" select="concat('document.Lov', @name, 'FindBean')"/>
          <xsl:with-param name="param2Name" select="'setName'"/>
          <xsl:with-param name="param2Value" select="concat('Lov', @name, 'Set')"/>
        </xsl:call-template>
        <tr>
          <td>
            <table class="tableForm" width="100%">
              <logic___iterate id="dataBean" name="{concat('Lov', @name, 'DataBean')}" indexId="index">
                  <!--
                    I use a jspInclude instead of just generating the right code here,
                    because the to be generated is relatively very complex; a combination
                    of javaScript, jsp tags and jsp code. In such a case, I think it's
                    good practice to put this stuff in an jsp include.
                  -->
                    <xsl:call-template name="jspInclude">
                      <xsl:with-param name="page" select="'lovSearchResult.jsp'"/>
                      <xsl:with-param name="param1Name" select="'beanName'"/>
                      <xsl:with-param name="param1Value" select="concat('Lov', @name, 'DataBean')"/>
                      <xsl:with-param name="param2Name" select="'descriptorProperties'"/>
                      <xsl:with-param name="param2Value" select="@lookupDisplayAttribute"/>
                      <xsl:with-param name="param3Name" select="'keyProperty'"/>
                      <xsl:with-param name="param3Value" select="@lookupValueAttribute"/>
                      <xsl:with-param name="param4Name" select="'index'"/>
                      <xsl:with-param name="param4Value" select="'jspO= index jspC'"/>
                    </xsl:call-template>
              </logic___iterate>
            </table>
          </td>
        </tr>
      </table>
    </logic___present>

</body>
</html>
</xsl:template>

</xsl:stylesheet>
