<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : JSPPage.xsl

Notes       :

$revision_history$
17-nov-2003   Steven Davelaar
  1.27        Prefix stylesheet location with requestContextPath to
              support submodules
14-nov-2003   Steven Davelaar
  1.26        Set form encType to multipart when appropriate
26-oct-2003   Aard-Jan van Kesteren
  1.25        Rewrote Boolean.TRUE and Boolean.FALSE occurences
21-aug-2003   Peter Ebell
  1.24        Replaced all occurences of static URL pattern "file://" by a call to
              utils:getURL, to allow for compatibility with Linux.
19-aug-2003   Aard-Jan van Kesteren
  1.23        Solved bug 3102735. Changed addParam3 of the buttonsForm jspInclude.
14-aug-2003   Aard-Jan van Kesteren
  1.22        Added global variables datePattern and datetimePatters
14-aug-2003   Aard-Jan van Kesteren
  1.21        - Moved js includes to routerForm.jspinclude
              - Replaced all taglibs with taglibs.jspinclude
14-aug-2003   Aard-Jan van Kesteren
  1.20        Solved bug 3096338: Also who formButton save if the form has a child group
              with samePage = 'true' which can be updated, deleted or inserted. 
14-aug-2003   Aard-Jan van Kesteren
  1.19        Added bean:define isInserting
12-aug-2003   Aard-Jan van Kesteren
  1.18        - Merged the two possible jsp include buttonsForm calls (isInserting and not isInserting)
                into one. 
              - Made the save button optional in the jsp include buttonsForm
              - Only generate a particular heading if that heading will actually be displayed.
                E.g. only generate the insert heading if @insert = 'true' 
07-aug-2003   Aard-Jan van Kesteren
  1.17        Generate nls key SAVE_BUTTON_LABEL_(group name) instead of just SAVE_BUTTON_LABEL
07-aug-2003   Aard-Jan van Kesteren
  1.16        Only call getNlsKey for the delete and new button, if these buttons are
              actually displayed.
06-aug-2003   Steven Davelaar
  1.15        
05-aug-2003   Aard-Jan van Kesteren
  1.14        Removed import of JSPTabBar.xsl
05-aug-2003   Aard-Jan van Kesteren
  1.13        Dropped template dataBoundAttribute
05-aug-2003   Aard-Jan van Kesteren
  1.12        Don't show form buttons if isViewing
05-aug-2003   Aard-Jan van Kesteren
  1.11        Added taglib session
04-aug-2003   Steven Davelaar
  1.10        Details on same page now also displayed when inserting master
              , now possible because we generate a createDefaultDataObjectSet action
04-aug-2003   Aard-Jan van Kesteren
  1.9         - Removed template groupTitles
              - added view_title
01-aug-2003   Aard-Jan van Kesteren
  1.8         - Refactored attributes in jspInclude heading2.jsp
              - Refactored attributes in jspInclude buttonsForm.jsp
              - Refactored attributes in jspInclude heading1.jsp
01-aug-2003   Aard-Jan van Kesteren
  1.7         Also add the attribute formName to the jsp include formButtons if inserting
29-jul-2003   Aard-Jan van Kesteren
  1.6         - removed js call setCheckForChangedItems()
              - dropped hidden input event and added hidden inputs targetCondition
                and targetConditionValue
              - Include routerForm
27-jul-2003   Aard-Jan van Kesteren
  1.5         - Worked on bug 3054427: For child groups always show the global header
22-jul-2003   Aard-Jan van Kesteren
  1.4         - Solved bug 2311557: Only generate lov jsp code once
14-mrt-2003   Aard-Jan van Kesteren
  1.0         Initial creation (based on UIXPage.xsl)

*******************************************************************************
$add_to_revision_history
$
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:utils="http://www.oracle.com/XSL/Transform/java/oracle.jheadstart.tools.util.XSLTUtils"
  xmlns:string="http://www.oracle.com/XSL/Transform/java/java.lang.String"      
  exclude-result-prefixes="utils string"
>
  <xsl:import href="JSPLibrary.xsl"/>
  <xsl:import href="JSPTableLib.xsl"/>
  <xsl:import href="JSPFormLib.xsl"/>
  <xsl:import href="JSPSelectFormLib.xsl"/>
  <xsl:import href="JSPLovLib.xsl"/>  

  <xsl:output method="xml" indent="yes" />
  <xsl:param name="groupName"></xsl:param>
  <xsl:param name="layoutMode"></xsl:param>

  <xsl:variable name="serviceName" select="Service/@name"/>

  <xsl:variable name="sourceDir" select="Service/@sourceDir"/>

  <xsl:variable name="bc4jDir" select="concat($sourceDir,translate(Service/@modelImplementationBase,'.','/'),'/')"/>

  <xsl:variable name="modelBase" select="concat(Service/@modelBase,'.')"/>

  <xsl:variable name="jspVirtualDir" select="Service/@pageVirtualDir"/>
  <xsl:variable name="jspIncludesVirtualDir" select="Service/@jspIncludesVirtualDir"/>

  <xsl:variable name="nls" select="Service/@nls"/>
  <xsl:variable name="nlsBundle" select="Service/@nlsBundle"/>
  <xsl:variable name="showHintText" select="Service/@showHintText"/>


  <xsl:variable name="templateRegistrationFile">
    <xsl:choose>
      <xsl:when test="Service/@templateLibraryFile">
        <xsl:value-of select="concat($jspVirtualDir,Service/@templateLibraryFile)"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="concat($jspVirtualDir,'jheadstartLibrary.uit')"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  
  <xsl:variable name="domainfile" select="utils:getURL(Service/@domainFilePath)"/>
  <xsl:variable name="domainDef" select="document($domainfile)"/>

  <xsl:variable name="pageName" select="$groupName"/>

  <xsl:variable name="tabBarName" select="concat(Service/@name,'TabBar')"/>
  <xsl:variable name="tabBarTemplate" select="concat($jspVirtualDir,$tabBarName,'.uit')"/>

  <xsl:variable name="datePattern" select="Service/@datePattern"/>
  <xsl:variable name="datetimePattern" select="Service/@datetimePattern"/>  

  <xsl:variable name="globalHeaderName">
    <xsl:choose>
<!--  <xsl:when test="$layoutMode='select'">
        <!- no global headers in select page ->
      </xsl:when> -->
      <xsl:when test="Service/Group[@name=$groupName]/Group[@name!='' and not(@samePage='true')]">
        <!-- group is parent group, get global header file from group itself
             but only if layout style is form. If it is table, the user must
             first select a row before he can navuigate to the child group,
             so the global header should be hidden. -->
        <xsl:if test="$layoutMode='form'">
         <xsl:value-of select="$groupName"/><xsl:text>GlobalHeader</xsl:text>
        </xsl:if>
      </xsl:when>
      <xsl:when test="Service/Group/Group[@name=$groupName]/@name!=''">
        <!-- group is child group, get global header file from parent group -->
        <xsl:value-of select="Service/Group[Group/@name=$groupName]/@name"/><xsl:text>GlobalHeader</xsl:text>
      </xsl:when>
    </xsl:choose>
  </xsl:variable>
  <xsl:variable name="globalHeaderTemplate" select="concat($jspVirtualDir,$globalHeaderName,'.uit')"/>

  <xsl:variable name="formName">
<!--   <xsl:value-of select="concat(Service/Group[@name=$groupName]/@dataObject,'Form')"/> -->
    <xsl:value-of select="concat($groupName,'Form')"/>
  </xsl:variable>

  <xsl:variable name="findItemPrefix">
      <xsl:value-of select="concat('Find',Service/Group[@name=$groupName]/@dataObject)"/>
  </xsl:variable>

  <!-- end page-level variables -->


<xsl:template match="Service">
<!--  <xsl:message>In Service Match template: <xsl:value-of select="$groupName"/>, <xsl:value-of select="$layoutMode"/></xsl:message> -->

  <xsl:choose>
    <xsl:when test="$layoutMode != 'lov'">
      <xsl:for-each select="Group[@name=$groupName]">
        <xsl:call-template name="masterGroup"/>
      </xsl:for-each>
      <xsl:for-each select="Group/Group[@name=$groupName]">
        <xsl:call-template name="childGroup"/>
      </xsl:for-each>
    </xsl:when>
    <xsl:otherwise>
      <xsl:for-each select="(//Lookup[@name=$groupName and @displayType='lov'])[position()=1]">
        <xsl:call-template name="lovLayout"/>
      </xsl:for-each>
    </xsl:otherwise>
  </xsl:choose>
</xsl:template>

<xsl:template name="masterGroup">
  <xsl:variable name="tabPosition">
    <xsl:for-each select="/Service/Group">
      <xsl:if test="@name=$groupName">
        <xsl:value-of select="position()-1"/>
      </xsl:if>
    </xsl:for-each>
  </xsl:variable>
  <xsl:variable name="globalHeaderPosition" select="'0'"/>
<!--  <xsl:message>Found Master group <xsl:value-of select="@name"/>, tabs: (<xsl:value-of select="$tabPosition"/>,<xsl:value-of select="$globalHeaderPosition"/>)</xsl:message> -->

<!-- hier zou niets uit mogen komen -->
  <xsl:variable name="masterGroup" select="/Service/Group[Group/@name=$groupName]"/>
  <xsl:variable name="masterGroupName" select="$masterGroup/@name"/>

  <xsl:call-template name="pagecontent">
    <xsl:with-param name="tabPosition" select="$tabPosition"/>
    <xsl:with-param name="globalHeaderPosition" select="$globalHeaderPosition"/>
    <xsl:with-param name="masterGroup" select="$masterGroup"/>
    <xsl:with-param name="masterGroupName" select="$masterGroupName"/>
  </xsl:call-template>
  
</xsl:template>

<xsl:template name="childGroup">
  <xsl:variable name="masterGroup" select="/Service/Group[Group/@name=$groupName]"/>
  <xsl:variable name="masterGroupName" select="$masterGroup/@name"/>
  <xsl:variable name="tabPosition">
    <xsl:for-each select="/Service/Group">
      <xsl:if test="@name=$masterGroupName">
        <xsl:value-of select="position()-1"/>
      </xsl:if>
    </xsl:for-each>
  </xsl:variable>
  <xsl:variable name="globalHeaderPosition">
    <xsl:for-each select="$masterGroup/Group">
      <xsl:if test="@name=$groupName">
        <xsl:value-of select="position()"/>
      </xsl:if>
    </xsl:for-each>
  </xsl:variable>
<!--  <xsl:message>Found Child group <xsl:value-of select="@name"/> of Master group <xsl:value-of select="$masterGroupName"/>, tabs: (<xsl:value-of select="$tabPosition"/>,<xsl:value-of select="$globalHeaderPosition"/>)</xsl:message> -->
  <xsl:call-template name="pagecontent">
    <xsl:with-param name="tabPosition" select="$tabPosition"/>
    <xsl:with-param name="globalHeaderPosition" select="$globalHeaderPosition"/>
    <xsl:with-param name="masterGroup" select="$masterGroup"/>
    <xsl:with-param name="masterGroupName" select="$masterGroupName"/>
  </xsl:call-template>
</xsl:template>


<xsl:template name="pagecontent">
  <xsl:param name="tabPosition"/>
  <xsl:param name="globalHeaderPosition"/>
  <xsl:param name="masterGroup"/>
  <xsl:param name="masterGroupName"/>

  <xsl:variable name="templateLocalName">
    <xsl:call-template name="getTemplateLocalName"/>
  </xsl:variable>  
<!-- <xsl:message> Using template: <xsl:value-of select="$templateLocalName"/></xsl:message>
     <xsl:message> from library file: <xsl:value-of select="$templateRegistrationFile"/></xsl:message> -->    

    <xsl:variable name="templateName" select="concat('templates:',$templateLocalName)"/>

<xsl:value-of select="concat('jspO@ include file=``', $jspIncludesVirtualDir, 'taglibs.jsp`` jspC')"/>
<xsl:text>&#xa;</xsl:text>
<xsl:text>&#xa;</xsl:text>

<html>
<head>
  <link rel="stylesheet" type="text/css">  
    <xsl:attribute name="href">
      <xsl:value-of select="concat('jspO= application.getAttribute(``requestContextPath``)+``/', /Service/@jspStylesheetUrl, '``jspC')"/>
    </xsl:attribute>
  </link>  

</head>
<body>

<xsl:call-template name="jspInclude">
  <xsl:with-param name="page" select="'routerForm.jsp'"/>
</xsl:call-template>

<xsl:call-template name="jspInclude">
  <xsl:with-param name="page" select="'header.jsp'"/>
</xsl:call-template>

<jsp___include>

  <xsl:attribute name="page">
    <xsl:value-of select="concat(concat(/Service/@jspVirtualDir, /Service/@name), 'TabBar.jsp')"/>
  </xsl:attribute>

  <xsl:attribute name="flush">
    <xsl:value-of select="'true'"/>
  </xsl:attribute>

  <jsp___param name="current">
    <xsl:attribute name="value">
      <xsl:choose>
        <xsl:when test="$masterGroupName != ''">
          <xsl:value-of select="$masterGroupName"/>        
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="@name"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:attribute>
  </jsp___param>
</jsp___include>


  <xsl:variable name="groupName" select="@name"/>

  <xsl:if test="$globalHeaderName!=''">
    <xsl:choose>
      <!-- Aard-Jan: For child groups, we can always show the globalheader -->
      <xsl:when test="$layoutMode='form' and /Service/Group[@name=$groupName]">

        <logic___notEqual name="{concat(@name, 'Bean')}" value="true" property="{concat(@name, 'IsInserting')}">
          <jsp___include>
            <xsl:attribute name="page">
              <xsl:value-of select="concat(concat(/Service/@jspVirtualDir, $globalHeaderName), '.jsp')"/>
            </xsl:attribute>
            <xsl:attribute name="flush">
              <xsl:value-of select="'true'"/>
            </xsl:attribute>
            <jsp___param name="current" value="{@name}"/>
          </jsp___include>
        </logic___notEqual>
      </xsl:when>
      <xsl:otherwise>
          <jsp___include>
            <xsl:attribute name="page">
              <xsl:value-of select="concat(concat(/Service/@jspVirtualDir, $globalHeaderName), '.jsp')"/>
            </xsl:attribute>
            <xsl:attribute name="flush">
              <xsl:value-of select="'true'"/>
            </xsl:attribute>
            <jsp___param name="current" value="{@name}"/>
          </jsp___include>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:if>

        <xsl:call-template name="layout">
          <xsl:with-param name="masterGroup" select="$masterGroup"/>
          <xsl:with-param name="groupLayoutStyle" select="@layoutStyle"/>
          <xsl:with-param name="layoutStyle" select="$layoutMode"/>
        </xsl:call-template>

  <xsl:call-template name="jspInclude">
    <xsl:with-param name="page" select="'footer.jsp'"/>
  </xsl:call-template>
     
</body>
</html>
</xsl:template>

<xsl:template name="layout">
  <xsl:param name="masterGroup"/>
  <xsl:param name="groupLayoutStyle"/>
  <xsl:param name="layoutStyle"/>
  
<!-- <xsl:message>In layout template, mastergroup=<xsl:value-of select="$masterGroup/@dataObject"/>, group=<xsl:value-of select="@name"/>, layoutStyle=<xsl:value-of select="$layoutStyle"/></xsl:message> -->
<!-- <xsl:message>In layout template</xsl:message> -->
  <xsl:variable name="masterDataObject" select="$masterGroup/@name"/>
<!--
  <xsl:variable name="masterTabName" select="$masterGroup/@tabName"/>
-->  

  <xsl:variable name="masterTabName">
    <xsl:choose>
      <xsl:when test="$masterGroup/@displayTitle!=''">
        <xsl:value-of select="$masterGroup/@displayTitle"/>
      </xsl:when>
      <xsl:when test="$masterGroup/@tabName!=''">
        <xsl:value-of select="$masterGroup/@tabName"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$masterGroup/@dataObject"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:variable name="displayTitle">
    <xsl:call-template name="getDisplayTitle"/>
  </xsl:variable>

  <xsl:variable name="masterContextAttribute" select="$masterGroup/@descriptorAttribute"/>
  <xsl:variable name="vofile" select="utils:getURL(concat($bc4jDir,@viewObject,'.xml'))"/>
<!--  <xsl:message>vofile=<xsl:value-of select="$vofile"/></xsl:message> -->
  <xsl:variable name="voDoc" select="document($vofile)"/>
  <xsl:variable name="columns">
    <xsl:choose>
      <xsl:when test="not(number(@columns))">
        <xsl:value-of select="'1'"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="@columns"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:choose>
    <xsl:when test="$layoutStyle='find'">
<!-- <xsl:message>Calling findFormLayout</xsl:message> -->
      <xsl:call-template name="findFormLayout">
        <xsl:with-param name="columns" select="$columns"/>
        <xsl:with-param name="voDoc" select="$voDoc"/>
        <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
      </xsl:call-template>
    </xsl:when>
    <xsl:when test="$layoutStyle='select'">
<!-- <xsl:message>Calling selectLayout</xsl:message> -->
      <xsl:call-template name="selectLayout">
        <xsl:with-param name="columns" select="$columns"/>
        <xsl:with-param name="voDoc" select="$voDoc"/>
        <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
      </xsl:call-template>
    </xsl:when>
    <xsl:when test="$layoutStyle='form'">

      <xsl:call-template name="jspInclude">
        <xsl:with-param name="page" select="'jhsInfo.jsp'"/>
      </xsl:call-template>


    <xsl:variable  name="multipartAttrs">
      <xsl:call-template name="checkMultipartAttributes"/>
    </xsl:variable>

      <html___form>       
        <xsl:attribute name="name">
          <xsl:value-of select="concat(@name, 'Bean')"/>
        </xsl:attribute>
        <xsl:attribute name="action">
          <xsl:value-of select="concat('/Start', /Service/@name)"/>
        </xsl:attribute>
        <xsl:if test="$multipartAttrs != ''">
          <xsl:attribute name="enctype">
            <xsl:value-of select="'multipart/form-data'"/>
          </xsl:attribute>
        </xsl:if>

        <xsl:attribute name="type">
          <xsl:text>oracle.jheadstart.view.struts.JhsDynaActionForm</xsl:text>
        </xsl:attribute>
        <xsl:attribute name="scope">
          <xsl:text>session</xsl:text>
        </xsl:attribute>

        <bean___define id="{concat(@name, 'IsInserting')}" name="{concat(@name, 'Bean')}" property="{concat(@name, 'IsInserting')}" type="Boolean"/>  
        <input type="hidden" name="HasErrors"/>
        <input type="hidden" name="targetCondition"/>
        <input type="hidden" name="targetConditionValue"/>        
        <xsl:call-template name="targetGroupHiddenFields"/>        
        <xsl:call-template name="jspInclude">
          <xsl:with-param name="page" select="'timestamp.jsp'"/>
        </xsl:call-template>

   <xsl:if test="@insert='true'">
     <logic___equal name="{concat(@name, 'Bean')}" value="true" property="{concat(@name, 'IsInserting')}">
        <xsl:call-template name="jspInclude">
          <xsl:with-param name="page" select="'heading1.jsp'"/>
          <xsl:with-param name="param1Name" select="'key'"/>
          <xsl:with-param name="param1Value">
             <xsl:value-of select="utils:getNlsKey('INSERT_TITLE',$displayTitle,concat('INSERT_TITLE_',@name))"/>
          </xsl:with-param>        
        </xsl:call-template>
      </logic___equal>
    </xsl:if>

    <xsl:if test="@update='true'">
      <logic___equal name="{concat(@name, 'Bean')}" value="true" property="{concat(@name, 'IsUpdating')}">
        <xsl:call-template name="jspInclude">
          <xsl:with-param name="page" select="'heading1.jsp'"/>
          <xsl:with-param name="param1Name" select="'key'"/>
          <xsl:with-param name="param1Value">
            <xsl:value-of select="utils:getNlsKey('EDIT_TITLE',$displayTitle,concat('EDIT_TITLE_',@name))"/>
          </xsl:with-param>        
        </xsl:call-template>
      </logic___equal>
    </xsl:if>

    <xsl:if test="@update='false'">  
      <logic___equal name="{concat(@name, 'Bean')}" value="true" property="{concat(@name, 'IsViewing')}">
        <xsl:call-template name="jspInclude">
          <xsl:with-param name="page" select="'heading1.jsp'"/>
          <xsl:with-param name="param1Name" select="'key'"/>
          <xsl:with-param name="param1Value">
            <xsl:value-of select="utils:getNlsKey('VIEW_TITLE',$displayTitle,concat('VIEW_TITLE_',@name))"/>
          </xsl:with-param>        
        </xsl:call-template>
      </logic___equal>
    </xsl:if>
     
<!-- <xsl:message>Calling formLayout</xsl:message> -->
      <xsl:call-template name="formLayout">
        <xsl:with-param name="columns" select="$columns"/>
        <xsl:with-param name="voDoc" select="$voDoc"/>
        <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
      </xsl:call-template>

      <!-- check whether there is a child group with
           samePage = true -->
      <xsl:if test="Group[@samePage='true']">
        <input type="hidden" name="value"/>
        <input type="hidden" name="source"/>
      </xsl:if>
      <xsl:for-each select="Group[@samePage='true']">

           <xsl:variable name="displayTitle">
             <xsl:call-template name="getDisplayTitle"/>
           </xsl:variable>

           <xsl:call-template name="jspInclude">
             <xsl:with-param name="page" select="'heading2.jsp'"/>
             <xsl:with-param name="param1Name" select="'key'"/>
             <xsl:with-param name="param1Value">
               <xsl:value-of select="utils:getNlsKey('TABLE_TITLE',$displayTitle,concat('TABLE_TITLE_',@name))"/>  
             </xsl:with-param>        
             <xsl:with-param name="param2Name" select="'withNls'"/>
             <xsl:with-param name="param2Value" select="$nls"/>              
           </xsl:call-template>

            <xsl:call-template name="layout">
              <xsl:with-param name="masterGroup" select="$masterGroup"/>
              <xsl:with-param name="groupLayoutStyle" select="@layoutStyle"/>
              <xsl:with-param name="layoutStyle" select="'table'"/>
            </xsl:call-template>

      </xsl:for-each>

      <xsl:variable name="newKey">
        <xsl:choose>
          <xsl:when test="@insert">
            <xsl:value-of select="utils:getNlsKey('NEW_BUTTON_LABEL', $displayTitle,concat('NEW_BUTTON_LABEL_',@name))"/>
          </xsl:when>
          <xsl:otherwise>
            no new button
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

      <xsl:variable name="deleteKey">
        <xsl:choose>
          <xsl:when test="@delete">
            <xsl:value-of select="utils:getNlsKey('DELETE_BUTTON_LABEL', $displayTitle,concat('DELETE_BUTTON_LABEL_',@name))"/>
          </xsl:when>
          <xsl:otherwise>
            no delete button
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>      

      <xsl:variable name="saveUpdateKey">
        <xsl:choose>
          <xsl:when test="@update">
            <xsl:value-of select="utils:getNlsKey('SAVE_BUTTON_LABEL', $displayTitle,concat('SAVE_BUTTON_LABEL_',@name))"/>
          </xsl:when>
          <xsl:otherwise>
            no save update button
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

      <xsl:variable name="saveInsertKey">
        <xsl:choose>
          <xsl:when test="@insert">
            <xsl:value-of select="utils:getNlsKey('SAVE_BUTTON_LABEL', $displayTitle,concat('SAVE_BUTTON_LABEL_',@name))"/>
          </xsl:when>
          <xsl:otherwise>
            no save insert button
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

     <xsl:call-template name="jspInclude">
       <xsl:with-param name="page" select="'buttonsForm.jsp'"/>
       <xsl:with-param name="param1Name" select="'isInserting'"/>
       <xsl:with-param name="param1Value" select="concat('jspO= ', @name, 'IsInserting jspC')"/>
       <xsl:with-param name="param2Name" select="'newKey'"/>
       <xsl:with-param name="param2Value" select="$newKey"/>
       <xsl:with-param name="addParam2" select="@insert"/>
       <xsl:with-param name="param3Name" select="'saveUpdateKey'"/>
       <xsl:with-param name="param3Value" select="$saveUpdateKey"/>       
       <xsl:with-param name="addParam3" select="(@update = 'true') or (Group[@samePage='true' and not(@insert='false' and @update='false' and @delete='false')])"/>
       <xsl:with-param name="param4Name" select="'deleteKey'"/>
       <xsl:with-param name="param4Value" select="$deleteKey"/>
       <xsl:with-param name="addParam4" select="@delete"/>
       <xsl:with-param name="param5Name" select="'saveInsertKey'"/>
       <xsl:with-param name="param5Value" select="$saveInsertKey"/>    
       <xsl:with-param name="addParam5" select="@insert"/>
       <xsl:with-param name="param6Name" select="'formName'"/>
       <xsl:with-param name="param6Value" select="concat(@name, 'Bean')"/>
     </xsl:call-template>     
      
      </html___form>
    </xsl:when>
    <xsl:when test="$layoutStyle='table'">
<!-- <xsl:message>Calling tableLayout</xsl:message> -->
       <xsl:call-template name="tableLayout">
         <xsl:with-param name="voDoc" select="$voDoc"/>
         <xsl:with-param name="masterDataObject" select="$masterDataObject"/>
         <xsl:with-param name="masterTabName" select="$masterTabName"/>
         <xsl:with-param name="masterContextAttribute" select="$masterContextAttribute"/>
         <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
         <xsl:with-param name="groupLayoutStyle" select="$groupLayoutStyle"/>
       </xsl:call-template>
    </xsl:when>
  </xsl:choose>
</xsl:template>

<xsl:template name="groupUsages">
  <xsl:variable name="insertAllowed">
    <xsl:choose>
      <xsl:when test="@insert='false'">
        <xsl:value-of select="'false'"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="'true'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <xsl:variable name="updateAllowed">
    <xsl:choose>
      <xsl:when test="@update='false'">
        <xsl:value-of select="'false'"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="'true'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <xsl:variable name="deleteAllowed">
    <xsl:choose>
      <xsl:when test="@delete='false'">
        <xsl:value-of select="'false'"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="'true'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:variable name="modifyChildAllowed">
    <xsl:choose>
      <xsl:when test="Group[@samePage='true' and not(@insert='false' and @update='false' and @delete='false')]">
        <xsl:value-of select="'true'"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="'false'"/>
      </xsl:otherwise>
    </xsl:choose> 
  </xsl:variable>  
      
<!--  <xsl:message>Testing for modifiable childs in group <xsl:value-of select="@name"/>: <xsl:value-of select="$modifyChildAllowed"/></xsl:message> -->

  <xsl:variable name="breadCrumbs">
    <xsl:choose>
      <xsl:when test="not(@breadCrumbs='false') and $layoutMode!='find'">
        <xsl:value-of select="'true'"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="'false'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:attribute name="insertAllowed">
      <xsl:value-of select="$insertAllowed"/>
  </xsl:attribute>
  <xsl:attribute name="updateAllowed">
      <xsl:value-of select="$updateAllowed"/>
  </xsl:attribute>
  <xsl:attribute name="deleteAllowed">
      <xsl:value-of select="$deleteAllowed"/>
  </xsl:attribute>
  <!-- set modifiable childs property -->
  <xsl:attribute name="modifyChildAllowed">
      <xsl:value-of select="$modifyChildAllowed"/>
  </xsl:attribute>

  <!-- set breadcrumbs property -->
  <xsl:attribute name="hasBreadCrumbs">
      <xsl:value-of select="$breadCrumbs"/>
  </xsl:attribute>
</xsl:template>

  <!-- template to set a data bound attribute
        This template cannot reside in any UIX Library stylesheet
        because of namespace repetition problem
        It must reside in top-level stylesheet -->
  <xsl:template name="boundAttribute">
    <xsl:param name="attributeName"/>
    <xsl:param name="attributeValue"/>
    
    <xsl:attribute name="{$attributeName}">
      <xsl:value-of select="$attributeValue"/>
    </xsl:attribute>
  </xsl:template>

  <!-- Here is determined with UIX template will be used for this page -->
  <xsl:template name="getTemplateLocalName">
    <xsl:choose>
      <!-- Form template -->
      <xsl:when test="$layoutMode='form'">
        <xsl:choose>
          <xsl:when test="@formTemplateLocalName">
            <xsl:value-of select="@formTemplateLocalName"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'formPage'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>  

      <!-- Table template -->
      <xsl:when test="$layoutMode='table'">
        <xsl:choose>
          <xsl:when test="@tableTemplateLocalName">
            <xsl:value-of select="@tableTemplateLocalName"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'tablePage'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>  

      <!-- Select template -->
      <xsl:when test="$layoutMode='select'">
        <xsl:choose>
          <xsl:when test="@selectTemplateLocalName">
            <xsl:value-of select="@selectTemplateLocalName"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'selectPage'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>  

      <!-- Find template -->
      <xsl:when test="$layoutMode='find'">
        <xsl:choose>
          <xsl:when test="@findTemplateLocalName">
            <xsl:value-of select="@findTemplateLocalName"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'findPage'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>  
    </xsl:choose>  
  </xsl:template>

</xsl:stylesheet>
