<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : JSPTabBar.xsl

Notes       :

$revision_history$
31-aug-2003   Aard-Jan van Kesteren
  1.9         - Only initialize "user" once
              - Generate the actual name of a tab in hasAccess( instead of an hardcoded @name
25-aug-2003   Peter Ebell
  1.8         Hide unauthorized groups if hideUnauthorizedGroupTabs property is set
14-aug-2003   Aard-Jan van Kesteren
  1.7         
07-aug-2003   Steven Davelaar
  1.6         Convert nls keys to uppercase
05-aug-2003   Aard-Jan van Kesteren
  1.5         Added bean taglib
05-aug-2003   Aard-Jan van Kesteren
  1.4         Add nls functionality
29-jul-2003   Aard-Jan van Kesteren
  1.3         - Use the go2 out of form.js
23-jul-2003   Aard-Jan van Kesteren
  1.2         - Solved bug 3062844. Rename js function goto to jhsGoto
14-mrt-2003   Aard-Jan van Kesteren
  1.0         Initial creation (based on UIXTabBar.xsl)

*******************************************************************************
$add_to_revision_history
$
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:utils="http://www.oracle.com/XSL/Transform/java/oracle.jheadstart.tools.util.XSLTUtils"
  xmlns:string="http://www.oracle.com/XSL/Transform/java/java.lang.String"      
  exclude-result-prefixes="utils string"
>
  <xsl:import href="JSPLibrary.xsl"/>
  
  <xsl:output method="xml" indent="yes" />

  <xsl:variable name="hideUnauthorizedGroupTabs" select="Service/@hideUnauthorizedGroupTabs"/>

<xsl:template match="/">

  <xsl:variable name="tabBarName" select="concat(/Service/@name,'TabBar')"/>

<xsl:text disable-output-escaping="yes">
<![CDATA[<%@ taglib uri="/WEB-INF/struts-bean.tld" prefix="bean" %> 
<%@ page import="oracle.jheadstart.model.JhsUser" %>
<%@ page import="oracle.jheadstart.JhsConstants" %>

<bean:parameter id="current" name="current"/>]]>
</xsl:text>
<xsl:if test="$hideUnauthorizedGroupTabs='true'">
<xsl:text disable-output-escaping="yes">
<![CDATA[
<% JhsUser user = (JhsUser)session.getAttribute(JhsConstants.JHS_USER); %>
]]>  
</xsl:text>
</xsl:if>


    <table class="tabBar" cellpadding="3" cellspacing="0" width="100%">     
      <tr>
        <td class="empty" width="100%"/>
    <!-- define the content of the page -->
        <xsl:apply-templates/>

      </tr>
    </table>

</xsl:template>

<xsl:template match="Service/Group">


   <xsl:variable name="displayLabel">
        <xsl:choose>
          <xsl:when test="@tabName!=''">
            <xsl:value-of select="@tabName"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="@dataObject"/>
          </xsl:otherwise>
        </xsl:choose>
   </xsl:variable>
  <!-- Hide groups that the user is not authorized for -->
  <xsl:if test="$hideUnauthorizedGroupTabs='true'">
    <xsl:value-of select="concat('jspO if (user != null &amp;&amp; user.hasAccess(``', @name, '``, session.getId())) { jspC')"/>
    <xsl:text>&#xa;</xsl:text>
    <xsl:text>    </xsl:text>  
  </xsl:if>

    <td nowrap="nowrap" class="{concat('jspO= (current.equals(``', @name, '``)  ? ``tabCurrent`` : `` ``) jspC')}">
      <xsl:text>&amp;nbsp;</xsl:text> 
    <a>
   
      <xsl:attribute name="href">
        <xsl:text>javascript:go2(['targetGroup','targetCondition'],['</xsl:text>
        <xsl:value-of select="@name"/>
        <xsl:text>','']);</xsl:text>
      </xsl:attribute>

        <xsl:call-template name="nlsTextAttribute">
          <xsl:with-param name="key">
            <xsl:value-of select="concat(string:toUpperCase(@name),'_LEVEL_1_TAB')"/>
          </xsl:with-param>
          <xsl:with-param name="value">
            <xsl:value-of select="$displayLabel"/>
          </xsl:with-param>
          <xsl:with-param name="addToNlsBundle">true</xsl:with-param>
        </xsl:call-template>
        
    </a>
    <xsl:text>&amp;nbsp;</xsl:text>
    
    </td>

  <xsl:if test="$hideUnauthorizedGroupTabs='true'">
    <xsl:text>&#xa;</xsl:text>  
    <xsl:text>  </xsl:text>
    <xsl:value-of select="'jspO } jspC'"/>
    <xsl:text>&#xa;</xsl:text>
    <xsl:text>  </xsl:text>
  </xsl:if>

  </xsl:template>

</xsl:stylesheet>
