<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : Providers.xsl

Notes       :

Open Issues :

$revision_history$
17-apr-2003   STEVEN DAVELAAR
  1.8         cleaned up revision history
16-apr-2003   STEVEN DAVELAAR
  1.6         Set bc4j configuration instead of us/pw/host/port etc.
              Use jheadstart ApplicationModuleProvider
17-mrt-2003   STEVEN DAVELAAR
  1.5         .
02-aug-2002   Peter Ebell
  1.4         Temporarily changed back the changes made in 1.3 due to unexpected issues at
              runtime (insert/update problems)
17-jul-2002   Peter Ebell
  1.3         - Changed class to oracle.jheadstart.persistence.b4jc.ApplicationModuleProvider.
              - Added property "managestate".
10-jun-2002   Peter Ebell
  1.2         Changed "scope" to "request" instead of "session"
14-mei-2002   Peter Ebell
  1.1         Pre-prod release
14-mei-2002   Peter Ebell
  1.0         Pre-prod release

17-mar-2003   Steven Davelaar
  1.5         
02-aug-2002   Peter Ebell
  1.4         Temporarily changed back the changes made in 1.3 due to unexpected issues at
              runtime (insert/update problems)
17-jul-2002   Peter Ebell
  1.3         - Changed class to oracle.jheadstart.model.b4jc.ApplicationModuleProvider.
              - Added property "managestate".
10-jun-2002   Peter Ebell
  1.2         Changed "scope" to "request" instead of "session"
14-may-2002   Peter Ebell
  1.1         Pre-prod release
22-feb-2002   Peter Ebell
  1.0         Initial creation
*******************************************************************************
$add_to_revision_history
$
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
  <xsl:output method="xml" indent="yes" />

  <xsl:template match="/">
    <xsl:variable name="serviceName" select="Service/@name"/>

    <xsl:variable name="modelImplementationBase" select="Service/@modelImplementationBase"/>
    <xsl:variable name="appModule"  select="concat($modelImplementationBase,'.',Service/@applicationModule)"/>
    <xsl:variable name="configuration"  select="concat(Service/@applicationModule,'Local')"/>
    <xsl:variable name="connection" select="Service/@connectString"/>

    <xsl:variable name="DBconnection" select="substring-after($connection,'jdbc:oracle:thin:')"/>
    <xsl:variable name="userNamePassWord" select="substring-before($DBconnection,'@')"/>
    <xsl:variable name="databaseHost" select="substring-after($DBconnection,'@')"/>

    <xsl:variable name="userName" select="substring-before($userNamePassWord,'/')"/>
    <xsl:variable name="passWord" select="substring-after($userNamePassWord,'/')"/>

    <xsl:variable name="host"     select="substring-before($databaseHost,':')"/>
    <xsl:variable name="database" select="substring-after($databaseHost,':')"/>
    <xsl:variable name="port"      select="substring-before($database,':')"/>
    <xsl:variable name="sid"      select="substring-after($database,':')"/>

    <!-- These we do not generate but you get warnings when you don't supply them -->
    <xsl:variable name="encryptiontype" select="''"/>
    <xsl:variable name="drivertype" select="''"/>


    <cle-providers>
      <provider name="{concat($serviceName,'Provider')}" class="oracle.jheadstart.model.bc4j.ApplicationModuleProvider">
        <property name="persistencebase" value="{$modelImplementationBase}"/>
        <property name="modulename" value="{$appModule}"/>
        <property name="configuration" value="{$configuration}"/>

<!--
        <property name="connectionstring" value="{$connection}"/>

        <property name="user" value="{$userName}"/>
        <property name="password" value="{$passWord}"/>
        <property name="host" value="{$host}"/>
        <property name="sid" value="{$sid}"/>
        <property name="port" value="{$port}"/>

        <property name="encryptiontype" value=""/>
        <property name="drivertype" value=""/>
        <property name="failover" value=""/>
-->
        <property name="scope" value="request"/>
        <property name="managestate" value="true"/>        
      </provider>
    </cle-providers>
  
  </xsl:template>

</xsl:stylesheet>
