<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : Service.xsl

Notes       :

Open Issues :
- all checkbox attributes should be removed from infoTable after
  displaying the page. This requires change in editPage process  

$revision_history$
19-nov-2003   Steven Davelaar
  2.13        Generate SelectMasterRow process when detail has form or select-form
              layout
25-aug-2003   Peter Ebell
  2.12        Removed globalinfo for groupAccessDataObject
29-jul-2003   Steven Davelaar
  2.11        Fixed bug in dataObjectNotFound transition in
              BrowseDataObjectSet
25-jul-2003   Steven Davelaar
  2.10        Fixed bug with form layout and no rows in table
22-may-2003   STEVEN DAVELAAR
  2.9         Added support for detailDisclosure, tableRanges and sortable for detail
              groups in same page
01-mei-2003   AARDJ
  2.8         Checked in after upload from D:\jhsdtdev\design\xslt\Service.xsl
              - Renamed UixVirtualDir to pageVirtualDir
17-apr-2003   STEVEN DAVELAAR
  2.7         cleaned up revision history
16-apr-2003   STEVEN DAVELAAR
  2.5         Include HandletableEvent when detailDisclosure set
17-mrt-2003   STEVEN DAVELAAR
  2.4         .
19-dec-2002   Peter Ebell
  2.3         .
23-okt-2002   Sigrid Gylseth
  2.2         Bugfix 2460233: Changed parameter value for resourceNotFoundProcess in 
              call to template browseDataSourceSet for select-form pages.
10-jun-2002   Peter Ebell
  2.1         - Added support for uixVirtualDir property
              - Generate service name property correctly.
              - Added CheckPageTimeStamp as initial process in the service router.
14-mei-2002   Peter Ebell
  2.0         Added functionality to merge a customized group from the previous version 
              of the Service XML file into the output of this stylesheet when 'generateServiceGroup'
              is 'false'
29-jan-2002   STEVEN DAVELAAR
  1.19        Fixed typo extention should be extension
28-jan-2002   Peter Ebell
  1.18        Changed .xml extensions to .uix for uix documents
28-jan-2002   Peter Ebell
  1.17        Added parameter passing to calls to insertDataSourceThroughMaster template
23-jan-2002   Peter Ebell
  1.16        Changed pageName variable to be equal to the group name
22-jan-2002   Peter Ebell
  1.15        Removed obsolete variable pageTitle
17-jan-2002   STEVEN DAVELAAR
  1.14        Fixed bug: if current group is master group and has child group with same
              page is true, navigation to lookup processes for child group did not take 
              place
14-jan-2002   STEVEN DAVELAAR
  1.13        Changed references to clex.trial classes to clex
14-jan-2002   Peter Ebell
  1.12        Added explicit parameter passing between templates for compatibility with 
              JDeveloper 9i
26-nov-2001   STEVEN DAVELAAR
  1.11        Fixed bug in retrieving initial process with lookups in child group
              in same page
06-nov-2001   STEVEN DAVELAAR
  1.10        Do not include lookup processes when Lookup displayType=lov
              Removed userClass seedinfo
31-okt-2001   STEVEN DAVELAAR
  1.9         Retrieve child data source sets after inserting master and its
              details before going to the edit page
25-sep-2001   STEVEN DAVELAAR
  1.8         Added support for find page, removed generation of group transitions,
              not needed because default behavior is ok.
              Added support for master-detail in same window
              Changed arguments and transitions HandleTableEvent
04-sep-2001   Lucas Jellema
  1.7         Continued reorg, new libraries GetDataProcessLib and SaveDataProcessLib
24-aug-2001   STEVEN DAVELAAR
  1.6         Set keepConsistent to false in GetChildDataSourceSet
              Add userClass seedinfo
              Added support for buttons in master table to navigate to child group
              Regorganized stylsheet, created separate libraries for router processes,
              page processes and data source processes
25-jun-2001   STEVEN DAVELAAR
  1.5         tablerangeSize now ignored when useTableRange is false im detail
              table
24-jun-2001   STEVEN DAVELAAR
  1.4         Changed derivation of page title for form layout
31-mei-2001   STEVEN DAVELAAR
  1.3         Datasource element renamed to Group, datasource name now specified in
              datasource attribute of Group
20-apr-2001   STEVEN DAVELAAR
  1.2         
20-apr-2001   STEVEN DAVELAAR
  1.1         
20-apr-2001   STEVEN DAVELAAR
  1.0         

17-mar-2003   Steven Davelaar
  2.4         
19-dec-2002   Peter Ebell
  2.3         - No longer generate debugMarlinPage seedinfo
              - Use Forward process instead of CreateUIXPage in Error Page Group
23-oct-2002   Sigrid Gylseth
  2.2         Bugfix 2460233: Changed parameter value for dataObjectNotFoundProcess in 
              call to template browseDataObjectSet for select-form pages.
10-jun-2002   Peter Ebell
  2.1         - Added support for uixVirtualDir property
              - Generate service name property correctly.
              - Added CheckPageTimeStamp as initial process in the service router.
14-may-2002   Peter Ebell
  2.0         Added functionality to merge a customized group from the previous version 
              of the Service XML file into the output of this stylesheet when 'generateServiceGroup'
              is 'false'
28-mrt-2002   Peter Ebell
  1.1         Rewritten for JHeadstart 9i. Removed obsolete revision history.
18-apr-2001   Steven Davelaar
  1.0         Initial creation

*******************************************************************************
$add_to_revision_history
$
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  exclude-result-prefixes="cnt">
  <xsl:import href="PageProcessLib.xsl"/>
  <xsl:import href="ServiceRouterLib.xsl"/>
  <xsl:import href="SaveDataProcessLib.xsl"/>
  <xsl:import href="GetDataProcessLib.xsl"/>
  <xsl:output method="xml" indent="yes" />

    <!-- This parameter holds a Nodeset which is the previous version of this 
         Service XML file. We use this to merge a customized group in the new
         version when 'generateServiceGroup' is 'false'
    -->
    <xsl:param name="oldServiceNode"/>

    <xsl:variable name="groupClassName">
      <xsl:value-of select="Service/@groupClass"/>
    </xsl:variable>

    <xsl:variable name="uixExtension">
      <xsl:value-of select="'.uix'"/>
    </xsl:variable>

    <xsl:variable name="uixVirtualDir">
      <xsl:value-of select="Service/@pageVirtualDir"/>
    </xsl:variable>

    <xsl:variable name="groupIncludeFile">
      <xsl:value-of select="Service/@groupIncludeFile"/>
    </xsl:variable>

    <xsl:variable name="defaultErrorPage">
      <xsl:value-of select="'DisplayErrorPage.uix'"/>
    </xsl:variable>

    <xsl:variable name="modelBase">
      <xsl:value-of select="concat(Service/@modelBase,'.')"/>
    </xsl:variable>
    

  <!-- shell template to create service -->
  <xsl:template match="/">


    <service name="{Service/@name}" class="oracle.cle.process.Service"
      initial="CheckPageTimeStamp">

      <xsl:text>&#xa;</xsl:text>
      <xsl:text>&#xa;</xsl:text>
      
      <!-- Add the process to check for the page timestamp -->
      <xsl:call-template name="checkPageTimeStamp"/>

      <!-- serviceRouter template resides in ServiceRouterLib.xsl -->
      <xsl:call-template name="serviceRouter"/>
      
      <xsl:apply-templates/>

      <xsl:call-template name="errorPageGroup"/>

    </service>
  </xsl:template>


  <!-- shell template to create all (child) process groups -->
  <xsl:template match="Service/Group">
    <xsl:choose>
      <xsl:when test="@generateServiceGroup='false' and boolean($oldServiceNode)">
        <xsl:call-template name="useOldProcessGroup"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="processGroup"/>
      </xsl:otherwise>
    </xsl:choose>

    <!-- loop through child groups that do not have samePage = true-->
     <xsl:for-each select="Group[@samePage!='true' or not(@samePage)]">
       <xsl:choose>
         <xsl:when test="@generateServiceGroup='false' and boolean($oldServiceNode)">
           <xsl:call-template name="useOldProcessGroup"/>
         </xsl:when>
         <xsl:otherwise>
           <xsl:call-template name="processGroup"/>
         </xsl:otherwise>
       </xsl:choose>  
     </xsl:for-each>

  </xsl:template>

  <!-- template to create a process group based on the old Service XML file -->
  <xsl:template name="useOldProcessGroup">
    <xsl:variable name="processGroup" select="@name"/>
    <xsl:variable name="printGroup" select="$oldServiceNode//processgroup[@name=$processGroup]"/>

<xsl:comment>
###############################################################

  Process Group: <xsl:value-of select='@name'/>

  Description:   <xsl:value-of select='@description'/>

  ** THIS PROCESS GROUP HAS NOT BEEN REGENERATED **
  
###############################################################
</xsl:comment>

    <xsl:copy-of select="$printGroup"/>
  </xsl:template>  

  <!-- template to create a process group -->
  <xsl:template name="processGroup">
    <xsl:text>&#xa;</xsl:text>
    <xsl:text>&#xa;</xsl:text>

<xsl:comment>
###############################################################

  Process Group: <xsl:value-of select='@name'/>

  Description:   <xsl:value-of select='@description'/>
  
###############################################################
</xsl:comment>

    <xsl:variable name="pageName" select="@name"/>
    <xsl:variable name="groupName" select="@name"/>
    <xsl:variable name="dataObjectKey" select="@name"/>
    <xsl:variable name="dataObjectSetKey" select="concat(@name,'Set')"/>

    <xsl:variable name="className">
      <xsl:choose>
        <xsl:when test="$groupClassName!=''">
          <xsl:value-of select="$groupClassName"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'oracle.cle.process.DisplayGroup'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!-- dataObject groups -->

    <processgroup>
      <xsl:attribute name="name">
        <xsl:value-of select="$groupName"/>
      </xsl:attribute>
      <xsl:attribute name="class">
        <xsl:value-of select="$className"/>
      </xsl:attribute>

      <xsl:choose>
        <xsl:when test="@groupIncludeFile">
          <xsl:attribute name="included">
            <xsl:value-of select="@groupIncludeFile"/>
          </xsl:attribute>
        </xsl:when>
        <xsl:when test="$groupIncludeFile">
          <xsl:attribute name="included">
            <xsl:value-of select="$groupIncludeFile"/>
          </xsl:attribute>
        </xsl:when>
      </xsl:choose>
      <xsl:attribute name="initial">
        <xsl:value-of select="concat($groupName,'Router')"/>
      </xsl:attribute>
      <xsl:attribute name="end">true</xsl:attribute>


      <!-- base start process for a group is the process to start
           after lookup processes have been executed.
           The base process depends on whether the group has
           a find page -->
      <xsl:variable name="baseStartProcess">
        <!-- use Find process if group has find page -->
        <xsl:choose>
          <xsl:when test="@findPage='true'">
            <xsl:value-of select="concat('Find',$pageName,'Page')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="concat('Get',$dataObjectSetKey)"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

      <!-- See of there are any lookUp elements defined for this group that are
           not displayed as lov.
           If so create lookup processes for them, and set the initial process
           of the group router to the first lookup process.
           The last lookup process wil then transition to the getDataSOurceSet
           process of the group dataObject itself -->
      <xsl:variable name="initialProcess">
        <xsl:choose>
          <xsl:when test="count(Lookup[not(@displayType='lov')])=0">
            <!-- check whether there is a child group with
                 samePage = true. If so check whether this child group
                 has a lookup process not displayed as lov and use this
                 as initial process -->
            <xsl:choose>
              <xsl:when test="count(Group[@samePage='true']/Lookup[not(@displayType='lov')])=0">
                <xsl:value-of select="$baseStartProcess"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="concat('Get',Group[@samePage='true']/Lookup[not(@displayType='lov')]/@name)"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="concat('Get',Lookup[not(@displayType='lov')]/@name)"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
<!-- <xsl:message>Base process: <xsl:value-of select="$baseStartProcess"/> </xsl:message> -->
<!-- <xsl:message>Initial process: <xsl:value-of select="$initialProcess"/> </xsl:message> -->

      <!-- add generic process router process
           within this template, layout-specific templates
           are invoked. All router templates reside in ServiceRouterLib.xsl! -->
      <xsl:call-template name="simpleProcessRouter">
        <xsl:with-param name="router" select="concat($groupName,'Router')"/>
        <xsl:with-param name="pageName" select="$pageName"/>
        <xsl:with-param name="groupName" select="$groupName"/>
        <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
        <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
        <xsl:with-param name="initialProcess" select="$initialProcess"/>
      </xsl:call-template>

      <!-- add lookup processes -->
      <xsl:call-template name="lookupProcesses">
        <xsl:with-param name="baseStartProcess" select="$baseStartProcess"/>
      </xsl:call-template>

      <!-- The processes within the group depends on the
           layout style used for maintaining the dataObject -->
      <xsl:choose>




        <xsl:when test="@layoutStyle='form' or @layoutStyle='select-form'">
          <!-- Create form group processes -->
          <xsl:call-template name="formGroupProcesses">
            <xsl:with-param name="pageName" select="$pageName"/> 
            <xsl:with-param name="groupName" select="$groupName"/> 
            <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/> 
            <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/> 
            <xsl:with-param name="baseStartProcess" select="$baseStartProcess"/> 
            <xsl:with-param name="initialProcess" select="$initialProcess"/>
          </xsl:call-template>
        </xsl:when>





        <xsl:when test="@layoutStyle='table'">
          <xsl:call-template name="tableGroupProcesses">
            <xsl:with-param name="pageName" select="$pageName"/> 
            <xsl:with-param name="groupName" select="$groupName"/> 
            <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/> 
            <xsl:with-param name="baseStartProcess" select="$baseStartProcess"/> 
            <xsl:with-param name="initialProcess" select="$initialProcess"/> 
          </xsl:call-template>
        </xsl:when>







        <xsl:when test="@layoutStyle='table-form'">
          <xsl:call-template name="tableFormGroupProcesses">
            <xsl:with-param name="pageName" select="$pageName"/> 
            <xsl:with-param name="groupName" select="$groupName"/> 
            <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/> 
            <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/> 
            <xsl:with-param name="baseStartProcess" select="$baseStartProcess"/> 
            <xsl:with-param name="initialProcess" select="$initialProcess"/> 
          </xsl:call-template>
        </xsl:when>



        
        <xsl:otherwise>
          <xsl:variable name="listProcess" select="concat('Select',$pageName,'Page')"/>
          <xsl:variable name="afterInsertProcess" select="concat('Edit',$pageName,'Page')"/>
          <xsl:call-template name="formGroupProcesses"/>
        </xsl:otherwise>
      </xsl:choose>

    <!-- S. davelaar 22-05-2003
         check whether there is at least one child group with samePage = true 
         and sortable, tableranges or
         detailDisclosure set to true. If so, we add one HandleTableEcent processs
         for all these children. We casnnot use sepearate processes because the
         routing request parameter is always "event". There is another request 
         parameter named "source" that holds the name of the child dataObjectSet.
         So, I also modified HandleTableEvent to check the source parameter if
         if the dataObjectSet cionstructior argument is not set -->
      <xsl:if test="count(Group[@samePage='true'])!='0'
                    and (Group[@sortable='true'] or Group[@useTableRange='true'] 
                    or Group[@detailDisclosure='true'])">

        <xsl:call-template name="handleTableEvent">
           <xsl:with-param name="processName" select="concat('Handle',@name,'ChildTableEvent')"/>
           <xsl:with-param name="pageName" select="concat($pageName,'Page')"/>
        </xsl:call-template>
      </xsl:if>
    
      <!-- add error process -->
      <xsl:call-template name="errorPage"/>

      <!-- add roles argument if accessRoles attribute is set -->
      <xsl:if test="@accessRoles!=''">
        <xsl:comment>Roles that have access to this group </xsl:comment>
        <argument type="String">
          <xsl:attribute name="value">
            <xsl:value-of select="@accessRoles"/>
          </xsl:attribute>
        </argument>
      </xsl:if>

    </processgroup>
    <xsl:comment> We do not need group transitions, because the default behavior
        is to go to the initial process of the service which is exactly
        what we need: all groups must transition to the serviceRouter
    </xsl:comment>
    <xsl:comment> End of <xsl:value-of select='@name'/> </xsl:comment>

  </xsl:template> <!-- end processGroup template -->


  <!-- Add lookup processes -->
  <xsl:template name="lookupProcesses">
    <xsl:param name="baseStartProcess"/>
    
    <xsl:for-each select="Lookup[not(@displayType='lov')]">
      <!-- determine next process, this is either the next lookup process
           of the same group, or -if group is child group with samePage
           =true- or the first lookup of the next child group with same page
           = true, or group is master group with child group in same page
           that has Lookup, or the GetdataObjectSet process of the
           master group dataObject itself -->
      <xsl:variable name="nextProcess">
        <xsl:choose>
          <xsl:when test="./following-sibling::node()[name(.)='Lookup' and not(@displayType='lov')]">
            <xsl:value-of select="concat('Get',./following-sibling::node()[name(.)='Lookup' and not(@displayType='lov')]/@name)"/>
          </xsl:when>
          <xsl:otherwise>
            <!-- is the current group a child group with same page true,
                 then check for next child group with same page is true
                 and has lookups. -->
            <xsl:choose>
              <xsl:when test="../following-sibling::node()[name(.)='Group' and Lookup[not(@displayType='lov') and position()=1]]/@samePage='true'">
                <xsl:value-of select="concat('Get',../following-sibling::node()/Lookup[not(@displayType='lov') and position()=1]/@name)"/>
              </xsl:when>
              <!-- S. Davelaar, 10-1-2002: extra when added to fix infomedics bug 
                   if current group is master group and has child group with same
                   page is true, check whether child group has choice Lookups -->
              <xsl:when test="../Group[Lookup[not(@displayType='lov') and position()=1]]/@samePage='true'">
                <xsl:value-of select="concat('Get',../Group/Lookup[not(@displayType='lov') and position()=1]/@name)"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="$baseStartProcess"/>
             </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
<!-- <xsl:message>Lookup: <xsl:value-of select="@name"/> => <xsl:value-of select="$nextProcess"/></xsl:message> -->
    
      <xsl:variable name="listProcess">
        <xsl:value-of select="$nextProcess"/>
      </xsl:variable>

      <!-- call template to add the process to the service xml file -->
      <xsl:call-template name="getLookupDataObjectSet">
        <xsl:with-param name="successProcess" select="$nextProcess"/>
        <xsl:with-param name="userErrorProcess" select="$listProcess"/>
        <xsl:with-param name="dataObjectNotFoundProcess" select="$listProcess"/>
      </xsl:call-template>

    </xsl:for-each>
      <!-- check whether there is a child group with
           samePage = true. If so add lookup processes for this child
           group. Note we have to add the lookups for edit as well
           as for view, right now -->
    <xsl:for-each select="Group[@samePage='true']">
      <xsl:call-template name="lookupProcesses">
        <xsl:with-param name="baseStartProcess" select="$baseStartProcess"/>
      </xsl:call-template>
    </xsl:for-each>

  </xsl:template>

  <!-- this template retrieves master dataObject and any child
       dataObject set for those child groups that have samePage
       attribute set to true -->
  <xsl:template name="getDataObjectsForPage">
<!-- <xsl:param name="getProcessSuffix"/> -->
    <xsl:param name="pageProcess"/>
    <xsl:param name="firstProcess"/>
    <xsl:param name="dataObjectKey"/>
    <xsl:param name="dataObjectSetKey"/>
    <xsl:param name="selectKey"/>

    <!-- first add process to retrieve master dataObject -->
    <xsl:if test="@layoutStyle!='form'">
      <xsl:call-template name="getSelectedDataObject">
        <xsl:with-param name="processName" select="concat('Get',$dataObjectKey)"/>
        <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
        <xsl:with-param name="dataObjectName" select="@dataObject"/>
        <xsl:with-param name="resultKey" select="$dataObjectKey"/>
        <xsl:with-param name="selectKey" select="$selectKey"/>
        <xsl:with-param name="successProcess">
        <!-- determine success process, this is either the
             page process, or the process to retrieve child data set if
             there is a child group displayed on same page -->
          <xsl:choose>
            <xsl:when test="count(Group[@samePage='true'])!='0'">
              <xsl:value-of select="concat('Get',Group[@samePage='true']/@name,'Set')"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$pageProcess"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
        <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
        <xsl:with-param name="dataObjectNotFoundProcess" select="$firstProcess"/>
      </xsl:call-template>
    </xsl:if>

    <!-- check whether there is a child group with samePage = true. If so add
         getChildDataObjectSet for this child group -->
    <xsl:for-each select="Group[@samePage='true']">
      <!-- determine next process, this is either the get dataObject set
           for the next child group with samePage = true,
           or, the display page process -->
      <xsl:variable name="nextProcess">
        <xsl:choose>
          <xsl:when test="./following-sibling::node()[name(.)='Group']/@samePage='true'">
            <xsl:value-of select="concat('Get',./following-sibling::node()/@name,'Set')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$pageProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

      <xsl:call-template name="getChildDataObjectSet">
        <xsl:with-param name="processName" select="concat('Get',@name,'Set')"/>
        <xsl:with-param name="successProcess" select="$nextProcess"/>
        <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
        <!-- P. Ebell - set dataObjectNotFoundProcess to $pageProcess because
             otherwise we would jump to the browseSelectedDataObject process
             of the master, and end up at the first row again
        -->
        <xsl:with-param name="dataObjectNotFoundProcess" select="$pageProcess"/>
        <xsl:with-param name="resultKey" select="concat(@name,'Set')"/>
        <xsl:with-param name="masterKey" select="../@name"/>
      </xsl:call-template>
      
    </xsl:for-each>

    <!-- If insert is allowed, add a process to get a default dataObject -->
    <xsl:if test="not(@insert='false')">
      <xsl:call-template name="getDefaultDataObject">
        <xsl:with-param name="processName" select="concat('GetDefault',$dataObjectKey)"/>
        <xsl:with-param name="resultKey" select="$dataObjectKey"/>
        <xsl:with-param name="successProcess" select="$pageProcess"/>
        <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
        <xsl:with-param name="dataObjectNotFoundProcess" select="$firstProcess"/>
      </xsl:call-template>
    </xsl:if>
  </xsl:template>  <!-- end getDataObjectsForPage template -->




  <!-- Add all dataObject specific processes for from layout-->
  <xsl:template name="formGroupProcesses">
    <xsl:param name="pageName"/>
    <xsl:param name="groupName"/>
    <xsl:param name="dataObjectKey"/> 
    <xsl:param name="dataObjectSetKey"/> 
    <xsl:param name="baseStartProcess"/>
    <xsl:param name="initialProcess"/>

    <!-- firstProcess holds the name of the first process after the proces
         that gets the dataObjectset (i.e. the findDataObjectSet, getChildDataObjectSet
         or getDataObjectSet process) -->         
    <xsl:variable name="firstProcess">
      <xsl:choose>
        <xsl:when test="@layoutStyle='select-form'">
          <xsl:value-of select="concat('Select',$pageName,'Page')"/>
        </xsl:when>
        <xsl:when test="@layoutStyle='form'">
          <xsl:value-of select="concat('Browse',$dataObjectSetKey)"/>
        </xsl:when>
      </xsl:choose>  
    </xsl:variable>  

    <xsl:variable name="groupPageProcess">
      <xsl:value-of select="concat($pageName,'Page')"/>
    </xsl:variable>

    <xsl:variable name="pageFile">
      <xsl:value-of select="concat($pageName,'Page',$uixExtension)"/>
    </xsl:variable>

    <!-- add find processes if applicable -->
    <xsl:if test="@findPage='true'">
      <xsl:call-template name="findPage">
        <xsl:with-param name="pageName" select="$pageName"/>
      </xsl:call-template>
      <!-- note: findDataObjectSet template requires
           nextProcess variable! -->
      <xsl:call-template name="findDataObjectSet">
        <xsl:with-param name="processName" select="concat('Find',$dataObjectSetKey)"/>
        <xsl:with-param name="successProcess" select="$firstProcess"/>
        <xsl:with-param name="userErrorProcess" select="$baseStartProcess"/>
        <xsl:with-param name="dataObjectNotFoundProcess" select="$baseStartProcess"/>
        <xsl:with-param name="findPage" select="concat('Find',$pageFile)"/>
        <xsl:with-param name="resultKey" select="$dataObjectSetKey"/>
      </xsl:call-template>
    </xsl:if>

    <xsl:if test="@layoutStyle='select-form'">
      <xsl:call-template name="selectPage">
          <xsl:with-param name="pageName" select="$pageName"/>
      </xsl:call-template>
    </xsl:if>

    <!-- check whether group is child group or not, and invoke
         corresponding process to get group set data -->
    <xsl:choose>
      <xsl:when test="name(..)='Group'">
        <xsl:call-template name="getChildDataObjectSet">
          <xsl:with-param name="processName" select="concat('Get',$dataObjectSetKey)"/>
          <xsl:with-param name="successProcess" select="$firstProcess"/>
          <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
          <xsl:with-param name="dataObjectNotFoundProcess" select="$firstProcess"/>
          <xsl:with-param name="resultKey" select="$dataObjectSetKey"/>
          <xsl:with-param name="masterKey" select="../@name"/>
        </xsl:call-template>

        <!-- if this is a detail group and the master group is a table layout, the
             master dataObject will not yet be in the infotable. -->
        <xsl:if test="../@layoutStyle='table'">
          <xsl:call-template name="selectMasterRow">
             <xsl:with-param name="processName" select="'SelectMasterRow'"/> 
             <xsl:with-param name="firstProcess" select="$initialProcess"/> 
          </xsl:call-template>
        </xsl:if>  

      </xsl:when>  
      <xsl:when test="not(@findPage='true')">
        <xsl:call-template name="getDataObjectSet">
          <xsl:with-param name="processName" select="concat('Get',$dataObjectSetKey)"/>
          <xsl:with-param name="successProcess" select="$firstProcess"/>
          <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
          <xsl:with-param name="dataObjectNotFoundProcess">
            <xsl:choose>
              <xsl:when test="@layoutStyle='form'">
                <xsl:value-of select="concat('GetDefault',$groupName)"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="$firstProcess"/>            
              </xsl:otherwise>
            </xsl:choose>  
          </xsl:with-param>  
          <xsl:with-param name="resultKey" select="$dataObjectSetKey"/>
        </xsl:call-template>
      </xsl:when>
    </xsl:choose>

    <xsl:call-template name="getDataObjectsForPage">
      <xsl:with-param name="pageProcess" select="$groupPageProcess"/>
      <xsl:with-param name="firstProcess" select="$firstProcess"/>
      <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
      <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
      <xsl:with-param name="selectKey" select="concat($dataObjectKey,'Rownum')"/>
    </xsl:call-template>

    <xsl:call-template name="browseDataObjectSet">
      <xsl:with-param name="processName" select="concat('Browse',$dataObjectSetKey)"/>
      <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
      <xsl:with-param name="buttonName" select="'browse'"/>
      <xsl:with-param name="resultKey" select="$dataObjectKey"/>
<!--  <xsl:with-param name="successProcess" select="$groupPageProcess"/> -->
      <xsl:with-param name="successProcess">
      <!-- determine success process, this is either the
           page process, or the process to retrieve child data set if
           there is a child group displayed on same page -->
        <xsl:choose>
          <xsl:when test="count(Group[@samePage='true'])!='0'">
            <xsl:value-of select="concat('Get',Group[@samePage='true']/@name,'Set')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$groupPageProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>      
      <xsl:with-param name="userErrorProcess">
      <!-- determine success process, this is either the
           page process, or the process to retrieve child data set if
           there is a child group displayed on same page -->
        <xsl:choose>
          <xsl:when test="@layoutStyle='form'">
            <xsl:value-of select="$groupPageProcess"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$firstProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>
      <!-- If no dataObject is found, return to the find page if possible --> 
      <xsl:with-param name="dataObjectNotFoundProcess">
        <xsl:choose>
          <xsl:when test="@findPage='true'">
            <xsl:value-of select="concat('Find',$groupPageProcess)"/>
          </xsl:when>
          <xsl:when test="@layoutStyle='form'">
            <xsl:value-of select="concat('GetDefault',$groupName)"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$firstProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>      

    </xsl:call-template>

    <xsl:call-template name="formPage">
      <xsl:with-param name="pageName" select="$pageName"/>
    </xsl:call-template>

    <xsl:call-template name="saveSimpleDataObject">
      <xsl:with-param name="processName" select="concat('Save',$dataObjectKey)"/>
      <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
      <xsl:with-param name="pageFile" select="$pageFile"/>
      <xsl:with-param name="dmlButton" select="'save'"/>
      <xsl:with-param name="doCommit">
        <xsl:choose>
          <!-- do commit is false when page contains child groups -->
          <xsl:when test="count(Group[@samePage='true'])!='0'">
            <xsl:value-of select="'false'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'true'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>
      <xsl:with-param name="successProcess">
        <xsl:choose>
          <!-- If there are detail groups on the same page, proceed to save them -->
          <xsl:when test="count(Group[@samePage='true'])!='0'">
            <xsl:value-of select="concat('Save',Group[@samePage='true']/@name,'Table')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$groupPageProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>      
      <xsl:with-param name="userErrorProcess" select="$groupPageProcess"/>

<!--
      <xsl:with-param name="afterDeleteProcess">
        <xsl:choose>
          <!- If there are detail groups on the same page, proceed to save them ->
          <xsl:when test="@layoutStyle='select-form'">
            <xsl:value-of select="concat('Select',$groupPageProcess)"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="concat('Browse',$dataObjectSetKey)"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>      
-->      
    </xsl:call-template>

    <xsl:if test="not(@delete='false')">
      <xsl:call-template name="deleteSimpleDataObject">
        <xsl:with-param name="processName" select="concat('Delete',$dataObjectKey)"/>
        <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
        <xsl:with-param name="pageFile" select="$pageFile"/>
        <xsl:with-param name="doCommit" select="'true'"/>
        <xsl:with-param name="successProcess" select="concat('Browse',$dataObjectSetKey)"/>
        <xsl:with-param name="userErrorProcess" select="$groupPageProcess"/>
      </xsl:call-template>
    </xsl:if>  


<!--    <xsl:message>calling saveSimpleChildDataObjectsForPage (form layout)</xsl:message> -->
    <xsl:call-template name="saveSimpleChildDataObjectsForPage">
      <xsl:with-param name="pageProcess" select="$groupPageProcess"/>
      <xsl:with-param name="pageFile" select="$pageFile"/>
    </xsl:call-template>

<!-- P. Ebell 25-02-2002 - Commented out the old Form processes 

<!-
    <xsl:variable name="newPageProcess">
      <xsl:value-of select="concat('New',$pageName,'Page')"/>
    </xsl:variable>

    <xsl:variable name="editPageProcess">
      <xsl:value-of select="concat('Edit',$pageName,'Page')"/>
    </xsl:variable>
->


    <!- get dataObject for edit page ->
    <xsl:call-template name="getDataObjectsForPage">
      <xsl:with-param name="getProcessSuffix" select="'ForEdit'"/>
      <xsl:with-param name="pageProcess" select="$editPageProcess"/>
      <xsl:with-param name="listProcess" select="$listProcess"/>
    </xsl:call-template>

    <!- get dataObject for view page ->
    <xsl:call-template name="getDataObjectsForPage">
      <xsl:with-param name="getProcessSuffix" select="'ForView'"/>
      <xsl:with-param name="pageProcess" select="concat('View',$pageName,'Page')"/>
      <xsl:with-param name="listProcess" select="$listProcess"/>
    </xsl:call-template>

    <xsl:call-template name="newPage">
      <xsl:with-param name="pageName" select="$pageName"/>
    </xsl:call-template>
    
    <xsl:call-template name="editPage">
      <xsl:with-param name="pageName" select="$pageName"/>
    </xsl:call-template>
    <xsl:call-template name="viewPage">
      <xsl:with-param name="pageName" select="$pageName"/>
    </xsl:call-template>

    <xsl:choose>
      <xsl:when test="name(..)='Group'">
        <xsl:call-template name="insertDataObjectThroughMaster">
          <xsl:with-param name="successProcess" select="$editPageProcess"/>
          <xsl:with-param name="userErrorProcess" select="concat('New',$pageName,'Page')"/>    
          <xsl:with-param name="pageName" select="$pageName"/>    
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="insertDataObject">
          <!- success process depends on whether page contains
               child groups that also need to be saved ->
          <xsl:with-param name="successProcess">
            <xsl:choose>
              <xsl:when test="count(Group[@samePage='true'])!='0'">
                <xsl:value-of select="concat('Save',Group[@samePage='true']/@dataObject,'TableMasterNew')"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="$editPageProcess"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:with-param>
          <!- do commit is false when page contains child groups ->
          <xsl:with-param name="doCommit">
            <xsl:choose>
              <xsl:when test="count(Group[@samePage='true'])!='0'">
                <xsl:value-of select="'false'"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="'true'"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:with-param>
          <xsl:with-param name="userErrorProcess" select="concat('New',$pageName,'Page')"/>
          <xsl:with-param name="pageName" select="$pageName"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>

    <!- save child dataObject sets on same page when
         inserting master ->
    <xsl:call-template name="saveChildDataObjectsForPage">
      <xsl:with-param name="getProcessSuffix" select="'MasterNew'"/>
      <xsl:with-param name="masterDmlAction" select="'insert'"/>
      <xsl:with-param name="newPageProcess" select="$newPageProcess"/>
      <xsl:with-param name="editPageProcess" select="$editPageProcess"/>
      <xsl:with-param name="pageFile" select="$pageFile"/>
    </xsl:call-template>

    <xsl:call-template name="updateDataObject">
      <xsl:with-param name="successProcess">
        <xsl:choose>
          <xsl:when test="count(Group[@samePage='true'])!='0'">
            <xsl:value-of select="concat('Save',Group[@samePage='true']/@dataObject,'TableMasterEdit')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$editPageProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>
      <!- do commit is false when page contains child groups ->
      <xsl:with-param name="doCommit">
        <xsl:choose>
          <xsl:when test="count(Group[@samePage='true'])!='0'">
            <xsl:value-of select="'false'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'true'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>
      <xsl:with-param name="pageName" select="$pageName"/>
      <xsl:with-param name="userErrorProcess" select="$editPageProcess"/>
      
    </xsl:call-template>

    <!- save child dataObject sets on same page when
         editing master ->
    <xsl:call-template name="saveChildDataObjectsForPage">
      <xsl:with-param name="getProcessSuffix" select="'MasterEdit'"/>
      <xsl:with-param name="masterDmlAction" select="'update'"/>
      <xsl:with-param name="newPageProcess" select="$newPageProcess"/>
      <xsl:with-param name="editPageProcess" select="$editPageProcess"/>
      <xsl:with-param name="pageFile" select="$pageFile"/>
    </xsl:call-template>

    <xsl:call-template name="deleteDataObject">
      <xsl:with-param name="pageName" select="$pageName"/>
      <xsl:with-param name="listProcess" select="$listProcess"/>
    </xsl:call-template>
-->

  </xsl:template>

  <!-- Add all dataObject specific processes for Table layout -->
  <xsl:template name="tableGroupProcesses">
    <xsl:param name="pageName"/>
    <xsl:param name="groupName"/> 
    <xsl:param name="dataObjectSetKey"/> 
    <xsl:param name="baseStartProcess"/>
    <xsl:param name="initialProcess"/>

    <xsl:variable name="groupTablePageProcess">
      <xsl:value-of select="concat($pageName,'TablePage')"/>
    </xsl:variable>

    <xsl:variable name="tablePageFile">
      <xsl:value-of select="concat($pageName,'TablePage',$uixExtension)"/>
    </xsl:variable>

    <!-- add find processes if applicable -->
    <xsl:if test="@findPage='true'">
      <xsl:call-template name="findPage">
        <xsl:with-param name="pageName" select="$pageName"/>
      </xsl:call-template>
      <!-- note: findDataObjectSet template requires
           nextProcess variable! -->
      <xsl:call-template name="findDataObjectSet">
        <xsl:with-param name="processName" select="concat('Find',$dataObjectSetKey)"/>
        <xsl:with-param name="successProcess" select="$groupTablePageProcess"/>
        <xsl:with-param name="userErrorProcess" select="$baseStartProcess"/>
        <xsl:with-param name="dataObjectNotFoundProcess" select="$baseStartProcess"/>
        <xsl:with-param name="findPage" select="concat('Find',$pageName,'Page',$uixExtension)"/>
        <xsl:with-param name="resultKey" select="$dataObjectSetKey"/>
      </xsl:call-template>
    </xsl:if>

    <!-- check whether group is child group or not, and invoke
         corresponding process to get group set data -->
    <xsl:choose>
      <xsl:when test="name(..)='Group'">
        <xsl:call-template name="getChildDataObjectSet">
          <xsl:with-param name="processName" select="concat('Get',$dataObjectSetKey)"/>
          <xsl:with-param name="successProcess" select="$groupTablePageProcess"/>
          <xsl:with-param name="userErrorProcess" select="$groupTablePageProcess"/>
          <xsl:with-param name="dataObjectNotFoundProcess" select="$groupTablePageProcess"/>
          <xsl:with-param name="resultKey" select="$dataObjectSetKey"/>
          <xsl:with-param name="masterKey" select="../@name"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="not(@findPage='true')">
        <xsl:call-template name="getDataObjectSet">
          <xsl:with-param name="processName" select="concat('Get',$dataObjectSetKey)"/>
          <xsl:with-param name="successProcess" select="$groupTablePageProcess"/>
          <xsl:with-param name="userErrorProcess" select="$groupTablePageProcess"/>
          <xsl:with-param name="dataObjectNotFoundProcess" select="$groupTablePageProcess"/>
          <xsl:with-param name="resultKey" select="$dataObjectSetKey"/>
        </xsl:call-template>
      </xsl:when>      
    </xsl:choose>

    <xsl:call-template name="tablePage">
       <xsl:with-param name="pageName" select="$pageName"/> 
    </xsl:call-template>

    <xsl:call-template name="saveTable">
        <xsl:with-param name="processName" select="concat('Save',$pageName,'Table')"/>
        <xsl:with-param name="tableName" select="$dataObjectSetKey"/>
        <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
        <xsl:with-param name="successProcess" select="$groupTablePageProcess"/>
        <xsl:with-param name="userErrorProcess" select="$groupTablePageProcess"/>
        <xsl:with-param name="pageFile" select="$tablePageFile"/>
    </xsl:call-template>

    <!-- If the table has sortable headers or table ranges, 
         or detailDisclosure, we'll need a handleTableEvent process-->
    <xsl:if test="@sortable='true' or @useTableRange='true' or @detailDisclosure='true'">
      <xsl:call-template name="handleTableEvent">
         <xsl:with-param name="processName" select="concat('Handle',@name,'TableEvent')"/>
         <xsl:with-param name="pageName" select="concat($pageName,'TablePage')"/>
      </xsl:call-template>
    </xsl:if>

    <!-- if this is a detail group and the master group is a table layout, the
         master dataObject will not yet be in the infotable. -->
    <xsl:if test="../@layoutStyle='table'">
      <xsl:call-template name="selectMasterRow">
         <xsl:with-param name="processName" select="'SelectMasterRow'"/> 
         <xsl:with-param name="firstProcess" select="$initialProcess"/> 
      </xsl:call-template>
    </xsl:if>  
  </xsl:template>


  <!-- Add all dataObject specific processes for table-form layout-->
  <xsl:template name="tableFormGroupProcesses">
    <xsl:param name="pageName"/>
    <xsl:param name="groupName"/> 
    <xsl:param name="dataObjectKey"/> 
    <xsl:param name="dataObjectSetKey"/> 
    <xsl:param name="baseStartProcess"/>
    <xsl:param name="initialProcess"/>

    <xsl:variable name="firstProcess" select="concat($pageName,'TablePage')"/>

    <xsl:variable name="groupPageProcess">
      <xsl:value-of select="concat($pageName,'Page')"/>
    </xsl:variable>

    <xsl:variable name="pageFile">
      <xsl:value-of select="concat($pageName,'Page',$uixExtension)"/>
    </xsl:variable>
    
    <xsl:call-template name="tableGroupProcesses">
      <xsl:with-param name="pageName" select="$pageName"/> 
      <xsl:with-param name="groupName" select="$groupName"/> 
      <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/> 
      <xsl:with-param name="baseStartProcess" select="$baseStartProcess"/> 
      <xsl:with-param name="initialProcess" select="$initialProcess"/> 
    </xsl:call-template>
    

    <xsl:call-template name="getDataObjectsForPage">
      <xsl:with-param name="pageProcess" select="$groupPageProcess"/>
      <xsl:with-param name="firstProcess" select="$firstProcess"/>
      <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
      <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
      <xsl:with-param name="selectKey" select="''"/>
    </xsl:call-template>

    <!-- include this in case of future use (and because generating the router
         would be much more complicated if this was to be left out  -->
    <xsl:call-template name="browseDataObjectSet">
      <xsl:with-param name="processName" select="concat('Browse',$dataObjectSetKey)"/>
      <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
      <xsl:with-param name="buttonName" select="'browse'"/>
      <xsl:with-param name="resultKey" select="$dataObjectKey"/>
      <xsl:with-param name="successProcess">
      <!-- determine success process, this is either the
           page process, or the process to retrieve child data set if
           there is a child group displayed on same page -->
        <xsl:choose>
          <xsl:when test="count(Group[@samePage='true'])!='0'">
            <xsl:value-of select="concat('Get',Group[@samePage='true']/@name,'Set')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$groupPageProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>      

      <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
      <!-- If no dataObject is found, return to the find page if possible --> 
      <xsl:with-param name="dataObjectNotFoundProcess">
        <xsl:choose>
          <xsl:when test="@findPage='true'">
            <xsl:value-of select="concat('Find',$groupPageProcess)"/>
          </xsl:when>
          <xsl:when test="@layoutStyle='form'">
            <xsl:value-of select="concat('GetDefault',$groupName)"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$firstProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>      
    </xsl:call-template>
    
    <xsl:call-template name="formPage">
      <xsl:with-param name="pageName" select="$pageName"/>
    </xsl:call-template>

    <xsl:call-template name="saveSimpleDataObject">
      <xsl:with-param name="processName" select="concat('Save',$dataObjectKey)"/>
      <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
      <xsl:with-param name="pageFile" select="$pageFile"/>
      <xsl:with-param name="dmlButton" select="'save'"/>
      <xsl:with-param name="doCommit">
        <xsl:choose>
          <!-- do commit is false when page contains child groups -->
          <xsl:when test="count(Group[@samePage='true'])!='0'">
            <xsl:value-of select="'false'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'true'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>
      <xsl:with-param name="successProcess">
        <xsl:choose>
          <!-- If there are detail groups on the same page, proceed to save them -->
          <xsl:when test="count(Group[@samePage='true'])!='0'">
            <xsl:value-of select="concat('Save',Group[@samePage='true']/@name,'Table')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$groupPageProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>      
      <xsl:with-param name="userErrorProcess" select="$groupPageProcess"/>
<!--  <xsl:with-param name="afterDeleteProcess" select="$firstProcess"/> -->
    </xsl:call-template>

    <xsl:if test="not(@delete='false')">
      <xsl:call-template name="deleteSimpleDataObject">
        <xsl:with-param name="processName" select="concat('Delete',$dataObjectKey)"/>
        <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
        <xsl:with-param name="pageFile" select="$pageFile"/>
        <xsl:with-param name="doCommit" select="'true'"/>
        <xsl:with-param name="successProcess" select="$firstProcess"/>
        <xsl:with-param name="userErrorProcess" select="$groupPageProcess"/>
      </xsl:call-template>
    </xsl:if>  

<!--    <xsl:message>calling saveSimpleChildDataObjectsForPage (table-form layout)</xsl:message> -->
    <xsl:call-template name="saveSimpleChildDataObjectsForPage">
      <xsl:with-param name="pageProcess" select="$groupPageProcess"/>
      <xsl:with-param name="pageFile" select="$pageFile"/>
    </xsl:call-template>


  </xsl:template>

  <xsl:template name="handleTableEvent">
    <xsl:param name="processName"/>
    <xsl:param name="pageName"/>

    <xsl:text>&#xa;</xsl:text>
    <xsl:text>&#xa;</xsl:text>
    <xsl:comment> Process to handle <xsl:value-of select="@name"/> table events </xsl:comment>

    <process>
      <xsl:attribute name="name">
        <xsl:value-of select="$processName"/>
      </xsl:attribute>
      <xsl:attribute name="class">
        <xsl:value-of select="'oracle.jheadstart.controller.mvc.process.HandleTableEvent'"/>
      </xsl:attribute>
      <xsl:attribute name="end">false</xsl:attribute>
      <!-- No longer set key of DataObjectSet, is derived within process
           from "source" request parameter. Needed to support multiple
           detail tables on same page as maste r
      <xsl:comment> infoTable select key of table DataObjectSet  </xsl:comment>
      <argument type="String">
        <xsl:attribute name="value">
          <xsl:value-of select="$dataObjectSetKey"/>
        </xsl:attribute>
      </argument>
      -->
    </process>

    <xsl:call-template name="genericProcessTransitions">
      <xsl:with-param name="sourceProcess"
        select="$processName"/>
      <xsl:with-param name="successProcess"
        select="$pageName"/>
    </xsl:call-template>

  </xsl:template> <!-- end template handle table event -->

  <xsl:template name="selectMasterRow">
    <xsl:param name="processName"/>
    <xsl:param name="firstProcess"/> 

    <xsl:variable name="masterDataObjectSetKey" select="concat(../@name,'Set')"/>
    <xsl:variable name="masterDataObjectKey" select="../@name"/>

    <xsl:call-template name="getSelectedDataObject">
      <xsl:with-param name="processName" select="$processName"/>
      <xsl:with-param name="dataObjectSetKey" select="$masterDataObjectSetKey"/>
      <xsl:with-param name="dataObjectName" select="../@dataObject"/>
      <xsl:with-param name="resultKey" select="$masterDataObjectKey"/>
      <xsl:with-param name="selectKey" select="''"/>
      <xsl:with-param name="successProcess" select="$firstProcess"/>
      <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
      <xsl:with-param name="dataObjectNotFoundProcess" select="$firstProcess"/>
    </xsl:call-template>

  </xsl:template> <!-- end template select master row -->

  <!-- sort dataObject set process -->
  <xsl:template name="sortDataObjectSet">

    <process>
      <xsl:attribute name="name">
        <xsl:value-of select="concat('Sort',@dataObject,'Set')"/>
      </xsl:attribute>
      <!-- name of get dataObject set process -->
      <xsl:attribute name="class">
        <xsl:value-of select="'oracle.jheadstart.controller.mvc.process.SortDataObjectSet'"/>
      </xsl:attribute>
      <xsl:attribute name="end">false</xsl:attribute>
      <!-- process paarmeter select key of DataObjectSet -->
      <xsl:comment> infoTable select key of table DataObjectSet  </xsl:comment>
      <argument type="String">
        <xsl:attribute name="value">
          <xsl:value-of select="concat(@dataObject,'Set')"/>
        </xsl:attribute>
      </argument>
    </process>

    <!-- call template to add process transitions -->
    <xsl:call-template name="genericProcessTransitions">
      <xsl:with-param name="sourceProcess"
        select="concat('Sort',@dataObject,'Set')"/>
      <xsl:with-param name="successProcess"
        select="$nextProcess"/>
    </xsl:call-template>

  </xsl:template> <!-- end sortDataSOurceSet template-->


  <xsl:template name="genericProcessTransitions">
    <xsl:param name="sourceProcess"/>
    <xsl:param name="successProcess"/>
    <!-- success condition -->
    <transition>
      <xsl:attribute name="src">
        <xsl:value-of select="$sourceProcess"/>
      </xsl:attribute>
      <xsl:attribute name="condition">success</xsl:attribute>
      <xsl:attribute name="dest">
        <xsl:value-of select="$successProcess"/>
      </xsl:attribute>
    </transition>
    <!-- failure condition -->
    <transition>
      <xsl:attribute name="src">
        <xsl:value-of select="$sourceProcess"/>
      </xsl:attribute>
      <xsl:attribute name="condition">failure</xsl:attribute>
      <xsl:attribute name="dest">ErrorPage</xsl:attribute>
    </transition>
  </xsl:template> <!-- end genericProcessTransitions template-->


  <xsl:template name="checkPageTimeStamp">
    <xsl:text>&#xa;</xsl:text>
    <xsl:text>&#xa;</xsl:text>
    <xsl:comment>
    This process checks whether the back button or refresh was used on a page
    that has a timestamp field (i.e. a page that should only be submitted once. Most
    likely, you'll want every page that can perform DML to have such a timestamp.
    See the javadoc of this class to see how this timestamp can be included in your
    pages.
    </xsl:comment>
    <process name="CheckPageTimeStamp" class="oracle.jheadstart.controller.mvc.process.CheckPageTimeStamp" end="false"> 
      <!-- Store back button error message in infoTable for display on Error Page? --> 
      <xsl:comment> Store back button error message in infoTable for display on Error Page? </xsl:comment>
      <argument type="Boolean" value="true"/> 
    </process> 
    <transition src="CheckPageTimeStamp" condition="success" dest="ServiceRouter"/> 
    <transition src="CheckPageTimeStamp" condition="failure" dest="ErrorPageGroup"/>
  </xsl:template>  

  <xsl:template name="errorPageGroup">
    <xsl:text>&#xa;</xsl:text>
    <xsl:text>&#xa;</xsl:text>
    <processgroup name="ErrorPageGroup" class="oracle.cle.process.DisplayGroup" initial="ErrorPage" end="true"> 
       <process name="ErrorPage" class="oracle.jheadstart.controller.mvc.process.Forward" end="true"> 
          <argument type="String" value="{concat($uixVirtualDir,'DisplayErrorPage.uix')}"/> 
        </process> 
    </processgroup> 
  </xsl:template>  

</xsl:stylesheet>
