<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : Struts-config.xsl

Notes       :

$revision_history$
03-dec-2003   Sandra Muller
  1.25        removed (debug) message gropenaam
24-nov-2003   Steven Davelaar
  1.24        Changed path of accessDenied and error page to includes dir
24-nov-2003   Steven Davelaar
  1.23        Generate accessDenied global forward when hideUnauthorisedTab = true
19-nov-2003   Steven Davelaar
  1.22        Generate SelectMasterRow action when detail has form or select-form
              layout
16-nov-2003   Steven Davelaar
  1.21        Added forwardPattern="$P" to controller element
14-nov-2003   Steven Davelaar
  1.20        Added DownloadFile action
24-okt-2003   Steven Davelaar
  1.19        Fixed bug 3191102: CreateDefaultDataObjectSet action
              was not generated when the detail group had newRows set to 0 or empty
29-aug-2003   Steven Davelaar
  1.18        Renamed ServiceRouter to ModuleRouter
06-aug-2003   Steven Davelaar
  1.17        Added beanName parameter to getDefaultDataObjectSet
04-aug-2003   Steven Davelaar
  1.16        Added generation of GetDefaultDataObjectSet for details on
              same page as master
04-aug-2003   Steven Davelaar
  1.15        Always generate nlsBundle into message-resources
29-jul-2003   Steven Davelaar
  1.14        Fixed bug in dataObjectNotFound transition in
              BrowseDataObjectSet
27-jul-2003   Aard-Jan van Kesteren
  1.13        - Solved bug 3054341. Before using "useOldProcessGroup" template, first check 
                whether an old struts-config.xml is provided.
              - Worked on bug 3054427. In template selectMasterRow provide the groupName as
                attribute
25-jul-2003   Steven Davelaar
  1.12        Improvd Fix for bug with form layout and no rows in table
              
23-jul-2003   Steven Davelaar
  1.11        Fixed bug so we navigate to new page with form layout and
              no rows found
05-jun-2003   STEVEN DAVELAAR
  1.10        Added null="false" to message-resources tag
28-mei-2003   Aard-Jan van Kesteren
  1.9         Generate a handle table event for a form if it has child groups
              with samePage = 'true'
22-mei-2003   Aard-Jan van Kesteren
  1.8         Added support for lovs
15-mei-2003   Aard-Jan van Kesteren
  1.7         Generate <message-resources  ... >
05-mei-2003   Aard-Jan van Kesteren
  1.6         - New CreateFormBean action for find pages without choice field
01-mei-2003   Aard-Jan van Kesteren
  1.5         .
01-mei-2003   Aard-Jan van Kesteren
  1.4         Renamed jspVirtualDir to pageVirtualDir
18-apr-2003   Aard-Jan van Kesteren
  1.3         Generate form-beans only if view type = 'JSP'
18-apr-2003   STEVEN DAVELAAR
  1.2         Added generation of dummy Tiles Plug In, required because JhsRequestprocessor
              extends Tiles to allow customer to use Tiles with JHeadstart.
              Added support for UIX table detail disclosure
24-feb-2003   Aard-Jan van Kesteren
  1.0         Initial creation (based on service.xsl)

*******************************************************************************
$add_to_revision_history
$
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:utils="http://www.oracle.com/XSL/Transform/java/oracle.jheadstart.tools.util.XSLTUtils"
  exclude-result-prefixes="cnt utils"  
  >
  <xsl:import href="StrutsPageProcessLib.xsl"/>
  <xsl:import href="StrutsServiceRouterLib.xsl"/>
  <xsl:import href="StrutsSaveDataProcessLib.xsl"/>
  <xsl:import href="StrutsGetDataProcessLib.xsl"/>
  <xsl:import href="StrutsFormBeans.xsl"/>  
  <xsl:import href="StrutsLovLib.xsl"/>    
  <xsl:output method="xml" indent="yes" />

    <!-- This parameter holds a Nodeset which is the previous version of this 
         Service XML file. We use this to merge a customized group in the new
         version when 'generateServiceGroup' is 'false'
    -->
    <xsl:param name="oldServiceNode"/>

    <xsl:variable name="groupClassName">
      <xsl:value-of select="Service/@groupClass"/>
    </xsl:variable>

    <xsl:variable name="uixExtension">
      <xsl:choose>
        <xsl:when test="Service/@viewType != 'JSP'">
          <xsl:value-of select="'.uix'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'.jsp'"/>
        </xsl:otherwise>
      </xsl:choose>
      
    </xsl:variable>

    <xsl:variable name="uixVirtualDir">
       <xsl:value-of select="Service/@pageVirtualDir"/>
    </xsl:variable>

    <xsl:variable name="includesVirtualDir">
       <xsl:value-of select="Service/@jspIncludesVirtualDir"/>
    </xsl:variable>

    <xsl:variable name="groupIncludeFile">
      <xsl:value-of select="Service/@groupIncludeFile"/>
    </xsl:variable>

    <xsl:variable name="defaultErrorPage">
      <xsl:choose>
        <xsl:when test="Service/@viewType != 'JSP'">
          <xsl:value-of select="'DisplayErrorPage.uix'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'DisplayErrorPage.jsp'"/>
        </xsl:otherwise>    
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="defaultAccessDeniedPage">
      <xsl:choose>
        <xsl:when test="Service/@viewType != 'JSP'">
          <xsl:value-of select="'AccessDeniedPage.uix'"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'AccessDeniedPage.jsp'"/>
        </xsl:otherwise>    
      </xsl:choose>
    </xsl:variable>

    <xsl:variable name="modelBase">
      <xsl:value-of select="concat(Service/@modelBase,'.')"/>
    </xsl:variable>
    

  <!-- shell template to create service -->
  <xsl:template match="/">

<xsl:text disable-output-escaping="yes">
<![CDATA[<!DOCTYPE struts-config PUBLIC
       "-//Apache Software Foundation//DTD Struts Configuration 1.1//EN"
       "http://jakarta.apache.org/struts/dtds/struts-config_1_1.dtd">]]>

</xsl:text>

     <struts-config>

     <xsl:if test="Service/@viewType = 'JSP'">
       <xsl:call-template name="formBeans"/>
     </xsl:if>

     <xsl:text>&#xa;</xsl:text>
     <xsl:text>&#xa;</xsl:text>     
     <xsl:comment> Error Page </xsl:comment>
     <global-forwards>
       <forward name="failure" path="{concat($includesVirtualDir, $defaultErrorPage)}"/>
       <xsl:if test="Service/@hideUnauthorizedGroupTabs='true'">
         <forward name="accessDenied" path="{concat($includesVirtualDir, $defaultAccessDeniedPage)}"/>
       </xsl:if>
       
     </global-forwards>

     <xsl:text>&#xa;</xsl:text>
     <xsl:text>&#xa;   </xsl:text>
     <action-mappings>
      <!-- moduleRouter template resides in ServiceRouterLib.xsl -->
      <xsl:call-template name="moduleRouter"/>
      
      <xsl:apply-templates/>

      <xsl:call-template name="handleLovs"/>

     <xsl:text>&#xa;   </xsl:text>

      <action path="/DownloadFile" 
          type="oracle.jheadstart.controller.struts.action.DownloadFile"/>
     
     <xsl:text>&#xa;   </xsl:text>

     </action-mappings>

     <xsl:text>&#xa;</xsl:text>
     <xsl:text>&#xa;   </xsl:text>
     <controller processorClass="oracle.jheadstart.controller.struts.JhsRequestProcessor" forwardPattern="$P" locale="true" />    

     <xsl:text>&#xa;</xsl:text>
     <xsl:text>&#xa;   </xsl:text>

     <xsl:variable name="messageResourcesParameter">
       <xsl:value-of select="/Service/@nlsBundle"/>
     </xsl:variable>

     <message-resources parameter="{$messageResourcesParameter}" factory="oracle.jheadstart.view.struts.JhsMessageResourcesFactory" null="false"/>

     <xsl:text>&#xa;</xsl:text>
     <xsl:text>&#xa;</xsl:text>
     <xsl:comment> The Tiles plug-in is really necessary only if Tiles definitions are used.
     But because the JhsRequestProcessor extends the TilesRequestProcessor to
     allow customers to use Tiles with JHeadstart, a dummy
     tiles-defs file should be available even when tiles is not used. 
     </xsl:comment> 
     <xsl:text>&#xa;</xsl:text>
     <xsl:text>&#xa;</xsl:text>

    <plug-in className="org.apache.struts.tiles.TilesPlugin">
      <set-property property="definitions-config" value="/jheadstart/tiles-defs-dummy.xml"/>
    </plug-in>
     <xsl:text>&#xa;</xsl:text>
     <xsl:text>&#xa;   </xsl:text>

     </struts-config>
  </xsl:template>


  <!-- shell template to create all (child) process groups -->
  <xsl:template match="Service/Group">
    <xsl:choose>
      <xsl:when test="@generateServiceGroup='false' and boolean($oldServiceNode)">
        <xsl:call-template name="useOldProcessGroup"/>
      </xsl:when>
      <xsl:otherwise>

        <xsl:call-template name="processGroup">
          <xsl:with-param name="groupName" select="@name"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>

    <!-- loop through child groups that do not have samePage = true-->
     <xsl:for-each select="Group[@samePage!='true' or not(@samePage)]">
       <xsl:choose>
         <xsl:when test="@generateServiceGroup='false' and boolean($oldServiceNode)">
           <xsl:call-template name="useOldProcessGroup"/>
         </xsl:when>
         <xsl:otherwise>
           <xsl:call-template name="processGroup">
             <xsl:with-param name="groupName" select="@name"/>
           </xsl:call-template>
         </xsl:otherwise>
       </xsl:choose>  
     </xsl:for-each>

  </xsl:template>

  <!-- template to create a process group based on the old Service XML file -->
  <xsl:template name="useOldProcessGroup">
    <xsl:variable name="processGroup" select="@name"/>

 <xsl:text>&#xa;</xsl:text>    
<xsl:comment>
###############################################################

  Actions for group: <xsl:value-of select='@name'/>

  Description:   <xsl:value-of select='@description'/>

  ** THIS ACTION GROUP HAS NOT BEEN REGENERATED **
  
###############################################################
</xsl:comment>


  <!-- shell template to create service -->

    <xsl:variable name="actions" select="$oldServiceNode//action[@path=concat($processGroup,'Router')]/following-sibling::*"/>

    <xsl:text>&#xa;</xsl:text>    
    <xsl:text>&#xa;</xsl:text>    
    <xsl:comment> Start of <xsl:value-of select="$oldServiceNode//action[@path=concat($processGroup,'Router')]/@path"/> action </xsl:comment>
    <xsl:copy-of select="$oldServiceNode//action[@path=concat($processGroup,'Router')]"/>
  
    <xsl:call-template name="printOldActions">
      <xsl:with-param name="actions" select="$actions"/>
    </xsl:call-template>

  </xsl:template>  

  <xsl:template name="printOldActions">
  <xsl:param name="actions"/>
  
    <xsl:if test="count($actions) != 0 and $actions[position() = 1][not(contains(@path, 'Router'))]">

      <xsl:text>&#xa;</xsl:text>    
      <xsl:text>&#xa;</xsl:text>    
      <xsl:comment> Start of <xsl:value-of select="$actions[position() = 1]/@path"/> action </xsl:comment>
      <xsl:copy-of select="$actions[position() = 1]"/>

      
      <xsl:call-template name="printOldActions">
        <xsl:with-param name="actions" select="$actions[position() != 1]"/>
      </xsl:call-template>
    </xsl:if>
    
  </xsl:template>


  <!-- template to create a process group -->
  <xsl:template name="processGroup">
    <xsl:param name="groupName"/>  
    <xsl:text>&#xa;</xsl:text>
    <xsl:text>&#xa;</xsl:text>
    

<xsl:comment>
###############################################################

  Actions for group: <xsl:value-of select='$groupName'/>

  Description:   <xsl:value-of select='@description'/>
  
###############################################################
</xsl:comment>

    <xsl:variable name="pageName" select="@name"/>
    <xsl:variable name="dataObjectKey" select="@name"/>
    <xsl:variable name="dataObjectSetKey" select="concat(@name,'Set')"/>
  
    <xsl:variable name="className">
      <xsl:choose>
        <xsl:when test="$groupClassName!=''">
          <xsl:value-of select="$groupClassName"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'oracle.cle.process.DisplayGroup'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!-- data source groups -->

      <xsl:choose>
        <xsl:when test="@groupIncludeFile">
          <xsl:attribute name="included">
            <xsl:value-of select="@groupIncludeFile"/>
          </xsl:attribute>
        </xsl:when>
        <xsl:when test="$groupIncludeFile">
          <xsl:attribute name="included">
            <xsl:value-of select="$groupIncludeFile"/>
          </xsl:attribute>
        </xsl:when>
      </xsl:choose>

      <!-- base start process for a group is the process to start
           after lookup processes have been executed.
           The base process depends on whether the group has
           a find page -->
      <xsl:variable name="baseStartProcess">
        <!-- use Find process if group has find page -->
        <xsl:choose>
          <xsl:when test="@findPage='true'">
            <xsl:value-of select="concat('Find',$pageName,'Page')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="concat('Get',$dataObjectSetKey)"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

      <!-- See of there are any lookUp elements defined for this group that are
           not displayed as lov.
           If so create lookup processes for them, and set the initial process
           of the group router to the first lookup process.
           The last lookup process wil then transition to the getDataSOurceSet
           process of the group dataObject itself -->
      <xsl:variable name="initialProcess">
        <xsl:choose>
          <xsl:when test="count(Lookup[not(@displayType='lov')])=0">
            <!-- check whether there is a child group with
                 samePage = true. If so check whether this child group
                 has a lookup process not displayed as lov and use this
                 as initial process -->
            <xsl:choose>
              <xsl:when test="count(Group[@samePage='true']/Lookup[not(@displayType='lov')])=0">

                <xsl:choose>
                  <xsl:when test="/Service/@viewType = 'JSP' and @findPage='true'">
                    <xsl:value-of select="concat('CreateFind', $groupName)"/>    
                  </xsl:when>
                  <xsl:otherwise>
                    <xsl:value-of select="$baseStartProcess"/>
                  </xsl:otherwise>
                </xsl:choose>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="concat(concat('Get', $groupName),Group[@samePage='true']/Lookup[not(@displayType='lov')]/@name)"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="concat(concat('Get', $groupName),Lookup[not(@displayType='lov')]/@name)"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
<!-- <xsl:message>Base process: <xsl:value-of select="$baseStartProcess"/> </xsl:message> -->
<!-- <xsl:message>Initial process: <xsl:value-of select="$initialProcess"/> </xsl:message> -->

      <!-- The processes within the group depends on the
           layout style used for maintaining the resource -->
      <xsl:choose>




        <xsl:when test="@layoutStyle='form' or @layoutStyle='select-form'">
          <!-- Create form group processes -->
          <xsl:call-template name="formGroupProcesses">
            <xsl:with-param name="pageName" select="$pageName"/> 
            <xsl:with-param name="groupName" select="$groupName"/> 
            <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/> 
            <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/> 
            <xsl:with-param name="baseStartProcess" select="$baseStartProcess"/> 
            <xsl:with-param name="router" select="concat($groupName,'Router')"/>  
            <xsl:with-param name="initialProcess" select="$initialProcess"/>           
          </xsl:call-template>
        </xsl:when>





        <xsl:when test="@layoutStyle='table'">
        
          <xsl:call-template name="tableGroupProcesses">
            <xsl:with-param name="pageName" select="$pageName"/> 
            <xsl:with-param name="groupName" select="$groupName"/> 
            <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/> 
            <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/> 
            <xsl:with-param name="baseStartProcess" select="$baseStartProcess"/> 
            <xsl:with-param name="router" select="concat($groupName,'Router')"/>  
            <xsl:with-param name="initialProcess" select="$initialProcess"/>           
          </xsl:call-template>
        </xsl:when>







        <xsl:when test="@layoutStyle='table-form'">
          <xsl:call-template name="tableFormGroupProcesses">
            <xsl:with-param name="pageName" select="$pageName"/> 
            <xsl:with-param name="groupName" select="$groupName"/> 
            <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/> 
            <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/> 
            <xsl:with-param name="baseStartProcess" select="$baseStartProcess"/> 
            <xsl:with-param name="router" select="concat($groupName,'Router')"/>  
            <xsl:with-param name="initialProcess" select="$initialProcess"/>           
          </xsl:call-template>
        </xsl:when>



        
        <xsl:otherwise>
          <xsl:variable name="listProcess" select="concat('Select',$pageName,'Page')"/>
          <xsl:variable name="afterInsertProcess" select="concat('Edit',$pageName,'Page')"/>
          <xsl:call-template name="formGroupProcesses">
            <xsl:with-param name="
            " select="$groupName"/>
          </xsl:call-template>
        </xsl:otherwise>
      </xsl:choose>

      <!-- add roles argument if accessRoles attribute is set -->
      <xsl:if test="@accessRoles!=''">
        <xsl:comment>Roles that have access to this group </xsl:comment>
        <argument type="String">
          <xsl:attribute name="value">
            <xsl:value-of select="@accessRoles"/>
          </xsl:attribute>
        </argument>
      </xsl:if>

  </xsl:template> <!-- end processGroup template -->


  <!-- Add lookup processes -->
  <xsl:template name="lookupProcesses">
    <xsl:param name="baseStartProcess"/>
    <xsl:param name="groupName"/>
    
    <xsl:for-each select="Lookup[not(@displayType='lov')]">
      <!-- determine next process, this is either the next lookup process
           of the same group, or -if group is child group with samePage
           =true- or the first lookup of the next child group with same page
           = true, or group is master group with child group in same page
           that has Lookup, or the GetdataObjectSet process of the
           master group dataObject itself -->
      <xsl:variable name="nextProcess">
        <xsl:choose>
          <xsl:when test="./following-sibling::node()[name(.)='Lookup' and not(@displayType='lov')]">
            <xsl:value-of select="concat(concat('Get', $groupName),./following-sibling::node()[name(.)='Lookup' and not(@displayType='lov')]/@name)"/>
          </xsl:when>
          <xsl:otherwise>
            <!-- is the current group a child group with same page true,
                 then check for next child group with same page is true
                 and has lookups. -->
            <xsl:choose>
              <xsl:when test="../following-sibling::node()[name(.)='Group' and Lookup[not(@displayType='lov') and position()=1]]/@samePage='true'">
                <xsl:value-of select="concat(concat(concat('Get', $groupName), $groupName),../following-sibling::node()/Lookup[not(@displayType='lov') and position()=1]/@name)"/>
              </xsl:when>
              <!-- S. Davelaar, 10-1-2002: extra when added to fix infomedics bug 
                   if current group is master group and has child group with same
                   page is true, check whether child group has choice Lookups -->
              <xsl:when test="../Group[Lookup[not(@displayType='lov') and position()=1]]/@samePage='true'">
                <xsl:value-of select="concat(concat('Get', $groupName),../Group/Lookup[not(@displayType='lov') and position()=1]/@name)"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="$baseStartProcess"/>
             </xsl:otherwise>
            </xsl:choose>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
<!-- <xsl:message>Lookup: <xsl:value-of select="@name"/> => <xsl:value-of select="$nextProcess"/></xsl:message> -->
    
      <xsl:variable name="listProcess">
        <xsl:value-of select="$nextProcess"/>
      </xsl:variable>

      <!-- call template to add the process to the service xml file -->
      <xsl:call-template name="getLookupDataObjectSet">
        <xsl:with-param name="successProcess" select="$nextProcess"/>
        <xsl:with-param name="userErrorProcess" select="$listProcess"/>
        <xsl:with-param name="dataObjectNotFoundProcess" select="$listProcess"/>
        <xsl:with-param name="groupName" select="$groupName"/>
      </xsl:call-template>

    </xsl:for-each>
      <!-- check whether there is a child group with
           samePage = true. If so add lookup processes for this child
           group. Note we have to add the lookups for edit as well
           as for view, right now -->
    <xsl:for-each select="Group[@samePage='true']">
      <xsl:call-template name="lookupProcesses">
        <xsl:with-param name="baseStartProcess" select="$baseStartProcess"/>
        <xsl:with-param name="groupName" select="$groupName"/>
      </xsl:call-template>
    </xsl:for-each>

  </xsl:template>

  <!-- this template retrieves master data source and any child
       data source set for those child groups that have samePage
       attribute set to true -->
  <xsl:template name="getDataObjectsForPage">
<!-- <xsl:param name="getProcessSuffix"/> -->
    <xsl:param name="pageProcess"/>
    <xsl:param name="firstProcess"/>
    <xsl:param name="dataObjectKey"/>
    <xsl:param name="dataObjectSetKey"/>
    <xsl:param name="selectKey"/>
    <xsl:param name="groupName"/>

    <!-- first add process to retrieve master dataObject -->
    <xsl:if test="@layoutStyle!='form'">
      <xsl:call-template name="getSelectedDataObject">
        <xsl:with-param name="processName" select="concat('Get',$dataObjectKey)"/>
        <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
        <xsl:with-param name="dataObjectName" select="@dataObject"/>
        <xsl:with-param name="resultKey" select="$dataObjectKey"/>
        <xsl:with-param name="selectKey" select="$selectKey"/>
        <xsl:with-param name="groupName" select="$groupName"/>
        <xsl:with-param name="successProcess">
        <!-- determine success process, this is either the
             page process, or the process to retrieve child data set if
             there is a child group displayed on same page -->
          <xsl:choose>
            <xsl:when test="count(Group[@samePage='true'])!='0'">
              <xsl:value-of select="concat('Get',Group[@samePage='true']/@name,'Set')"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$pageProcess"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
        <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
        <xsl:with-param name="dataObjectNotFoundProcess" select="$firstProcess"/>
      </xsl:call-template>
    </xsl:if>

    <!-- check whether there is a child group with samePage = true. If so add
         getChildDataObjectSet for this child group -->
    <xsl:for-each select="Group[@samePage='true']">
      <!-- determine next process, this is either the get dataObject set
           for the next child group with samePage = true,
           or, the display page process -->
      <xsl:variable name="nextProcess">
        <xsl:choose>
          <xsl:when test="./following-sibling::node()[name(.)='Group']/@samePage='true'">
            <xsl:value-of select="concat('Get',./following-sibling::node()/@name,'Set')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$pageProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

      <xsl:call-template name="getChildDataObjectSet">
        <xsl:with-param name="processName" select="concat('Get',@name,'Set')"/>
        <xsl:with-param name="successProcess" select="$nextProcess"/>
        <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
        <!-- P. Ebell - set dataObjectNotFoundProcess to $pageProcess because
             otherwise we would jump to the browseSelectedDataObject process
             of the master, and end up at the first row again
        -->
        <xsl:with-param name="dataObjectNotFoundProcess" select="$pageProcess"/>
        <xsl:with-param name="resultKey" select="concat(@name,'Set')"/>
        <xsl:with-param name="masterKey" select="../@name"/>
        <xsl:with-param name="groupName" select="$groupName"/>
      </xsl:call-template>
      
    </xsl:for-each>

    <!-- If insert is allowed, add a process to get a default dataObject -->
    <xsl:if test="not(@insert='false')">
      <xsl:call-template name="getDefaultDataObject">
        <xsl:with-param name="processName" select="concat('GetDefault',$dataObjectKey)"/>
        <xsl:with-param name="resultKey" select="$dataObjectKey"/>
        <xsl:with-param name="successProcess">
        <!-- determine success process, this is either the
             page process, or the process to retrieve child default data set if
             there is a child group displayed on same page -->
          <xsl:choose>
            <xsl:when test="count(Group[@samePage='true'])!='0'">
              <xsl:value-of select="concat('GetDefault',Group[@samePage='true']/@name,'Set')"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$pageProcess"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
        
        <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
        <xsl:with-param name="groupName" select="$groupName"/>
      </xsl:call-template>

    <!-- check whether there is a child group with samePage = true. If so add
         getDefaultDataObjectSet for this child group -->
     <xsl:for-each select="Group[@samePage='true']">
      <!-- determine next process, this is either the get dataObject set
           for the next child group with samePage = true,
           or, the display page process -->
      <xsl:variable name="nextProcess">
        <xsl:choose>
          <xsl:when test="./following-sibling::node()[name(.)='Group']/@samePage='true' and @newRows!='' and @newRows!='0'">
            <xsl:value-of select="concat('GetDefault',./following-sibling::node()/@name,'Set')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$pageProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>

      <xsl:call-template name="getDefaultDataObjectSet">
        <xsl:with-param name="processName" select="concat('GetDefault',@name,'Set')"/>
        <xsl:with-param name="successProcess" select="$nextProcess"/>
        <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
        <xsl:with-param name="resultKey" select="concat(@name,'Set')"/>
        <xsl:with-param name="groupName" select="$groupName"/>
        <xsl:with-param name="beanName" select="concat(@name,'Bean')"/>
      </xsl:call-template>
    </xsl:for-each>
      

      
    </xsl:if>
    
  </xsl:template>  <!-- end getDataObjectsForPage template -->



<!--
  <!- this template saves data for child groups in a page ->
  <xsl:template name="saveChildDataObjectsForPage">
    <xsl:param name="getProcessSuffix"/>
    <xsl:param name="masterDmlAction"/>
    <xsl:param name="newPageProcess"/>
    <xsl:param name="editPageProcess"/>
    <xsl:param name="pageFile"/>

      <!- check whether there is a child group with
           samePage = true. If so add saveChildDataObjectSet for this
           child group ->
    <xsl:variable name="childCount">
      <xsl:value-of select="count(Group[@samePage='true'])"/>
    </xsl:variable>
    <xsl:variable name="endProcess">
      <xsl:value-of select="concat('Get',Group[1]/@dataObject,'SetForEdit')"/>
    </xsl:variable>
    <xsl:for-each select="Group[@samePage='true']">
      <!- determine next process, this is either the get dataObject set
           for the next child group with samePage = true,
           or, the display page process ->
      <xsl:variable name="nextProcess">
        <xsl:choose>
          <xsl:when test="./following-sibling::node()[name(.)='Group']/@samePage='true'">
            <xsl:value-of select="concat('Save',./following-sibling::node()/@dataObject,'Table',$getProcessSuffix)"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$endProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:variable name="userErrorProcess">
        <xsl:choose>
          <xsl:when test="$masterDmlAction='insert'">
            <xsl:value-of select="$newPageProcess"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$editPageProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:variable>
      <xsl:call-template name="saveTable">
        <xsl:with-param name="processName"
            select="concat('Save',@dataObject,'Table',$getProcessSuffix)"/>
        <xsl:with-param name="successProcess" select="$nextProcess"/>
        <xsl:with-param name="userErrorProcess" select="$userErrorProcess"/>
        <xsl:with-param name="pageFile" select="$pageFile"/>
        <xsl:with-param name="doCommit">
          <!- check whether the group is the last child group on same
               page. If so, doCommit is true, otherwise it is false ->
          <xsl:choose>
            <xsl:when test="$childCount=position()">
              <xsl:value-of select="'true'"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="'false'"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:for-each>
  </xsl:template>  <!- end saveChildDataObjectsForPage template ->
-->

  <!-- Add all dataObject specific processes for from layout-->
  <xsl:template name="formGroupProcesses">
    <xsl:param name="pageName"/>
    <xsl:param name="groupName"/>
    <xsl:param name="dataObjectKey"/> 
    <xsl:param name="dataObjectSetKey"/> 
    <xsl:param name="baseStartProcess"/>
    <xsl:param name="router"/>
    <xsl:param name="initialProcess"/>    

    <!-- firstProcess holds the name of the first process after the proces
         that gets the dataObjectset (i.e. the findDataObjectSet, getChildDataObjectSet
         or getDataObjectSet process) -->         
    <xsl:variable name="firstProcess">
      <xsl:choose>
        <xsl:when test="@layoutStyle='select-form'">
          <xsl:value-of select="concat('Select',$pageName,'Page')"/>
        </xsl:when>
        <xsl:when test="@layoutStyle='form'">
          <xsl:value-of select="concat('Browse',$dataObjectSetKey)"/>
        </xsl:when>
      </xsl:choose>  
    </xsl:variable>  

    <xsl:variable name="groupPageProcess">
      <xsl:value-of select="concat($pageName,'Page')"/>
    </xsl:variable>

    <xsl:variable name="pageFile">
      <xsl:value-of select="concat($pageName,'Page',$uixExtension)"/>
    </xsl:variable>



    <xsl:if test="@layoutStyle='select-form'">
      <xsl:call-template name="selectPage">
          <xsl:with-param name="pageName" select="$pageName"/>
      </xsl:call-template>
    </xsl:if>

    <xsl:call-template name="formPage">
      <xsl:with-param name="pageName" select="$pageName"/>
    </xsl:call-template>

    <!-- add find processes if applicable -->
    <xsl:if test="@findPage='true'">
      <xsl:call-template name="findPage">
        <xsl:with-param name="pageName" select="$pageName"/>
      </xsl:call-template>
    </xsl:if>

      <!-- add generic process router process
           within this template, layout-specific templates
           are invoked. All router templates reside in ServiceRouterLib.xsl! -->
      <xsl:call-template name="simpleProcessRouter">
        <xsl:with-param name="router" select="concat($groupName,'Router')"/>
        <xsl:with-param name="pageName" select="$pageName"/>
        <xsl:with-param name="groupName" select="$groupName"/>
        <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
        <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
        <xsl:with-param name="initialProcess" select="$initialProcess"/>
      </xsl:call-template>

    <!-- add lookup processes -->
    <xsl:call-template name="lookupProcesses">
      <xsl:with-param name="baseStartProcess" select="$baseStartProcess"/>
      <xsl:with-param name="groupName" select="$groupName"/>
    </xsl:call-template>

    <xsl:if test="@findPage='true'">      
      <!-- note: findDataObjectSet template requires
           nextProcess variable! -->
      <xsl:call-template name="findDataObjectSet">
        <xsl:with-param name="processName" select="concat('Find',$dataObjectSetKey)"/>
        <xsl:with-param name="successProcess" select="$firstProcess"/>
        <xsl:with-param name="userErrorProcess" select="$baseStartProcess"/>
        <xsl:with-param name="dataObjectNotFoundProcess" select="$baseStartProcess"/>
        <xsl:with-param name="findPage" select="concat('Find',$pageFile)"/>
        <xsl:with-param name="resultKey" select="$dataObjectSetKey"/>
        <xsl:with-param name="groupName" select="$groupName"/>        
      </xsl:call-template>
    </xsl:if>

    <!-- If the viewtype = 'JSP' and the find page doesn't have a lookup, then
         the form bean has to be created explicitly
    -->
    <xsl:if test="@findPage='true' 
                  and /Service/@viewType='JSP'
                  and count(Lookup[not(@displayType='lov')])=0
                  and count(Group[@samePage='true']/Lookup[not(@displayType='lov')])=0
                  ">
      <xsl:call-template name="createFindFormBean">
        <xsl:with-param name="processName" select="concat('CreateFind',$groupName)"/>
        <xsl:with-param name="successProcess" select="$baseStartProcess"/>
        <xsl:with-param name="groupName" select="$groupName"/>
      </xsl:call-template>
    </xsl:if>

    <!-- check whether group is child group or not, and invoke
         corresponding process to get group set data -->
    <xsl:choose>
      <xsl:when test="name(..)='Group'">
        <xsl:call-template name="getChildDataObjectSet">
          <xsl:with-param name="processName" select="concat('Get',$dataObjectSetKey)"/>
          <xsl:with-param name="successProcess" select="$firstProcess"/>
          <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
          <xsl:with-param name="dataObjectNotFoundProcess" select="$firstProcess"/>
          <xsl:with-param name="resultKey" select="$dataObjectSetKey"/>
          <xsl:with-param name="masterKey" select="../@name"/>
          <xsl:with-param name="groupName" select="$groupName"/>          
        </xsl:call-template>

        <!-- if master has table layout, we need an action to select master -->
        <xsl:if test="../@layoutStyle='table'">
          <xsl:call-template name="selectMasterRow">
             <xsl:with-param name="processName" select="'SelectMasterRow'"/> 
             <xsl:with-param name="firstProcess" select="$initialProcess"/> 
             <xsl:with-param name="groupName" select="$groupName"/>
          </xsl:call-template>
        </xsl:if>  

      </xsl:when>  
      <xsl:when test="not(@findPage='true')">
        <xsl:call-template name="getDataObjectSet">
          <xsl:with-param name="processName" select="concat('Get',$dataObjectSetKey)"/>
          <xsl:with-param name="successProcess" select="$firstProcess"/>
          <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
          <xsl:with-param name="dataObjectNotFoundProcess">
            <xsl:choose>
              <xsl:when test="@layoutStyle='form'">
                <xsl:value-of select="concat('GetDefault',$groupName)"/>
              </xsl:when>
              <xsl:otherwise>
                <xsl:value-of select="$firstProcess"/>            
              </xsl:otherwise>
            </xsl:choose>  
          </xsl:with-param>  
          <xsl:with-param name="resultKey" select="$dataObjectSetKey"/>
          <xsl:with-param name="groupName" select="$groupName"/>          
        </xsl:call-template>
      </xsl:when>
    </xsl:choose>

    <xsl:call-template name="getDataObjectsForPage">
      <xsl:with-param name="pageProcess" select="$groupPageProcess"/>
      <xsl:with-param name="firstProcess" select="$firstProcess"/>
      <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
      <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
      <xsl:with-param name="selectKey" select="concat($dataObjectKey,'Rownum')"/>
      <xsl:with-param name="groupName" select="$groupName"/>      
    </xsl:call-template>

    <xsl:call-template name="browseDataObjectSet">
      <xsl:with-param name="processName" select="concat('Browse',$dataObjectSetKey)"/>
      <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
      <xsl:with-param name="buttonName" select="'browse'"/>
      <xsl:with-param name="resultKey" select="$dataObjectKey"/>
<!--  <xsl:with-param name="successProcess" select="$groupPageProcess"/> -->
      <xsl:with-param name="successProcess">
      <!-- determine success process, this is either the
           page process, or the process to retrieve child data set if
           there is a child group displayed on same page -->
        <xsl:choose>
          <xsl:when test="count(Group[@samePage='true'])!='0'">
            <xsl:value-of select="concat('Get',Group[@samePage='true']/@name,'Set')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$groupPageProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>      
      <xsl:with-param name="userErrorProcess">
      <!-- determine success process, this is either the
           page process, or the process to retrieve child data set if
           there is a child group displayed on same page -->
        <xsl:choose>
          <xsl:when test="@layoutStyle='form'">
            <xsl:value-of select="$groupPageProcess"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$firstProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>
      <!-- If no resource is found, return to the find page if possible --> 
      <xsl:with-param name="dataObjectNotFoundProcess">
        <xsl:choose>
          <xsl:when test="@findPage='true'">
            <xsl:value-of select="concat('Find',$groupPageProcess)"/>
          </xsl:when>
          <xsl:when test="@layoutStyle='form'">
            <xsl:value-of select="concat('GetDefault',$groupName)"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$firstProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>      
      <xsl:with-param name="groupName" select="$groupName"/>
    </xsl:call-template>

    <xsl:call-template name="saveSimpleDataObject">
      <xsl:with-param name="processName" select="concat('Save',$dataObjectKey)"/>
      <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
      <xsl:with-param name="pageFile" select="$pageFile"/>
      <xsl:with-param name="dmlButton" select="'save'"/>
      <xsl:with-param name="doCommit">
        <xsl:choose>
          <!-- do commit is false when page contains child groups -->
          <xsl:when test="count(Group[@samePage='true'])!='0'">
            <xsl:value-of select="'false'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'true'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>
      <xsl:with-param name="successProcess">
        <xsl:choose>
          <!-- If there are detail groups on the same page, proceed to save them -->
          <xsl:when test="count(Group[@samePage='true'])!='0'">
            <xsl:value-of select="concat('Save',Group[@samePage='true']/@name,'Table')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$groupPageProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>      
      <xsl:with-param name="userErrorProcess" select="$groupPageProcess"/>
      <xsl:with-param name="groupName" select="$groupName"/>


    </xsl:call-template>

    <xsl:if test="not(@delete='false')">
      <xsl:call-template name="deleteSimpleDataObject">
        <xsl:with-param name="processName" select="concat('Delete',$dataObjectKey)"/>
        <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
        <xsl:with-param name="pageFile" select="$pageFile"/>
        <xsl:with-param name="doCommit" select="'true'"/>
        <xsl:with-param name="successProcess" select="concat('Browse',$dataObjectSetKey)"/>
        <xsl:with-param name="userErrorProcess" select="$groupPageProcess"/>
        <xsl:with-param name="groupName" select="$groupName"/>        
      </xsl:call-template>
    </xsl:if>  

<!--    <xsl:message>calling saveSimpleChildDataObjectsForPage (form layout)</xsl:message> -->
    <xsl:call-template name="saveSimpleChildDataObjectsForPage">
      <xsl:with-param name="pageProcess" select="$groupPageProcess"/>
      <xsl:with-param name="pageFile" select="$pageFile"/>
      <xsl:with-param name="groupName" select="$groupName"/>       
    </xsl:call-template>

    <xsl:if test="Group[@samePage='true' and (@sortable='true' or @useTableRange='true' or @detailDisclosure='true')]">
      <xsl:call-template name="handleTableEvent">
        <xsl:with-param name="processName" select="concat('Handle',@name,'TableEvent')"/>
        <xsl:with-param name="pageName" select="$pageName"/>
        <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
        <xsl:with-param name="groupName" select="$groupName"/>  
        <xsl:with-param name="successProcess" select="concat($uixVirtualDir, @name, 'Page', $uixExtension)"/>
        <xsl:with-param name="withDataObjectSetName" select="'false'"/>
      </xsl:call-template>
    </xsl:if>

  </xsl:template>

  <!-- Add all dataObject specific processes for Table layout -->
  <xsl:template name="tableGroupProcesses">
    <xsl:param name="pageName"/>
    <xsl:param name="groupName"/>
    <xsl:param name="dataObjectKey"/> 
    <xsl:param name="dataObjectSetKey"/> 
    <xsl:param name="baseStartProcess"/>
    <xsl:param name="router"/>
    <xsl:param name="initialProcess"/>    

    <xsl:variable name="groupTablePageProcess">
      <xsl:value-of select="concat($pageName,'TablePage')"/>
    </xsl:variable>

    <xsl:variable name="tablePageFile">
      <xsl:value-of select="concat($pageName,'TablePage',$uixExtension)"/>
    </xsl:variable>

    <xsl:call-template name="tablePage">
       <xsl:with-param name="pageName" select="$pageName"/> 
    </xsl:call-template>

    <!-- add find processes if applicable -->
    <xsl:if test="@findPage='true'">
      <xsl:call-template name="findPage">
        <xsl:with-param name="pageName" select="$pageName"/>
      </xsl:call-template>
    </xsl:if>

      <!-- add generic process router process
           within this template, layout-specific templates
           are invoked. All router templates reside in ServiceRouterLib.xsl! -->
      <xsl:call-template name="simpleProcessRouter">
        <xsl:with-param name="router" select="concat($groupName,'Router')"/>
        <xsl:with-param name="pageName" select="$pageName"/>
        <xsl:with-param name="groupName" select="$groupName"/>
        <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
        <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
        <xsl:with-param name="initialProcess" select="$initialProcess"/>
      </xsl:call-template>

      <!-- add lookup processes -->
      <xsl:call-template name="lookupProcesses">
        <xsl:with-param name="baseStartProcess" select="$baseStartProcess"/>
        <xsl:with-param name="groupName" select="$groupName"/>        
      </xsl:call-template>

    <xsl:if test="@findPage='true'">      
      <!-- note: findDataObjectSet template requires
           nextProcess variable! -->
      <xsl:call-template name="findDataObjectSet">
        <xsl:with-param name="processName" select="concat('Find',$dataObjectSetKey)"/>
        <xsl:with-param name="successProcess" select="$groupTablePageProcess"/>
        <xsl:with-param name="userErrorProcess" select="$baseStartProcess"/>
        <xsl:with-param name="dataObjectNotFoundProcess" select="$baseStartProcess"/>
        <xsl:with-param name="findPage" select="concat('Find',$pageName,'Page',$uixExtension)"/>
        <xsl:with-param name="resultKey" select="$dataObjectSetKey"/>
        <xsl:with-param name="groupName" select="$groupName"/>        
      </xsl:call-template>
    </xsl:if>

    <!-- If the viewtype = 'JSP' and the find page doesn't have a lookup, then
         the form bean has to be created explicitly
    -->
    <xsl:if test="@findPage='true' 
                  and /Service/@viewType='JSP'
                  and count(Lookup[not(@displayType='lov')])=0
                  and count(Group[@samePage='true']/Lookup[not(@displayType='lov')])=0
                  ">
      <xsl:call-template name="createFindFormBean">
        <xsl:with-param name="processName" select="concat('CreateFind',$groupName)"/>
        <xsl:with-param name="successProcess" select="$baseStartProcess"/>
        <xsl:with-param name="groupName" select="$groupName"/>
      </xsl:call-template>
    </xsl:if>

    <!-- check whether group is child group or not, and invoke
         corresponding process to get group set data -->
    <xsl:choose>
      <xsl:when test="name(..)='Group'">
        <xsl:call-template name="getChildDataObjectSet">
          <xsl:with-param name="processName" select="concat('Get',$dataObjectSetKey)"/>
          <xsl:with-param name="successProcess" select="$groupTablePageProcess"/>
          <xsl:with-param name="userErrorProcess" select="$groupTablePageProcess"/>
          <xsl:with-param name="dataObjectNotFoundProcess" select="$groupTablePageProcess"/>
          <xsl:with-param name="resultKey" select="$dataObjectSetKey"/>
          <xsl:with-param name="masterKey" select="../@name"/>
          <xsl:with-param name="groupName" select="$groupName"/>          
        </xsl:call-template>
      </xsl:when>
      <xsl:when test="not(@findPage='true')">
        <xsl:call-template name="getDataObjectSet">
          <xsl:with-param name="processName" select="concat('Get',$dataObjectSetKey)"/>
          <xsl:with-param name="successProcess" select="$groupTablePageProcess"/>
          <xsl:with-param name="userErrorProcess" select="$groupTablePageProcess"/>
          <xsl:with-param name="dataObjectNotFoundProcess" select="$groupTablePageProcess"/>
          <xsl:with-param name="resultKey" select="$dataObjectSetKey"/>
          <xsl:with-param name="groupName" select="$groupName"/>          
        </xsl:call-template>
      </xsl:when>      
    </xsl:choose>

    <xsl:call-template name="saveTable">
        <xsl:with-param name="processName" select="concat('Save',$pageName,'Table')"/>
        <xsl:with-param name="tableName" select="$dataObjectSetKey"/>
        <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
        <xsl:with-param name="successProcess" select="$groupTablePageProcess"/>
        <xsl:with-param name="userErrorProcess" select="$groupTablePageProcess"/>
        <xsl:with-param name="pageFile" select="$tablePageFile"/>
        <xsl:with-param name="groupName" select="$groupName"/>        
    </xsl:call-template>

    <!-- If the table has sortable headers or table ranges, 
         or detailDisclosure, we'll need a handleTableEvent process-->
    <xsl:if test="@sortable='true' or @useTableRange='true' or @detailDisclosure='true'">
       <xsl:call-template name="handleTableEvent">
         <xsl:with-param name="processName" select="concat('Handle',@name,'TableEvent')"/>
         <xsl:with-param name="pageName" select="$pageName"/>
         <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
         <xsl:with-param name="groupName" select="$groupName"/>         
      </xsl:call-template>
    </xsl:if>

    <!-- if this is a detail group and the master group is a table layout, the
         master dataObject will not yet be in the SessionData. -->
    <xsl:if test="../@layoutStyle='table'">
      <xsl:call-template name="selectMasterRow">
         <xsl:with-param name="processName" select="'SelectMasterRow'"/> 
         <xsl:with-param name="firstProcess" select="$initialProcess"/> 
         <xsl:with-param name="groupName" select="$groupName"/>
      </xsl:call-template>
    </xsl:if>  
  </xsl:template>


  <!-- Add all dataObject specific processes for table-form layout-->
  <xsl:template name="tableFormGroupProcesses">
    <xsl:param name="pageName"/>
    <xsl:param name="groupName"/>
    <xsl:param name="dataObjectKey"/> 
    <xsl:param name="dataObjectSetKey"/> 
    <xsl:param name="baseStartProcess"/>
    <xsl:param name="router"/>
    <xsl:param name="initialProcess"/>    

    <xsl:variable name="firstProcess" select="concat($pageName,'TablePage')"/>

    <xsl:variable name="groupPageProcess">
      <xsl:value-of select="concat($pageName,'Page')"/>
    </xsl:variable>

    <xsl:variable name="pageFile">
      <xsl:value-of select="concat($pageName,'Page',$uixExtension)"/>
    </xsl:variable>

    <xsl:call-template name="formPage">
      <xsl:with-param name="pageName" select="$pageName"/>
    </xsl:call-template>    
    
    <xsl:call-template name="tableGroupProcesses">
            <xsl:with-param name="pageName" select="$pageName"/> 
            <xsl:with-param name="groupName" select="$groupName"/> 
            <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/> 
            <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/> 
            <xsl:with-param name="baseStartProcess" select="$baseStartProcess"/> 
            <xsl:with-param name="router" select="concat($groupName,'Router')"/>  
            <xsl:with-param name="initialProcess" select="$initialProcess"/>           
    </xsl:call-template>
    

    <xsl:call-template name="getDataObjectsForPage">
      <xsl:with-param name="pageProcess" select="$groupPageProcess"/>
      <xsl:with-param name="firstProcess" select="$firstProcess"/>
      <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
      <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
      <xsl:with-param name="selectKey" select="''"/>
      <xsl:with-param name="groupName" select="$groupName"/>      
    </xsl:call-template>

    <!-- include this in case of future use (and because generating the router
         would be much more complicated if this was to be left out  -->
    <xsl:call-template name="browseDataObjectSet">
      <xsl:with-param name="processName" select="concat('Browse',$dataObjectSetKey)"/>
      <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
      <xsl:with-param name="buttonName" select="'browse'"/>
      <xsl:with-param name="resultKey" select="$dataObjectKey"/>
      <xsl:with-param name="successProcess">
      <!-- determine success process, this is either the
           page process, or the process to retrieve child data set if
           there is a child group displayed on same page -->
        <xsl:choose>
          <xsl:when test="count(Group[@samePage='true'])!='0'">
            <xsl:value-of select="concat('Get',Group[@samePage='true']/@name,'Set')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$groupPageProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>      

      <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
      <!-- If no resource is found, return to the find page if possible --> 
      <xsl:with-param name="dataObjectNotFoundProcess">
        <xsl:choose>
          <xsl:when test="@findPage='true'">
            <xsl:value-of select="concat('Find',$groupPageProcess)"/>
          </xsl:when>
          <xsl:when test="@layoutStyle='form'">
            <xsl:value-of select="concat('GetDefault',$groupName)"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$firstProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>      
      <xsl:with-param name="groupName" select="$groupName"/>      
    </xsl:call-template>

    
    <xsl:call-template name="saveSimpleDataObject">
      <xsl:with-param name="processName" select="concat('Save',$dataObjectKey)"/>
      <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
      <xsl:with-param name="pageFile" select="$pageFile"/>
      <xsl:with-param name="dmlButton" select="'save'"/>
      <xsl:with-param name="doCommit">
        <xsl:choose>
          <!-- do commit is false when page contains child groups -->
          <xsl:when test="count(Group[@samePage='true'])!='0'">
            <xsl:value-of select="'false'"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'true'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>
      <xsl:with-param name="successProcess">
        <xsl:choose>
          <!-- If there are detail groups on the same page, proceed to save them -->
          <xsl:when test="count(Group[@samePage='true'])!='0'">
            <xsl:value-of select="concat('Save',Group[@samePage='true']/@name,'Table')"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$groupPageProcess"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:with-param>      
      <xsl:with-param name="userErrorProcess" select="$groupPageProcess"/>
<!--  <xsl:with-param name="afterDeleteProcess" select="$firstProcess"/> -->
      <xsl:with-param name="groupName" select="$groupName"/>
    </xsl:call-template>

    <xsl:if test="not(@delete='false')">
      <xsl:call-template name="deleteSimpleDataObject">
        <xsl:with-param name="processName" select="concat('Delete',$dataObjectKey)"/>
        <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
        <xsl:with-param name="pageFile" select="$pageFile"/>
        <xsl:with-param name="doCommit" select="'true'"/>
        <xsl:with-param name="successProcess" select="$firstProcess"/>
        <xsl:with-param name="userErrorProcess" select="$groupPageProcess"/>
        <xsl:with-param name="groupName" select="$groupName"/>        
      </xsl:call-template>
    </xsl:if>  

<!--    <xsl:message>calling saveSimpleChildDataObjectsForPage (table-form layout)</xsl:message> -->
    <xsl:call-template name="saveSimpleChildDataObjectsForPage">
      <xsl:with-param name="pageProcess" select="$groupPageProcess"/>
      <xsl:with-param name="pageFile" select="$pageFile"/>
      <xsl:with-param name="groupName" select="$groupName"/>      
    </xsl:call-template>


<!--
    <xsl:call-template name="getSelectedRowForEdit">
      <xsl:with-param name="successProcess" select="concat('Edit',$pageName,'Page')"/>
    </xsl:call-template>
-->    

<!--

    <xsl:call-template name="newPage">
      <xsl:with-param name="pageName" select="$pageName"/>
    </xsl:call-template>
    <xsl:call-template name="editPage">
      <xsl:with-param name="pageName" select="$pageName"/>
    </xsl:call-template>

    <xsl:choose>
      <xsl:when test="name(..)='Group'">
        <xsl:call-template name="insertDataObjectThroughMaster">
          <xsl:with-param name="successProcess" select="$afterInsertProcess"/>
          <xsl:with-param name="userErrorProcess" select="concat('New',$pageName,'Page')"/>    
          <xsl:with-param name="pageName" select="$pageName"/>    
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="insertDataObject">
          <xsl:with-param name="successProcess" select="$afterInsertProcess"/>
          <xsl:with-param name="userErrorProcess" select="concat('New',$pageName,'Page')"/>
          <xsl:with-param name="pageName" select="$pageName"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>

    <xsl:call-template name="updateDataObject">
      <xsl:with-param name="successProcess" select="concat('Edit',$pageName,'Page')"/>
      <xsl:with-param name="userErrorProcess" select="concat('Edit',$pageName,'Page')"/>
      <xsl:with-param name="pageName" select="$pageName"/>
    </xsl:call-template>
      
    <xsl:call-template name="deleteDataObject">
      <xsl:with-param name="pageName" select="$pageName"/>
      <xsl:with-param name="listProcess" select="$listProcess"/>
    </xsl:call-template>
-->


  </xsl:template>

  <xsl:template name="handleTableEvent">
    <xsl:param name="processName"/>
    <xsl:param name="pageName"/>
    <xsl:param name="dataObjectSetKey"/>
    <xsl:param name="groupName"/>
    <xsl:param name="successProcess" select="concat($pageName,'TablePage')"/>
    <xsl:param name="withDataObjectSetName">true</xsl:param>

    <xsl:param name="actionName">
      <xsl:value-of select="utils:getActionName($processName, $groupName)"/>        
    </xsl:param>    

    <xsl:text>&#xa;</xsl:text>
    <xsl:text>&#xa;</xsl:text>
    <xsl:comment> Action to handle <xsl:value-of select="@name"/> table events </xsl:comment>

    <action>
      <xsl:attribute name="path">
        <xsl:value-of select="$actionName"/>
      </xsl:attribute>
      <xsl:attribute name="type">
        <xsl:value-of select="'oracle.jheadstart.controller.struts.action.HandleTableEvent'"/>
      </xsl:attribute>
 
      <xsl:if test="$withDataObjectSetName = 'true'">
        <!-- process parameter select key of DataObjectSet -->
        <xsl:comment> SessionData select key of table DataObjectSet  </xsl:comment>
        <set-property property="dataObjectSetName">
          <xsl:attribute name="value">
            <xsl:value-of select="$dataObjectSetKey"/>
          </xsl:attribute>
        </set-property>
      </xsl:if>

    <xsl:call-template name="genericProcessTransitions">
      <xsl:with-param name="sourceProcess"
        select="$processName"/>
      <xsl:with-param name="successProcess"
        select="$successProcess"/>
      <xsl:with-param name="groupName" select="$groupName"/>        
    </xsl:call-template>

    </action>

  </xsl:template> <!-- end template handle table event -->

  <xsl:template name="selectMasterRow">
    <xsl:param name="processName"/>
    <xsl:param name="firstProcess"/> 
    <xsl:param name="groupName"/>    

    <xsl:variable name="masterDataObjectSetKey" select="concat(../@name,'Set')"/>
    <xsl:variable name="masterDataObjectKey" select="../@name"/>

    <xsl:call-template name="getSelectedDataObject">
      <xsl:with-param name="processName" select="$processName"/>
      <xsl:with-param name="dataObjectSetKey" select="$masterDataObjectSetKey"/>
      <xsl:with-param name="dataObjectName" select="../@dataObject"/>
      <xsl:with-param name="resultKey" select="$masterDataObjectKey"/>
      <xsl:with-param name="selectKey" select="''"/>
      <xsl:with-param name="successProcess" select="$firstProcess"/>
      <xsl:with-param name="userErrorProcess" select="$firstProcess"/>
      <xsl:with-param name="dataObjectNotFoundProcess" select="$firstProcess"/>
      <xsl:with-param name="groupName" select="$groupName"/>      
    </xsl:call-template>

  </xsl:template> <!-- end template select master row -->

  <!-- sort dataObject set process -->
  <xsl:template name="sortDataObjectSet">
    <xsl:param name="groupName"/>    
    
    <action>
      <xsl:attribute name="path">
        <xsl:value-of select="utils:getActionName(concat('Sort',@dataObject,'Set'), $groupName)"/>
      </xsl:attribute>
      <!-- name of get dataObject set process -->
      <xsl:attribute name="type">
        <xsl:value-of select="'oracle.jheadstart.controller.struts.action.SortDataObjectSet'"/>
      </xsl:attribute>
      <!-- process paarmeter select key of DataObjectSet -->
      <xsl:comment> SessionData select key of table DataObjectSet  </xsl:comment>
      <set-property property="dataObjectSetName">
        <xsl:attribute name="value">
          <xsl:value-of select="concat(@dataObject,'Set')"/>
        </xsl:attribute>
      </set-property>
    </action>

    <!-- call template to add process transitions -->
    <xsl:call-template name="genericProcessTransitions">
      <xsl:with-param name="sourceProcess"
        select="concat('Sort',@dataObject,'Set')"/>
      <xsl:with-param name="successProcess"
        select="$nextProcess"/>
      <xsl:with-param name="groupName" select="$groupName"/>        
    </xsl:call-template>

  </xsl:template> <!-- end sortDataSOurceSet template-->


  <xsl:template name="genericProcessTransitions">
    <xsl:param name="sourceProcess"/>
    <xsl:param name="successProcess"/>
    <xsl:param name="groupName"/>
    <!-- success condition -->
    <forward>
      <xsl:attribute name="name">success</xsl:attribute>
      <xsl:attribute name="path">
        <xsl:value-of select="utils:getActionName($successProcess, $groupName)"/>
      </xsl:attribute>
    </forward>
  </xsl:template> <!-- end genericProcessTransitions template-->


</xsl:stylesheet>
