<?xml version='1.0' encoding='windows-1252'?>


<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : StrutsFormBeans.xsl

Notes       :

$revision_history$
25-mrt-2004   Steven Davelaar
  1.17        Set reset property to false for Find bean properties (bug 3532626)
27-jan-2004   Peter Ebell
  1.16        isPersistent now listens to 'PERSISTS' generator property.
18-jan-2004   Peter Ebell
  1.15        persistentAttribute on form- and find bean now listens to Custom VO property.
27-nov-2003   Steven Davelaar
  1.13        Only set isPersistent to true when attribute is updatable
19-nov-2003   Steven Davelaar
  1.12        isPersistent=true no longer set on action attributes
14-nov-2003   Steven Davelaar
  1.11        Added isFileField property
24-okt-2003   Steven Davelaar
  1.10        fix bug 3186101 STRUTS-JSP: PROBLEMS WITH DOMAIN WITH MEANING THAT  
              CONTAINS SPACES OR COMMA'S.
20-okt-2003   Steven Davelaar
  1.9         Prefix find form properties with "Find"
22-aug-2003   Peter Ebell
  1.8         Added exclude-result-prefixes for utils namespace.
21-aug-2003   Peter Ebell
  1.7         Replaced all occurences of static URL pattern "file://" by a call to
              utils:getURL, to allow for compatibility with Linux.
08-aug-2003   Steven Davelaar
  1.6         Only set uncheckedValue when checkbox is updatable
              deleteRow prefixed with group name and persistent set to false
04-aug-2003   Aard-Jan van Kesteren
  1.5         - Added property isUpdating
              - Added property isViewing
29-jul-2003   Steven Davelaar
  1.4         Added support for isDateTimeField
              Fixed code that looked up custom properties only
              at VO level instead of both EO and VO level
10-jun-2003   Aard-Jan van Kesteren
  1.3         
22-mei-2003   Aard-Jan van Kesteren
  1.2         - Generate form-beans for Lov's
              - Also generate comment texts for form beans
              - Add uncheckedValue property for checkboxes
14-mrt-2003   Aard-Jan van Kesteren
  1.0         Initial creation

*******************************************************************************
$add_to_revision_history
$
-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
   xmlns:utils="http://www.oracle.com/XSL/Transform/java/oracle.jheadstart.tools.util.XSLTUtils"
   exclude-result-prefixes="utils">

  <xsl:variable name="sourceDir" select="Service/@sourceDir"/>
  <xsl:variable name="bc4jDir" select="concat($sourceDir,translate(Service/@modelImplementationBase,'.','/'),'/')"/>
  <xsl:variable name="domainfile" select="utils:getURL(Service/@domainFilePath)"/>
  <xsl:variable name="domainDoc" select="document($domainfile)"/>

<xsl:template name="formBeans">

  <form-beans>

  <xsl:for-each select="//Group">

<xsl:text>&#xa;</xsl:text>
<xsl:text>&#xa;</xsl:text>
<xsl:comment>
###############################################################

  Form-beans for group: <xsl:value-of select="@name"/>
  
###############################################################
</xsl:comment>

    <xsl:call-template name="formBean"/>

    <xsl:if test="@findPage = 'true'">
      <xsl:call-template name="findFormBean"/>
    </xsl:if>
    
  </xsl:for-each>

  <xsl:for-each select="//Lookup[@displayType='lov']">
    <xsl:call-template name="lookupFormBeans"/>
  </xsl:for-each>

  <xsl:call-template name="domainsBean"/>

<!--
  <xsl:for-each select="//Lookup[@displayType='lov']">
    <xsl:call-template name=""/>
  </xsl:for-each>
-->
  
  </form-beans>
   
</xsl:template>

<xsl:template name="formBean">
  <xsl:param name="name"><xsl:value-of select="concat(@name, 'Bean')"/></xsl:param>
  <xsl:param name="groupName"><xsl:value-of select="@name"/></xsl:param>  

  <xsl:variable name="vofile" select="utils:getURL(concat($bc4jDir,@viewObject,'.xml'))"/>
<!--  <xsl:message>vofile=<xsl:value-of select="$vofile"/></xsl:message> -->
  <xsl:variable name="voDoc" select="document($vofile)"/>

  <xsl:text>&#xa;</xsl:text>
  <xsl:text>&#xa;</xsl:text>
  <xsl:comment>Form-bean: <xsl:value-of select="$name"/></xsl:comment>

  <form-bean>
    <xsl:attribute name="name">
      <xsl:value-of select="$name"/>
    </xsl:attribute>
    <xsl:attribute name="dynamic">
      <xsl:value-of select="'true'"/>
    </xsl:attribute>    
    <xsl:attribute name="type">
      <xsl:value-of select="'oracle.jheadstart.view.struts.JhsDynaActionForm'"/>
    </xsl:attribute>        

    <xsl:variable name="groupName" select="@name"/>

    <form-property className="oracle.jheadstart.controller.struts.config.JhsFormPropertyConfig" name="{concat($groupName, 'IsInserting')}" type="java.lang.Boolean">
      <set-property property="persistentAttribute" value="isInserting"/>      
    </form-property>  
    <form-property className="oracle.jheadstart.controller.struts.config.JhsFormPropertyConfig" name="{concat($groupName, 'IsUpdating')}" type="java.lang.Boolean">
      <set-property property="persistentAttribute" value="isUpdating"/>      
    </form-property>  
    <form-property className="oracle.jheadstart.controller.struts.config.JhsFormPropertyConfig" name="{concat($groupName, 'IsViewing')}" type="java.lang.Boolean">
      <set-property property="persistentAttribute" value="isViewing"/>      
    </form-property>  
    <form-property className="oracle.jheadstart.controller.struts.config.JhsFormPropertyConfig" name="{concat($groupName, 'DeleteRow')}" type="java.lang.String">
    </form-property>  

    <xsl:for-each select="$voDoc//ViewAttribute">

      <xsl:variable name="eoFile">
        <xsl:call-template name="getEoFileName">
          <xsl:with-param name="voDoc" select="$voDoc"/>
        </xsl:call-template>
      </xsl:variable>
      <xsl:variable name="entityUsage" select="@EntityUsage"/>
      <xsl:variable name="eoAttributeName" select="@EntityAttrName"/>
      <xsl:variable name="eoDoc" select="document($eoFile)"/>
      <xsl:variable name="entityAttributeNode"  select="$eoDoc/Entity/Attribute[$entityUsage!='' and @Name=$eoAttributeName]|current()[$entityUsage='']"/>

      <xsl:variable name="displayType">
        <xsl:call-template name="getCustomProperty">
          <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
          <xsl:with-param name="propertyName" select="'DISPLAY_TYPE'"/>
          <xsl:with-param name="defaultValue" select="''"/>
        </xsl:call-template>
      </xsl:variable>

      <form-property className="oracle.jheadstart.controller.struts.config.JhsFormPropertyConfig" name="{concat($groupName, @Name)}" >

        <xsl:attribute  name="type">
          <xsl:choose>
            <xsl:when test="   $entityAttributeNode/@ColumnType = 'BLOB'
                    or $displayType = 'uploadFile'">
              <xsl:value-of select="'org.apache.struts.upload.FormFile'"/>
            </xsl:when> 
            <xsl:otherwise>
              <xsl:value-of select="'java.lang.String'"/>
            </xsl:otherwise>
          </xsl:choose>
        </xsl:attribute>    

        <xsl:variable name="updateable">
          <xsl:choose>
            <xsl:when test="/ViewObject/EntityUsage[@Name=$entityUsage]/@ReadOnly='true'">
              <xsl:value-of select="'false'"/>
            </xsl:when>
            <xsl:when test="@IsUpdateable!=''">
              <xsl:value-of select="@IsUpdateable"/>
            </xsl:when>
            <xsl:otherwise>true</xsl:otherwise>
          </xsl:choose>
        </xsl:variable>

        <xsl:variable name="isPersistent">
          <xsl:choose>
            <xsl:when test="$updateable = 'while_insert'">
              <xsl:value-of select="'true'"/>
            </xsl:when>
            <xsl:otherwise>
              <xsl:value-of select="$updateable"/>
            </xsl:otherwise>  
          </xsl:choose>
        </xsl:variable>

        <set-property property="isPersistent">
          <xsl:attribute name="value">
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
              <xsl:with-param name="propertyName" select="'PERSISTS'"/>
              <xsl:with-param name="defaultValue" select="$isPersistent"/>
            </xsl:call-template>
          </xsl:attribute>  
        </set-property>  

        <set-property property="persistentAttribute">
          <xsl:attribute name="value">
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
              <xsl:with-param name="propertyName" select="'PERSISTENT_ATTRIBUTE'"/>
              <xsl:with-param name="defaultValue" select="@Name"/>
            </xsl:call-template>
          </xsl:attribute>  
        </set-property>

        <xsl:if test="   $entityAttributeNode/@ColumnType = 'DATE'
                      or $displayType = 'dateField'">
          <set-property property="isDateField" value="true"/>
        </xsl:if>     

        <xsl:if test="$displayType = 'datetimeField'">
          <set-property property="isDateTimeField" value="true"/>
        </xsl:if>     

        <xsl:if test="   $entityAttributeNode/@ColumnType = 'BLOB'
                      or $displayType = 'uploadFile'">
          <set-property property="isFileField" value="true"/>
        </xsl:if>     

        <xsl:if test="$displayType = 'checkBox' and @IsUpdateable!='false'">

          <xsl:variable name="domain">
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
              <xsl:with-param name="propertyName" select="'DOMAIN'"/>
              <xsl:with-param name="defaultValue" select="''"/>
            </xsl:call-template>
          </xsl:variable>

          <xsl:variable name="uncheckedValue">
            <xsl:choose>
              <xsl:when test="$domainDoc//Domain[@name=$domain]/AllowableValue[2]">
                <xsl:value-of select="$domainDoc//Domain[@name=$domain]/AllowableValue[2]/@value"/>
              </xsl:when> 
              <xsl:otherwise>
                <xsl:value-of select="''"/>
              </xsl:otherwise>
            </xsl:choose>
          </xsl:variable>
        
          <set-property property="uncheckedValue" value="{$uncheckedValue}"/>
        </xsl:if>

      </form-property>        

      
    </xsl:for-each>
   
  </form-bean>
</xsl:template>

<xsl:template name="findFormBean">
  <xsl:param name="name"><xsl:value-of select="concat('Find', @name)"/></xsl:param>
  <xsl:param name="groupName"><xsl:value-of select="@name"/></xsl:param>

  <xsl:variable name="vofile" select="utils:getURL(concat($bc4jDir,@viewObject,'.xml'))"/>
<!--  <xsl:message>vofile=<xsl:value-of select="$vofile"/></xsl:message> -->
  <xsl:variable name="voDoc" select="document($vofile)"/>

  <xsl:text>&#xa;</xsl:text>
  <xsl:text>&#xa;</xsl:text>
  <xsl:comment>Form-bean: <xsl:value-of select="$name"/></xsl:comment>
  <form-bean>
    <xsl:attribute name="name">
      <xsl:value-of select="$name"/>
    </xsl:attribute>
    <xsl:attribute name="dynamic">
      <xsl:value-of select="'true'"/>
    </xsl:attribute>    
    <xsl:attribute name="type">
      <xsl:value-of select="'oracle.jheadstart.view.struts.JhsDynaActionForm'"/>
    </xsl:attribute>        

    <xsl:for-each select="$voDoc//ViewAttribute">
      <form-property className="oracle.jheadstart.controller.struts.config.JhsFormPropertyConfig" name="{concat('Find',$groupName, @Name)}" type="java.lang.String">

        <xsl:variable name="eoFile">
          <xsl:call-template name="getEoFileName">
            <xsl:with-param name="voDoc" select="$voDoc"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="entityUsage" select="@EntityUsage"/>
        <xsl:variable name="eoAttributeName" select="@EntityAttrName"/>
        <xsl:variable name="eoDoc" select="document($eoFile)"/>
        <xsl:variable name="entityAttributeNode"  select="$eoDoc/Entity/Attribute[$entityUsage!='' and @Name=$eoAttributeName]|current()[$entityUsage='']"/>

        <xsl:variable name="displayType">
          <xsl:call-template name="getCustomProperty">
            <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
            <xsl:with-param name="propertyName" select="'DISPLAY_TYPE'"/>
            <xsl:with-param name="defaultValue" select="''"/>
          </xsl:call-template>
        </xsl:variable>

        <set-property property="persistentAttribute">
          <xsl:attribute name="value">
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
              <xsl:with-param name="propertyName" select="'PERSISTENT_ATTRIBUTE'"/>
              <xsl:with-param name="defaultValue" select="@Name"/>
            </xsl:call-template>
          </xsl:attribute>          
        </set-property>

        <xsl:if test="   $entityAttributeNode/@ColumnType = 'DATE'
                      or $displayType = 'dateField'">
          <set-property property="isDateField" value="true"/>
        </xsl:if>     

        <xsl:if test="$displayType = 'datetimeField'">
          <set-property property="isDateTimeField" value="true"/>
        </xsl:if>     
        
        <xsl:variable name="caseInsensitive">
          <xsl:call-template name="getCustomProperty">
            <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
            <xsl:with-param name="propertyName" select="'CASE_INSENSITIVE'"/>
            <xsl:with-param name="defaultValue" select="''"/>
          </xsl:call-template>
        </xsl:variable>

        <xsl:if test="$caseInsensitive = 'true'">
          <set-property property="isCaseInsensitive" 
                        value="true"/>
        </xsl:if>    

        <xsl:variable name="queryOperator">
          <xsl:call-template name="getCustomProperty">
            <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
            <xsl:with-param name="propertyName" select="'QUERY_OPERATOR'"/>
            <xsl:with-param name="defaultValue" select="''"/>
          </xsl:call-template>
        </xsl:variable>

        <xsl:if test="$queryOperator != ''">
          <set-property property="queryOperator" value="{$queryOperator}"/>
        </xsl:if>

        <!-- S. Davelaar, added 25-03-2004: set reset to false so find bean
             properties are preserved over requests -->
        <set-property property="reset" value="false"/>

      </form-property>   
      
    </xsl:for-each>
   
  </form-bean>

</xsl:template>

  <xsl:template name="domainsBean">
    <xsl:variable name="domainFile" select="utils:getURL(/Service/@domainFilePath)"/>
    <xsl:variable name="domainDoc" select="document($domainFile)"/>

    <xsl:if test="count($domainDoc/DomainSet/Domain) != 0">

    <xsl:text>&#xa;</xsl:text>
    <xsl:text>&#xa;</xsl:text>
    <xsl:comment>
###############################################################

  Form-bean for domains:<xsl:for-each select="$domainDoc/DomainSet/Domain">  
  - <xsl:value-of select="@name"/>
  </xsl:for-each>
###############################################################
     </xsl:comment>  
    
      <form-bean name="DomainsBean" dynamic="true" type="oracle.jheadstart.view.struts.JhsDynaActionForm">
        <xsl:for-each select="$domainDoc/DomainSet/Domain">
          <form-property className="oracle.jheadstart.controller.struts.config.JhsFormPropertyConfig" name="{concat(@name, 'Value')}" type="java.lang.String[]">
            <xsl:attribute name="initial">
              <!-- fix bug 3186101 STRUTS-JSP: PROBLEMS WITH DOMAIN WITH MEANING THAT  
                    CONTAINS SPACES OR COMMA'S.
                    Fixed by enclosing value and meaning in single quotes -->
              <xsl:text>{''</xsl:text>
               <xsl:for-each select="AllowableValue">
                 <xsl:text>,'</xsl:text>
                 <xsl:value-of select="@value"/>
                 <xsl:text>'</xsl:text>
               </xsl:for-each>
              <xsl:text>}</xsl:text>
            </xsl:attribute>
          </form-property>
          <form-property className="oracle.jheadstart.controller.struts.config.JhsFormPropertyConfig" name="{concat(@name, 'Meaning')}" type="java.lang.String[]">
            <xsl:attribute name="initial">
              <xsl:text>{''</xsl:text>
               <xsl:for-each select="AllowableValue">
                 <xsl:text>,'</xsl:text>
                 <xsl:value-of select="@meaning"/>
                 <xsl:text>'</xsl:text>
               </xsl:for-each>
              <xsl:text>}</xsl:text>
            </xsl:attribute>
          </form-property>          
        </xsl:for-each>
      </form-bean>
    </xsl:if>
    
  </xsl:template>

  <xsl:template name="getEoFileName">
    <xsl:param name="voDoc"/>
    <xsl:variable name="entityUsageName" select="@EntityUsage"/>
    <xsl:choose>
      <xsl:when test="$entityUsageName!=''">
        <xsl:variable name="entityUsage" select="$voDoc/ViewObject/EntityUsage[@Name=$entityUsageName]/@Entity"/>
        <xsl:variable name="entityUsagePath" select="translate($entityUsage,'.','/')"/>
        <xsl:value-of select="utils:getURL(concat($sourceDir,$entityUsagePath,'.xml'))"/>
      </xsl:when> 
      <xsl:otherwise>
        <xsl:value-of select="$domainfile"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="lookupFormBeans">
    <xsl:text>&#xa;</xsl:text>
    <xsl:text>&#xa;</xsl:text>
    <xsl:comment>
###############################################################

  Form-beans for lov: <xsl:value-of select="@name"/>
  
###############################################################
    </xsl:comment>

    <xsl:call-template name="findFormBean">
      <xsl:with-param name="name" select="concat('Lov', @name, 'FindBean')"/>
      <xsl:with-param name="groupName" select="@name"/>      
    </xsl:call-template>

    
  </xsl:template>

  <xsl:template name="getCustomProperty">
    <xsl:param name="entityAttribute"/>
    <xsl:param name="propertyName"/>
    <xsl:param name="defaultValue"/>

    <xsl:variable name="eoType" select="$entityAttribute/@Type"/> 
    <xsl:variable name="eoProperty" select="$entityAttribute/Properties/Property[@Name=$propertyName]/@Value"/> 
    <xsl:variable name="voProperty" select="Properties/Property[@Name=$propertyName]/@Value"/>

    <!-- Figure out the value of the display height, First check the VO attribute
         for the custom property, then check the EO attribute for
         the same property. If both properties donot exist/are null, then
         assign defaultValue
    -->
      <xsl:choose>
        <xsl:when test="$voProperty!=''">
          <xsl:value-of select="$voProperty"/>
        </xsl:when>
        <xsl:when test="$eoProperty!=''">
          <xsl:value-of select="$eoProperty"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="$defaultValue"/>
        </xsl:otherwise>
      </xsl:choose>

  </xsl:template> <!-- end get custom property template -->



</xsl:stylesheet>
