<?xml version='1.0' encoding='windows-1252'?>


<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : StrutsLovLib.xsl

Notes       :

$revision_history$
16-feb-2004   Peter Ebell
  1.5         Use getDataObjectInterface method on XSLTUtils instead of concatinating modelPersistenceBase
              with dataObjectInterface attributes.
19-dec-2003   Jan Kettenis
  1.4         Changed GetDataObjectSet action to use readOnlyBean.
28-jul-2003   Aard-Jan van Kesteren
  1.3         - Solved bug 3069186. Added queryType in FindDataObjectSet
27-jul-2003   Aard-Jan van Kesteren
  1.2
22-mei-2003   Aard-Jan van Kesteren
  1.1
21-mei-2003   Aard-Jan van Kesteren
  1.0
16-may-2003  Aard-Jan van Kesteren
  1.0         Initial creation

*******************************************************************************
$add_to_revision_history
$
-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:utils="http://www.oracle.com/XSL/Transform/java/oracle.jheadstart.tools.util.XSLTUtils"
  exclude-result-prefixes="utils" 
>

  <xsl:template name="handleLovs">
    <xsl:for-each select="//Lookup[@displayType = 'lov']">
      <xsl:call-template name="handleLov"/>
    </xsl:for-each>
  </xsl:template>

  <xsl:template name="handleLov">

    <xsl:text>&#xa;</xsl:text>
    <xsl:text>&#xa;</xsl:text>
<xsl:comment>
###############################################################

  Actions for lov: <xsl:value-of select='@name'/>

###############################################################
</xsl:comment>

    <xsl:text>&#xa;</xsl:text>
    <xsl:text>&#xa;</xsl:text>
    <xsl:comment> Start Lov<xsl:value-of select='@name'/>Router action </xsl:comment>

    <action path="{concat('Lov', @name, 'Router')}" type="oracle.jheadstart.controller.struts.action.ActionRouter">
      <set-property property="defaultForward" value="initial"/>
      <forward name="initial" path="{concat('CreateLov', @name, 'FindBean')}"/>
      <forward name="find" path="{concat('Lov', @name, 'Find')}"/>
      <forward name="event" path="{concat('HandleLov', @name, 'TableEvent')}"/>
    </action>

    <xsl:text>&#xa;</xsl:text>
    <xsl:text>&#xa;</xsl:text>
    <xsl:comment> Start CreateLov<xsl:value-of select="concat(@name, 'FindBean')"/> action </xsl:comment>
     <action>
      <xsl:attribute name="path">
        <xsl:value-of select="concat('CreateLov', @name, 'FindBean')"/>
      </xsl:attribute>
      <!-- name of find dataObject set process -->
      <xsl:attribute name="type">
        <xsl:value-of select="'oracle.jheadstart.controller.struts.action.CreateFormBean'"/>
      </xsl:attribute>
      <xsl:attribute name="name">
        <xsl:value-of select="concat('Lov', @name, 'FindBean')"/>
      </xsl:attribute>

      <forward>
        <xsl:attribute name="name">success</xsl:attribute>
        <xsl:attribute name="path">
          <xsl:value-of select="concat(/Service/@pageVirtualDir, 'Lov', @name, 'Page.jsp')"/>
        </xsl:attribute>
      </forward>
    </action>


    <xsl:text>&#xa;</xsl:text>
    <xsl:text>&#xa;</xsl:text>
    <xsl:comment> Start Lov<xsl:value-of select="@name"/>Find action </xsl:comment>

    <action>
      <xsl:attribute name="path">
        <xsl:value-of select="concat('Lov', @name, 'Find')"/>
      </xsl:attribute>
      <!-- name of find dataObject set process -->
      <xsl:attribute name="type">
        <xsl:value-of select="'oracle.jheadstart.controller.struts.action.FindDataObjectSet'"/>
      </xsl:attribute>

      <xsl:attribute name="scope">
        <xsl:value-of select="'session'"/>
      </xsl:attribute>

      <!-- name of the read only bean -->
      <xsl:comment> name of the readOnlyBean </xsl:comment>
      <set-property property="readOnlyBean">
        <xsl:attribute name="value">
          <xsl:value-of select="concat('Lov', @name, 'DataBean')"/>
        </xsl:attribute>
      </set-property>
      <!-- fully qualified dataObject interface class name -->
      <xsl:comment> name of dataObject interface class </xsl:comment>
      <set-property property="dataObjectInterface">
        <xsl:attribute name="value">
          <xsl:value-of select="utils:getDataObjectInterface($modelBase,@dataObject)"/>
        </xsl:attribute>
      </set-property>
      <!-- process result select key of DataObjectSet -->
      <xsl:comment> key used to store result DataObjectSet in SessionData </xsl:comment>
      <set-property property="dataObjectSetName">
        <xsl:attribute name="value">
          <xsl:value-of select="concat('Lov', @name, 'Set')"/>
        </xsl:attribute>
      </set-property>
      <!-- file name of find page -->

      <xsl:comment>Name of Form Bean that contains the properties used to populate the page fields that map of attributes of the datasource that is saved.</xsl:comment>
      <set-property property="pageName">
        <xsl:attribute name="value">
          <xsl:value-of select="concat('Lov', @name, 'FindBean')"/>
        </xsl:attribute>
      </set-property>

        <xsl:comment>Query Type</xsl:comment>
        <xsl:if test="@queryType != ''">
          <set-property property="queryType" value="{@queryType}"/>
        </xsl:if>

        <xsl:comment> range size </xsl:comment>
        <set-property property="rangeSize">
          <xsl:attribute name="value">
            <xsl:value-of select="'10'"/>
          </xsl:attribute>
        </set-property>

      <!-- Is the result set updateable? -->
      <xsl:comment> Is the result set updateable? </xsl:comment>
      <set-property property="isUpdatable">
        <xsl:attribute name="value">
          <xsl:value-of select="'false'"/>
        </xsl:attribute>
      </set-property>

      <forward name="success" path="{concat(/Service/@pageVirtualDir, 'Lov', @name, 'Page.jsp')}"/>
      <forward name="userError" path="{concat(/Service/@pageVirtualDir, 'Lov', @name, 'Page.jsp')}"/>
      <forward name="dataObjectNotFound" path="{concat(/Service/@pageVirtualDir, 'Lov', @name, 'Page.jsp')}"/>

    </action>

    <xsl:text>&#xa;</xsl:text>
    <xsl:text>&#xa;</xsl:text>
    <xsl:comment> Start <xsl:value-of select="concat('HandleLov', @name, 'TableEvent')"/> action </xsl:comment>
<!-- Action to handle Employee table events -->
      <action path="{concat('HandleLov', @name, 'TableEvent')}" type="oracle.jheadstart.controller.struts.action.HandleTableEvent">
         <!-- SessionData select key of table DataObjectSet  -->
         <set-property property="dataObjectSetName" value="{concat('Lov', @name, 'Set')}"/>
         <forward name="success" path="{concat(/Service/@pageVirtualDir, 'Lov', @name, 'Page.jsp')}"/>
      </action>

  </xsl:template>

</xsl:stylesheet>
