<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : StrutsPageProcessLib.xsl

Notes       :

$revision_history$
18-apr-2003   AARDJ
  1.3         Checked in after upload from D:\jhsdtdev\design\xslt\StrutsPageProcessLib.xsl
              Generate form-beans only if view type = 'JSP'
18-apr-2003   STEVEN DAVELAAR
  1.2         renamings
24-feb-2003  Aard-Jan van Kesteren
  1.0         Initial creation (based on PageProcessLib.xsl)

*******************************************************************************
$add_to_revision_history
$
-->

<xsl:stylesheet
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:utils="http://www.oracle.com/XSL/Transform/java/oracle.jheadstart.tools.util.XSLTUtils"
  exclude-result-prefixes="utils"  
  >
  <xsl:output method="xml" indent="yes" />


  <!-- find dataObject page process -->
  <xsl:template name="findPage">
    <xsl:param name="pageName"/>
    <xsl:call-template name="createSimpleUixPage">
      <xsl:with-param name="fullPageName" select="concat('Find',$pageName,'Page')"/>
      <xsl:with-param name="uixFileName" select="concat('Find',$pageName,'Page',$uixExtension)"/>
    </xsl:call-template>
  </xsl:template> <!-- end find dataObject page process -->

  <!-- select dataObject page process -->
  <xsl:template name="selectPage">
    <xsl:param name="pageName"/>
    <xsl:call-template name="createSimpleUixPage">
      <xsl:with-param name="fullPageName" select="concat('Select',$pageName,'Page')"/>
      <xsl:with-param name="uixFileName" select="concat('Select',$pageName,'Page',$uixExtension)"/>
    </xsl:call-template>
  </xsl:template> <!-- end select dataObject page process -->


  <!-- new form page process -->
  <xsl:template name="formPage">
    <xsl:param name="pageName"/>
    <xsl:call-template name="createSimpleUixPage">
      <xsl:with-param name="fullPageName" select="concat($pageName,'Page')"/>
      <xsl:with-param name="uixFileName" select="concat($pageName,'Page',$uixExtension)"/>
    </xsl:call-template>
  </xsl:template>

  <!-- table page process -->
  <xsl:template name="tablePage">
    <xsl:param name="pageName"/> 
    <xsl:call-template name="createSimpleUixPage">
      <xsl:with-param name="fullPageName" select="concat($pageName,'TablePage')"/>
      <xsl:with-param name="uixFileName" select="concat($pageName,'TablePage',$uixExtension)"/>
    </xsl:call-template>
  </xsl:template> <!-- end table page process -->


  <xsl:template name="tabsArgument">
    <!-- check whether group is child group, if this is the case,
         the tab number is the master group position (-1 because
         of zero-based index), and the global header is the position
         of the group itself. If the group is not a child group, the
         tab number is the position of the group itself -->
      <xsl:choose>
        <xsl:when test="name(..)='Group'">
          <xsl:value-of select="concat($masterTabnr,',',position())"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="concat(position()-1,',0')"/>
        </xsl:otherwise>
      </xsl:choose>
  </xsl:template>

  <!-- P. Ebell - Simplified create UIX page process for v9i_2 -->
  <xsl:template name="createSimpleUixPage">
    <xsl:param name="className">
      <xsl:value-of select="'oracle.jheadstart.controller.mvc.process.Forward'"/>
    </xsl:param>
    <xsl:param name="fullPageName"/>
    <xsl:param name="uixFileName"/>

    <xsl:variable name="dummy">
      <xsl:value-of select="utils:addToPageForward($fullPageName,concat($uixVirtualDir,$uixFileName))"/>
    </xsl:variable>
  </xsl:template>

</xsl:stylesheet>
