<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : UIXPage.xsl

Notes       :

Open Issues :

$revision_history$
24-nov-2003   Steven Davelaar
  2.18        path of jheadstartLibrary.uit is now includes dir 
14-nov-2003   Steven Davelaar
  2.17        Set and pass usesUpload form attribute to templates
07-sep-2003   Steven Davelaar
  2.16        Added controllerType variable
29-aug-2003   Steven Davelaar
  2.15        Renamed infoTable to sessionData
21-aug-2003   Peter Ebell
  2.14        Replaced all occurences of static URL pattern "file://" by a call to
              utils:getURL, to allow for compatibility with Linux.
06-aug-2003   Steven Davelaar
  2.13        
04-aug-2003   Steven Davelaar
  2.12        Always generate breadcrumbs nls-enabled
23-may-2003   STEVEN DAVELAAR
  2.11        Added showHintText variable
15-mei-2003   STEVEN DAVELAAR
  2.10        Changed implementation of nls bundle, now create as DataObjewct in runtime
              code, so we don't have to to datascope stuff anymore
03-mei-2003   STEVEN DAVELAAR
  2.9         Pass nlsBundle as parameter to template (although not used currently
              because UIX bundle class cannot be databound... log bug for that.)
01-mei-2003   Steven Davelaar
  2.8         Added nls support
01-mei-2003   AARDJ
  2.6         Checked in after upload from D:\jhsdtdev\design\xslt\UIXPage.xsl- Renamed uixVirtualDir to pageVirtualDir
17-mar-2003   Steven Davelaar
  2.5         
19-dec-2002   Peter Ebell
  2.4         - Use display title instead of tabname for master context attribute
              - Added template itemScreenPrompts to generate Javascript array that holds
                the prompts for all the items in the form.
01-jul-2002   Peter Ebell
  2.3         Changed references to formValues 'targetInfoAlias(Value)' to 'targetCondition(Value)'
              because infoAliases do not exist in the SimpleProcessRouter.
10-jun-2002   Peter Ebell
  2.2         - Added dataObject attribute to pageHeader, to enable dynamic binding of the
                disabled attribute of global headers.
              - Import now use uixVirtualDir property instead of uixDir  
15-may-2002   Peter Ebell
  2.1         Always use template getDisplayTitle for buttons etc.
14-may-2002   Peter Ebell
  2.0         Pre-prod release
28-mrt-2002   Peter Ebell
  1.1         Rewritten for JHeadstart 9i. Removed obsolete revision history.
25-sep-2001   Steven Davelaar
  1.0         initial creation
*******************************************************************************
$add_to_revision_history
$
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns="http://xmlns.oracle.com/uix/ui"
  xmlns:data="http://xmlns.oracle.com/uix/ui"
  xmlns:utils="http://www.oracle.com/XSL/Transform/java/oracle.jheadstart.tools.util.XSLTUtils"
  xmlns:string="http://www.oracle.com/XSL/Transform/java/java.lang.String"
  exclude-result-prefixes="utils, string"
  xmlns:jheadstart="http://www.oracle.com/jheadstart">
  <xsl:import href="UIXLibrary.xsl"/>
  <xsl:import href="UIXTableLib.xsl"/>
  <xsl:import href="UIXFormLib.xsl"/>
  <xsl:import href="UIXSelectFormLib.xsl"/>
  <xsl:output method="xml" indent="yes" />
  <xsl:param name="groupName"></xsl:param>
  <xsl:param name="layoutMode"></xsl:param>

  <xsl:variable name="serviceName" select="Service/@name"/>

  <xsl:variable name="sourceDir" select="Service/@sourceDir"/>

  <xsl:variable name="bc4jDir" select="concat($sourceDir,translate(Service/@modelImplementationBase,'.','/'),'/')"/>

  <xsl:variable name="modelBase" select="concat(Service/@modelBase,'.')"/>

  <xsl:variable name="showHintText" select="Service/@showHintText"/>

  <xsl:variable name="uixVirtualDir" select="Service/@pageVirtualDir"/>
  <xsl:variable name="includesVirtualDir" select="Service/@jspIncludesVirtualDir"/>

  <xsl:variable name="nls" select="Service/@nls"/>

  <xsl:variable name="controllerType" select="Service/@controllerType"/>

  <xsl:variable name="nlsBundle" select="Service/@nlsBundle"/>

  <xsl:variable name="templateRegistrationFile">
    <xsl:choose>
      <xsl:when test="Service/@templateLibraryFile">
        <xsl:value-of select="concat($includesVirtualDir,Service/@templateLibraryFile)"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="concat($includesVirtualDir,'jheadstartLibrary.uit')"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  
  <xsl:variable name="domainfile" select="utils:getURL(Service/@domainFilePath)"/>
  <xsl:variable name="domainDef" select="document($domainfile)"/>

  <xsl:variable name="pageName" select="$groupName"/>

  <xsl:variable name="tabBarName" select="concat(Service/@name,'TabBar')"/>
  <xsl:variable name="tabBarTemplate" select="concat($uixVirtualDir,$tabBarName,'.uit')"/>

  <xsl:variable name="globalHeaderName">
    <xsl:choose>
<!--  <xsl:when test="$layoutMode='select'">
        <!- no global headers in select page ->
      </xsl:when> -->
      <xsl:when test="Service/Group[@name=$groupName]/Group[@name!='' and not(@samePage='true')]">
        <!-- group is parent group, get global header file from group itself
             but only if layout style is form. If it is table, the user must
             first select a row before he can navuigate to the child group,
             so the global header should be hidden. -->
        <xsl:if test="$layoutMode='form'">
         <xsl:value-of select="$groupName"/><xsl:text>GlobalHeader</xsl:text>
        </xsl:if>
      </xsl:when>
      <xsl:when test="Service/Group/Group[@name=$groupName]/@name!=''">
        <!-- group is child group, get global header file from parent group -->
        <xsl:value-of select="Service/Group[Group/@name=$groupName]/@name"/><xsl:text>GlobalHeader</xsl:text>
      </xsl:when>
    </xsl:choose>
  </xsl:variable>
  <xsl:variable name="globalHeaderTemplate" select="concat($uixVirtualDir,$globalHeaderName,'.uit')"/>

  <xsl:variable name="formName">
<!--   <xsl:value-of select="concat(Service/Group[@name=$groupName]/@dataObject,'Form')"/> -->
    <xsl:value-of select="concat($groupName,'Form')"/>
  </xsl:variable>

  <xsl:variable name="findItemPrefix">
      <xsl:value-of select="concat('Find',Service/Group[@name=$groupName]/@dataObject)"/>
  </xsl:variable>

  <!-- end page-level variables -->


<xsl:template match="Service">
<!--  <xsl:message>In Service Match template: <xsl:value-of select="$groupName"/>, <xsl:value-of select="$layoutMode"/></xsl:message> -->

  <xsl:for-each select="Group[@name=$groupName]">
    <xsl:call-template name="masterGroup"/>
  </xsl:for-each>
  <xsl:for-each select="Group/Group[@name=$groupName]">
    <xsl:call-template name="childGroup"/>
  </xsl:for-each>
</xsl:template>

<xsl:template name="masterGroup">
  <xsl:variable name="tabPosition">
    <xsl:for-each select="/Service/Group">
      <xsl:if test="@name=$groupName">
        <xsl:value-of select="position()-1"/>
      </xsl:if>
    </xsl:for-each>
  </xsl:variable>
  <xsl:variable name="globalHeaderPosition" select="'0'"/>
<!--  <xsl:message>Found Master group <xsl:value-of select="@name"/>, tabs: (<xsl:value-of select="$tabPosition"/>,<xsl:value-of select="$globalHeaderPosition"/>)</xsl:message> -->

<!-- hier zou niets uit mogen komen -->
  <xsl:variable name="masterGroup" select="/Service/Group[Group/@name=$groupName]"/>
  <xsl:variable name="masterGroupName" select="$masterGroup/@name"/>

  <xsl:call-template name="pagecontent">
    <xsl:with-param name="tabPosition" select="$tabPosition"/>
    <xsl:with-param name="globalHeaderPosition" select="$globalHeaderPosition"/>
    <xsl:with-param name="masterGroup" select="$masterGroup"/>
    <xsl:with-param name="masterGroupName" select="$masterGroupName"/>
  </xsl:call-template>
  
</xsl:template>

<xsl:template name="childGroup">
  <xsl:variable name="masterGroup" select="/Service/Group[Group/@name=$groupName]"/>
  <xsl:variable name="masterGroupName" select="$masterGroup/@name"/>
  <xsl:variable name="tabPosition">
    <xsl:for-each select="/Service/Group">
      <xsl:if test="@name=$masterGroupName">
        <xsl:value-of select="position()-1"/>
      </xsl:if>
    </xsl:for-each>
  </xsl:variable>
  <xsl:variable name="globalHeaderPosition">
    <xsl:for-each select="$masterGroup/Group">
      <xsl:if test="@name=$groupName">
        <xsl:value-of select="position()"/>
      </xsl:if>
    </xsl:for-each>
  </xsl:variable>
<!--  <xsl:message>Found Child group <xsl:value-of select="@name"/> of Master group <xsl:value-of select="$masterGroupName"/>, tabs: (<xsl:value-of select="$tabPosition"/>,<xsl:value-of select="$globalHeaderPosition"/>)</xsl:message> -->
  <xsl:call-template name="pagecontent">
    <xsl:with-param name="tabPosition" select="$tabPosition"/>
    <xsl:with-param name="globalHeaderPosition" select="$globalHeaderPosition"/>
    <xsl:with-param name="masterGroup" select="$masterGroup"/>
    <xsl:with-param name="masterGroupName" select="$masterGroupName"/>
  </xsl:call-template>
</xsl:template>


<xsl:template name="pagecontent">
  <xsl:param name="tabPosition"/>
  <xsl:param name="globalHeaderPosition"/>
  <xsl:param name="masterGroup"/>
  <xsl:param name="masterGroupName"/>

  <xsl:variable name="templateLocalName">
    <xsl:call-template name="getTemplateLocalName"/>
  </xsl:variable>  
<!-- <xsl:message> Using template: <xsl:value-of select="$templateLocalName"/></xsl:message>
     <xsl:message> from library file: <xsl:value-of select="$templateRegistrationFile"/></xsl:message> -->    

<page xmlns="http://xmlns.oracle.com/uix/controller" xmlns:ui="http://xmlns.oracle.com/uix/ui" xmlns:ctrl="http://xmlns.oracle.com/uix/controller" xmlns:html="http://www.w3.org/TR/REC-html40" xmlns:templates="http://www.oracle.com/jheadstart/templates">
  <templates xmlns="http://xmlns.oracle.com/uix/ui">
    <templateImport source="{$templateRegistrationFile}"/>    
    <templateImport source="{$tabBarTemplate}"/>
    <xsl:if test="$globalHeaderName!=''">
      <templateImport source="{$globalHeaderTemplate}"/>
  </xsl:if>    
  </templates>
  <content>
    <xsl:variable name="templateName" select="concat('templates:',$templateLocalName)"/>

    <xsl:variable  name="multipartAttrs">
      <xsl:call-template name="checkMultipartAttributes"/>
    </xsl:variable>

    <xsl:element name="{$templateName}" xmlns="http://xmlns.oracle.com/uix/ui"
       xmlns:data="http://xmlns.oracle.com/uix/ui"
       xmlns:templates="http://www.oracle.com/jheadstart/templates"
       xmlns:jheadstart="http://www.oracle.com/jheadstart">


    <xsl:attribute name="usesUpload">
      <xsl:choose>
        <xsl:when  test="$multipartAttrs!=''">true</xsl:when>
        <xsl:otherwise>false</xsl:otherwise>
      </xsl:choose>
    </xsl:attribute>

      <xsl:call-template name="groupTitles">
        <xsl:with-param name="layoutStyle" select="$layoutMode"/>
      </xsl:call-template>

      <xsl:call-template name="dataObjects"/>  

      <xsl:call-template name="pageButtons"/>

      <xsl:call-template name="groupUsages"/>

      <xsl:call-template name="formOnSubmit"/>

      <tabs>
        <xsl:element name="{concat('templates:',$tabBarName)}">
          <xsl:attribute name="selectedTab">
            <xsl:value-of select="$tabPosition"/>
          </xsl:attribute>
        </xsl:element>  
      </tabs>
      <xsl:if test="$globalHeaderName!=''">
        <pageHeader>
          <xsl:element name="{concat('templates:',$globalHeaderName)}">
            <xsl:attribute name="selectedIndex">
              <xsl:value-of select="$globalHeaderPosition"/>
            </xsl:attribute>
            <xsl:if test="name(..)='Service'">
              <xsl:attribute name="data:dataObject">
                <xsl:value-of select="concat($groupName,'@jheadstart:sessionData')"/>
              </xsl:attribute>
            </xsl:if>  
          </xsl:element>  
        </pageHeader>  
      </xsl:if>
        
      <xsl:call-template name="breadCrumbs"/>   

      <xsl:call-template name="bodycontent">
        <xsl:with-param name="masterGroup" select="$masterGroup"/>
      </xsl:call-template>
    </xsl:element>
  </content> 
</page>
</xsl:template>

<!-- Add body content to page, put in separate template to
     include support for nls dataScope provider -->
<xsl:template name="bodycontent">
  <xsl:param name="masterGroup"/>
      <contents>
        <xsl:call-template name="itemScreenPrompts"/>

        <xsl:call-template name="requiredFieldsInTable">
          <xsl:with-param name="groupLayoutStyle" select="@layoutStyle"/>
        </xsl:call-template>

        <xsl:call-template name="layout">
          <xsl:with-param name="masterGroup" select="$masterGroup"/>
          <xsl:with-param name="groupLayoutStyle" select="@layoutStyle"/>
          <xsl:with-param name="layoutStyle" select="$layoutMode"/>
        </xsl:call-template>

      </contents>
</xsl:template>

<xsl:template name="layout">
  <xsl:param name="masterGroup"/>
  <xsl:param name="groupLayoutStyle"/>
  <xsl:param name="layoutStyle"/>
  
<!-- <xsl:message>In layout template, mastergroup=<xsl:value-of select="$masterGroup/@dataObject"/>, group=<xsl:value-of select="@name"/>, layoutStyle=<xsl:value-of select="$layoutStyle"/></xsl:message> -->
<!-- <xsl:message>In layout template</xsl:message> -->
  <xsl:variable name="masterDataObject" select="$masterGroup/@name"/>
<!--
  <xsl:variable name="masterTabName" select="$masterGroup/@tabName"/>
-->  

  <xsl:variable name="masterTabName">
    <xsl:choose>
      <xsl:when test="$masterGroup/@displayTitle!=''">
        <xsl:value-of select="$masterGroup/@displayTitle"/>
      </xsl:when>
      <xsl:when test="$masterGroup/@tabName!=''">
        <xsl:value-of select="$masterGroup/@tabName"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="$masterGroup/@dataObject"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:variable name="masterContextAttribute" select="$masterGroup/@descriptorAttribute"/>
  <xsl:variable name="vofile" select="utils:getURL(concat($bc4jDir,@viewObject,'.xml'))"/>
<!--  <xsl:message>vofile=<xsl:value-of select="$vofile"/></xsl:message> -->
  <xsl:variable name="voDoc" select="document($vofile)"/>
  <xsl:variable name="columns" select="@columns"/>

  <xsl:choose>
    <xsl:when test="$layoutStyle='find'">
<!-- <xsl:message>Calling findFormLayout</xsl:message> -->
      <xsl:call-template name="findFormLayout">
        <xsl:with-param name="columns" select="$columns"/>
        <xsl:with-param name="voDoc" select="$voDoc"/>
        <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
      </xsl:call-template>
    </xsl:when>
    <xsl:when test="$layoutStyle='select'">
<!-- <xsl:message>Calling selectLayout</xsl:message> -->
      <xsl:call-template name="selectLayout">
        <xsl:with-param name="columns" select="$columns"/>
        <xsl:with-param name="voDoc" select="$voDoc"/>
        <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
      </xsl:call-template>
    </xsl:when>
    <xsl:when test="$layoutStyle='form'">
<!-- <xsl:message>Calling formLayout</xsl:message> -->
      <xsl:call-template name="formLayout">
        <xsl:with-param name="columns" select="$columns"/>
        <xsl:with-param name="voDoc" select="$voDoc"/>
        <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
      </xsl:call-template>
      <!-- check whether there is a child group with
           samePage = true -->
      <xsl:for-each select="Group[@samePage='true']">
        <!-- re-initialze group-specific variables
             that have been initliazed at page level because
             they were needed in other templates -->
<!--        <xsl:variable name="masterGroup" select="$group"/> -->
<!--
        <xsl:variable name="groupName" select="@name"/>
        <xsl:variable name="group" select="current()"/>
        <xsl:variable name="dataObjectName" select="@dataObject"/>
        <xsl:variable name="layoutStyle" select="'table'"/> 
        <xsl:variable name="groupLayoutStyle" select="$group/@layoutStyle"/>
-->

        <header>
          <xsl:call-template name="groupTitles"/>
          
          <contents>
            <!-- recursive call to itself to add layout of detail group in
                 same page -->

<!--            <xsl:message>In samepage child group: <xsl:value-of select="@name"/></xsl:message> -->

            <xsl:call-template name="layout">
              <xsl:with-param name="masterGroup" select="$masterGroup"/>
              <xsl:with-param name="groupLayoutStyle" select="@layoutStyle"/>
              <xsl:with-param name="layoutStyle" select="'table'"/>
            </xsl:call-template>

          </contents>
        </header>
      </xsl:for-each>
    </xsl:when>
    <xsl:when test="$layoutStyle='table'">
<!-- <xsl:message>Calling tableLayout</xsl:message> -->
       <xsl:call-template name="tableLayout">
         <xsl:with-param name="voDoc" select="$voDoc"/>
         <xsl:with-param name="masterDataObject" select="$masterDataObject"/>
         <xsl:with-param name="masterTabName" select="$masterTabName"/>
         <xsl:with-param name="masterContextAttribute" select="$masterContextAttribute"/>
         <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
         <xsl:with-param name="groupLayoutStyle" select="$groupLayoutStyle"/>
       </xsl:call-template>
    </xsl:when>
  </xsl:choose>
</xsl:template>


<!-- Add the dataObjects to the template call, so that they can be referenced
     from within the template -->     
<xsl:template name="dataObjects">
  <xsl:if test="contains($layoutMode,'form')">
    <xsl:attribute name="data:dataObject">
      <xsl:value-of select="concat(@name,'@jheadstart:sessionData')"/>
    </xsl:attribute>
  </xsl:if>  

  <!-- always add dataObjectSet, necessary for previous/next form functionality -->
  <xsl:attribute name="data:dataObjectSet">
    <xsl:value-of select="concat(@name,'Set','@jheadstart:sessionData')"/>
  </xsl:attribute>
  
</xsl:template>

<xsl:template name="pageButtons">
  <xsl:choose>
    <xsl:when test="$layoutMode='select'">
      <xsl:call-template name="selectButtons"/>
    </xsl:when>
    <xsl:when test="$layoutMode='find'">
      <xsl:call-template name="findFormButtons"/>
    </xsl:when>
    <xsl:when test="$layoutMode='form'">
      <xsl:call-template name="formButtons"/>
     </xsl:when>
    <xsl:when test="$layoutMode='table'">
      <xsl:call-template name="tableButtons"/>
    </xsl:when>
  </xsl:choose>
</xsl:template>

<xsl:template name="groupUsages">
  <xsl:variable name="insertAllowed">
    <xsl:choose>
      <xsl:when test="@insert='false'">
        <xsl:value-of select="'false'"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="'true'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <xsl:variable name="updateAllowed">
    <xsl:choose>
      <xsl:when test="@update='false'">
        <xsl:value-of select="'false'"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="'true'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>
  <xsl:variable name="deleteAllowed">
    <xsl:choose>
      <xsl:when test="@delete='false'">
        <xsl:value-of select="'false'"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="'true'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:variable name="modifyChildAllowed">
    <xsl:choose>
      <xsl:when test="Group[@samePage='true' and not(@insert='false' and @update='false' and @delete='false')]">
        <xsl:value-of select="'true'"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="'false'"/>
      </xsl:otherwise>
    </xsl:choose> 
  </xsl:variable>  
      
<!--  <xsl:message>Testing for modifiable childs in group <xsl:value-of select="@name"/>: <xsl:value-of select="$modifyChildAllowed"/></xsl:message> -->

  <xsl:variable name="breadCrumbs">
    <xsl:choose>
      <xsl:when test="not(@breadCrumbs='false') and $layoutMode!='find'">
        <xsl:value-of select="'true'"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="'false'"/>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:variable>

  <xsl:attribute name="insertAllowed">
      <xsl:value-of select="$insertAllowed"/>
  </xsl:attribute>
  <xsl:attribute name="updateAllowed">
      <xsl:value-of select="$updateAllowed"/>
  </xsl:attribute>
  <xsl:attribute name="deleteAllowed">
      <xsl:value-of select="$deleteAllowed"/>
  </xsl:attribute>
  <!-- set modifiable childs property -->
  <xsl:attribute name="modifyChildAllowed">
      <xsl:value-of select="$modifyChildAllowed"/>
  </xsl:attribute>

  <!-- set breadcrumbs property -->
  <xsl:attribute name="hasBreadCrumbs">
      <xsl:value-of select="$breadCrumbs"/>
  </xsl:attribute>
</xsl:template>


<xsl:template name="groupTitles">
  <xsl:param name="layoutStyle"/>

  <!-- determine the display title -->
  <xsl:variable name="displayTitle">
    <xsl:call-template name="getDisplayTitle"/>
  </xsl:variable>

  <xsl:choose>
    <!-- Set group title for child groups with samepage='true'. In this case
         it's not attributes on a template call that we are creating, but a
         text attribute on a (sub)header -->
    <xsl:when test="name(..)='Group' and @samePage='true'">
      <xsl:attribute name="text">
        <xsl:value-of select="$displayTitle"/>
      </xsl:attribute>
    </xsl:when>
  
    <!-- Set group title for Find pages -->    
    <xsl:when test="$layoutStyle='find'">

      <xsl:call-template name="nlsTextAttribute">
        <xsl:with-param name="attributeName" select="'header'"/>
        <xsl:with-param name="key">
          <xsl:value-of select="utils:getNlsKey('SEARCH_TITLE',$displayTitle,concat('SEARCH_TITLE_',@name))"/>
        </xsl:with-param>
        <xsl:with-param name="value">
          <xsl:value-of select="$displayTitle"/>
        </xsl:with-param>
      </xsl:call-template>

    </xsl:when>

    <!-- Set group title for Select pages -->    
    <xsl:when test="$layoutStyle='select'">
      <xsl:call-template name="nlsTextAttribute">
        <xsl:with-param name="attributeName" select="'header'"/>
        <xsl:with-param name="key">
          <xsl:value-of select="utils:getNlsKey('SELECT_TITLE',$displayTitle,concat('SELECT_TITLE_',@name))"/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:when>

    <!-- Set group titles for Form pages -->    
    <xsl:when test="$layoutStyle='form'">
      <xsl:call-template name="nlsTextAttribute">
        <xsl:with-param name="attributeName" select="'insertTitle'"/>
        <xsl:with-param name="key">
          <xsl:value-of select="utils:getNlsKey('INSERT_TITLE',$displayTitle,concat('INSERT_TITLE_',@name))"/>
        </xsl:with-param>
      </xsl:call-template>
      <xsl:call-template name="nlsTextAttribute">
        <xsl:with-param name="attributeName" select="'updateTitle'"/>
        <xsl:with-param name="key">
          <xsl:value-of select="utils:getNlsKey('EDIT_TITLE',$displayTitle,concat('EDIT_TITLE_',@name))"/>
        </xsl:with-param>
      </xsl:call-template>
      <xsl:call-template name="nlsTextAttribute">
        <xsl:with-param name="attributeName" select="'viewTitle'"/>
        <xsl:with-param name="key">
          <xsl:value-of select="utils:getNlsKey('VIEW_TITLE',$displayTitle,concat('VIEW_TITLE_',@name))"/>
        </xsl:with-param>
      </xsl:call-template>
    </xsl:when>

    <!-- Set group title for Table pages -->    
    <xsl:when test="$layoutStyle='table'">
      <xsl:call-template name="nlsTextAttribute">
        <xsl:with-param name="attributeName" select="'header'"/>
        <xsl:with-param name="key">
          <xsl:value-of select="concat('TABLE_TITLE_',@name)"/>
        </xsl:with-param>
        <xsl:with-param name="value">
          <xsl:value-of select="$displayTitle"/>
        </xsl:with-param>
        <xsl:with-param name="addToNlsBundle">true</xsl:with-param>
      </xsl:call-template>

    </xsl:when>
  </xsl:choose>

</xsl:template>


  <!-- template to set a data bound attribute
        This template cannot reside in any UIX Library stylesheet
        because of namespace repetition problem
        It must reside in top-level stylesheet -->
  <xsl:template name="boundAttribute">
    <xsl:param name="attributeName"/>
    <xsl:param name="attributeValue"/>
    
    <xsl:attribute name="{$attributeName}">
      <xsl:value-of select="$attributeValue"/>
    </xsl:attribute>
  </xsl:template>

  <xsl:template name="dataBoundAttribute">
    <xsl:param name="name"/>
    <xsl:param name="value"/>
    <xsl:attribute name="{$name}">
      <xsl:value-of select="$value"/>
    </xsl:attribute>
  </xsl:template>

  <!-- Here is determined with UIX template will be used for this page -->
  <xsl:template name="getTemplateLocalName">
    <xsl:choose>
      <!-- Form template -->
      <xsl:when test="$layoutMode='form'">
        <xsl:choose>
          <xsl:when test="@formTemplateLocalName">
            <xsl:value-of select="@formTemplateLocalName"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'formPage'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>  

      <!-- Table template -->
      <xsl:when test="$layoutMode='table'">
        <xsl:choose>
          <xsl:when test="@tableTemplateLocalName">
            <xsl:value-of select="@tableTemplateLocalName"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'tablePage'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>  

      <!-- Select template -->
      <xsl:when test="$layoutMode='select'">
        <xsl:choose>
          <xsl:when test="@selectTemplateLocalName">
            <xsl:value-of select="@selectTemplateLocalName"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'selectPage'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>  

      <!-- Find template -->
      <xsl:when test="$layoutMode='find'">
        <xsl:choose>
          <xsl:when test="@findTemplateLocalName">
            <xsl:value-of select="@findTemplateLocalName"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="'findPage'"/>
          </xsl:otherwise>
        </xsl:choose>
      </xsl:when>  
    </xsl:choose>  
  </xsl:template>


  <xsl:template name="breadCrumbs"  xmlns="http://xmlns.oracle.com/uix/ui">
    <xsl:variable name="linkdest" select="''"/>
    <xsl:if test="not(breadCrumbs='false') and $layoutMode!='find'"> <!-- en master group? -->
      <templates:breadcrumbs xmlns:templates="http://www.oracle.com/jheadstart/templates">
        <breadCrumbs>
          <contents>

            <xsl:if test="@findPage='true' and $layoutMode!='find'">
              <xsl:call-template name="breadCrumbLink">
                <xsl:with-param name="linkText" select="utils:getNlsKey('BREADCRUMB_FIND_LABEL')"/>
                <xsl:with-param name="targetProcess" select="'findPage'"/>
              </xsl:call-template>
            </xsl:if>  

            <xsl:if test="$layoutMode='select'and @findPage='true'">
              <xsl:call-template name="breadCrumbLink">
                <xsl:with-param name="linkText" select="utils:getNlsKey('BREADCRUMB_RESULTS_LABEL')"/>
                <xsl:with-param name="targetProcess" select="'selectPage'"/>
                <xsl:with-param name="disabled" select="'true'"/>
              </xsl:call-template>
            </xsl:if>  

            <xsl:if test="$layoutMode='table'and @findPage='true'">
              <xsl:call-template name="breadCrumbLink">
                <xsl:with-param name="linkText" select="utils:getNlsKey('BREADCRUMB_RESULTS_LABEL')"/>
                <xsl:with-param name="targetProcess" select="'tablePage'"/>
                <xsl:with-param name="disabled" select="'true'"/>
              </xsl:call-template>
            </xsl:if>  


            <xsl:if test="$layoutMode='form'">
              <xsl:choose>
                <xsl:when test="@layoutStyle='select-form'">
                  <xsl:choose>
                    <xsl:when test="@findPage='true'">
                      <xsl:call-template name="breadCrumbLink">
                        <xsl:with-param name="linkText" select="utils:getNlsKey('BREADCRUMB_RESULTS_LABEL')"/>
                        <xsl:with-param name="targetProcess" select="'selectPage'"/>
                      </xsl:call-template>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:call-template name="breadCrumbLink">
                        <xsl:with-param name="linkText" select="utils:getNlsKey('BREADCRUMB_SUMMARY_LABEL')"/>
                        <xsl:with-param name="targetProcess" select="'selectPage'"/>
                      </xsl:call-template>
                    </xsl:otherwise>
                  </xsl:choose>
                  <xsl:call-template name="breadCrumbLink">
                    <xsl:with-param name="linkText" select="utils:getNlsKey('BREADCRUMB_DETAILS_LABEL')"/>
                    <xsl:with-param name="targetProcess" select="'groupPage'"/>
                    <xsl:with-param name="disabled" select="'true'"/>
                  </xsl:call-template>
                </xsl:when>
                <xsl:when test="@layoutStyle='table-form'">
                  <xsl:choose>
                    <xsl:when test="@findPage='true'">
                      <xsl:call-template name="breadCrumbLink">
                        <xsl:with-param name="linkText" select="utils:getNlsKey('BREADCRUMB_RESULTS_LABEL')"/>
                        <xsl:with-param name="targetProcess" select="'tablePage'"/>
                      </xsl:call-template>
                    </xsl:when>
                    <xsl:otherwise>
                      <xsl:call-template name="breadCrumbLink">
                        <xsl:with-param name="linkText" select="utils:getNlsKey('BREADCRUMB_SUMMARY_LABEL')"/>
                        <xsl:with-param name="targetProcess" select="'tablePage'"/>
                      </xsl:call-template>
                    </xsl:otherwise>
                  </xsl:choose>
                  <xsl:call-template name="breadCrumbLink">
                    <xsl:with-param name="linkText" select="utils:getNlsKey('BREADCRUMB_DETAILS_LABEL')"/>
                    <xsl:with-param name="targetProcess" select="'groupPage'"/>
                    <xsl:with-param name="disabled" select="'true'"/>
                  </xsl:call-template>
                </xsl:when>
              </xsl:choose>  
            </xsl:if>  
           </contents>
        </breadCrumbs>  
      </templates:breadcrumbs>  
    </xsl:if>
  </xsl:template>



  <xsl:template name="breadCrumbLink">
   <xsl:param name="linkText"/>
   <xsl:param name="targetProcess"/>
   <xsl:param name="disabled" select="'false'"/>
   <!-- add dummy text here to get output-escaping really disabled -->
   <xsl:text disable-output-escaping="yes">
   </xsl:text>
    <link>

      <!-- always data-bind text attribute because breadcrumbs
           are always generate as nls-enabled-->
      <xsl:call-template name="dataBoundAttribute">
        <xsl:with-param name="name">data:text</xsl:with-param>
        <xsl:with-param name="value">
          <xsl:value-of select="concat($linkText,'@jheadstart:nls')"/>
        </xsl:with-param>
      </xsl:call-template>
    
      <xsl:attribute name="destination">
        <xsl:text>javascript:go2(['targetCondition'],['</xsl:text>
        <xsl:value-of select="$targetProcess"/>
        <xsl:text>']);</xsl:text>
      </xsl:attribute>
      <xsl:attribute name="data:disabled">
        <xsl:value-of select="$disabled"/>
      </xsl:attribute>
    </link>
  </xsl:template>

  <!-- template to create javascript array with the prompt of all the items
       in the page -->
  <xsl:template name="itemScreenPrompts">
    <script>
      <xsl:attribute name="text">
        <xsl:text>itemScreenPrompts=[</xsl:text>
          <!-- First, process the items for the master group -->
          <xsl:call-template name="screenPromptsForGroup">
            <xsl:with-param name="tableName">
              <xsl:if test="$layoutMode='table'">
                <xsl:value-of select="concat(@name,'Set')"/>
              </xsl:if>
            </xsl:with-param>
          </xsl:call-template>
          <!-- Process items for samepage detail groups -->
          <xsl:for-each select="Group[@samePage='true']">
            <xsl:call-template name="screenPromptsForGroup">
              <xsl:with-param name="tableName" select="concat(@name,'Set')"/>
            </xsl:call-template>   
          </xsl:for-each>
        <xsl:text>['','']];</xsl:text>
      </xsl:attribute>
    </script>
  </xsl:template>

  <xsl:template name="screenPromptsForGroup">
    <xsl:param name="tableName"/>
    
    <xsl:variable name="vofile" select="utils:getURL(concat($bc4jDir,@viewObject,'.xml'))"/>
    <xsl:variable name="voDoc" select="document($vofile)"/>
      <xsl:for-each select="$voDoc/ViewObject/ViewAttribute">
        <!-- get corresponding entity attribute node (if any) -->  
        <xsl:variable name="eoFile">
          <xsl:call-template name="getEoFileName">
            <xsl:with-param name="voDoc" select="$voDoc"/>
          </xsl:call-template>
        </xsl:variable>
        <xsl:variable name="entityUsage" select="@EntityUsage"/>
        <xsl:variable name="eoAttributeName" select="@EntityAttrName"/>
        <xsl:variable name="eoDoc" select="document($eoFile)"/>
        <xsl:variable name="entityAttributeNode"  select="$eoDoc/Entity/Attribute[$entityUsage!='' and @Name=$eoAttributeName]|current()[$entityUsage='']"/>

        <!-- exclude attribute with custom property DISPLAY set to false -->
        <xsl:variable name="prompt">
          <xsl:call-template name="getCustomProperty">
          <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
          <xsl:with-param name="propertyName" select="'PROMPT'"/>
          <xsl:with-param name="defaultValue" select="@Name"/>
          </xsl:call-template>
        </xsl:variable>
        <!-- Generate the output -->
        <xsl:text>['</xsl:text>
        <xsl:if test="$tableName != ''">
          <xsl:value-of select="$tableName"/>
          <xsl:text>:</xsl:text>
        </xsl:if>
        <xsl:value-of select="@Name"/>
        <xsl:text>','</xsl:text>
        <xsl:value-of select="$prompt"/>
        <xsl:text>'],</xsl:text>
      </xsl:for-each>

  </xsl:template>



</xsl:stylesheet>

