<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : UIXSelectFormLib.xsl

Notes       :

Open Issues :

$revision_history$
29-aug-2003   Steven Davelaar
  2.6         Renamed infoTable to sessionData
06-aug-2003   Steven Davelaar
  2.5         
15-mei-2003   STEVEN DAVELAAR
  2.4         Improved nls support
17-mar-2003   Steven Davelaar
  2.3         
01-jul-2002   Peter Ebell
  2.2         Fixed xmlns namespaces.
15-may-2002   Peter Ebell
  2.1         Always use template getDisplayTitle for buttons etc.
14-may-2002   Peter Ebell
  2.0         Pre-prod release
28-mrt-2002   Peter Ebell
  1.1         Rewritten for JHeadstart 9i. Removed obsolete revision history.
02-nov-2001   Steven Davelaar
  1.0         initial creation (copied large parts from obsolete
              VoToUIXSelect.xsl)

*******************************************************************************
$add_to_revision_history
$
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns="http://xmlns.oracle.com/uix/ui"
  xmlns:data="http://xmlns.oracle.com/uix/ui"
  xmlns:utils="http://www.oracle.com/XSL/Transform/java/oracle.jheadstart.tools.util.XSLTUtils"
  exclude-result-prefixes="utils"
  xmlns:jheadstart="http://www.oracle.com/jheadstart">
  <xsl:import href="UIXLibrary.xsl"/>

  <xsl:template name="selectLayout">
    <xsl:param name="columns"/>
    <xsl:param name="voDoc"/>

    <xsl:variable name="descriptorAttribute" select="@descriptorAttribute"/>
    <xsl:variable name="dataObjectKey" select="@name"/>
    <xsl:variable name="dataObjectSetKey" select="concat(@name,'Set')"/>

    <stackLayout>
      <contents>
        <script text="ignoreChanges=true;"/>
        <spacer height="14"/>
        <xsl:call-template name="selectList">
          <xsl:with-param name="descriptorAttribute" select="$descriptorAttribute"/>
          <xsl:with-param name="dataObjectKey" select="$dataObjectKey"/>
          <xsl:with-param name="dataObjectSetKey" select="$dataObjectSetKey"/>
        </xsl:call-template>
      </contents>
    </stackLayout>
  </xsl:template>

  <xsl:template name="selectList">
    <xsl:param name="descriptorAttribute"/>
    <xsl:param name="dataObjectKey"/>
    <xsl:param name="dataObjectSetKey"/>

    <messageList>
      <xsl:attribute name="name">
        <xsl:value-of select="concat($dataObjectKey,'Rownum')"/>
      </xsl:attribute>
      <xsl:attribute name="data:selectedValue">
        <xsl:value-of select="concat($dataObjectKey,'Rownum@jheadstart:sessionData')"/>
      </xsl:attribute>

      <xsl:attribute name="size">15</xsl:attribute>

      <contents>
        <xsl:attribute name="data:childData">
          <xsl:value-of select="concat($dataObjectSetKey,'@jheadstart:sessionData')"/>
        </xsl:attribute>
        <option>
          <xsl:attribute name="data:value">
            <xsl:value-of select="'rownum'"/>
          </xsl:attribute>
          <xsl:attribute name="data:text">
            <xsl:value-of select="$descriptorAttribute"/>
          </xsl:attribute>
        </option>
      </contents>
    </messageList>
  </xsl:template>

  <xsl:template name="selectButtons">
    <!-- determine the display title -->
    <xsl:variable name="displayTitle">
      <xsl:call-template name="getDisplayTitle"/>
    </xsl:variable>

    <xsl:attribute name="formName">
      <xsl:value-of select="$formName"/>
    </xsl:attribute>

      <xsl:call-template name="nlsTextAttribute">
        <xsl:with-param name="attributeName" select="'newButtonLabel'"/>
        <xsl:with-param name="key">
          <xsl:value-of select="utils:getNlsKey('NEW_BUTTON_LABEL',$displayTitle,concat('NEW_BUTTON_LABEL_',@name))"/>
        </xsl:with-param>
      </xsl:call-template>

      <xsl:call-template name="nlsTextAttribute">
        <xsl:with-param name="attributeName" select="'editButtonLabel'"/>
        <xsl:with-param name="key">
          <xsl:value-of select="utils:getNlsKey('EDIT_BUTTON_LABEL',$displayTitle,concat('EDIT_BUTTON_LABEL_',@name))"/>
        </xsl:with-param>
      </xsl:call-template>

      <xsl:call-template name="nlsTextAttribute">
        <xsl:with-param name="attributeName" select="'viewButtonLabel'"/>
        <xsl:with-param name="key">
          <xsl:value-of select="utils:getNlsKey('VIEW_BUTTON_LABEL',$displayTitle,concat('VIEW_BUTTON_LABEL_',@name))"/>
        </xsl:with-param>
      </xsl:call-template>

  </xsl:template>

</xsl:stylesheet>
