<!--
*******************************************************************************
Copyright (c) 2001 Oracle Corporation

File        : UIXTableLib.xsl

Notes       :

Open Issues :

$revision_history$
07-sep-2003   Steven Davelaar
  2.27        Do not bind tableDataSet to newRows when master in same page and
              controller is Struts. In Struts we now have defaultDataObjectSet!
29-aug-2003   Steven Davelaar
  2.26        Renamed infoTable to sessionData
21-aug-2003   Peter Ebell
  2.25        Replaced all occurences of static URL pattern "file://" by a call to
              utils:getURL, to allow for compatibility with Linux.
12-aug-2003   Sandra Muller
  2.24        removed template hiddenFieldsTableLayout and the call to it 
              (bugfix 3054427: targetGroup and targetCondition are now in tablePage.uit)
11-aug-2003   Steven Davelaar
  2.23        removed readOnly property of delete checkbox, also enabled for 
              new rows: bug 2683576
06-aug-2003   Steven Davelaar
  2.22        
29-jul-2003   Steven Davelaar
  2.21        fix for bug 2745305: onSubmit must be single return statement, 
              with && beween all checkForChanges for each child group set
              in same page!
28-jul-2003   Steven Davelaar
  2.20        Single selection bean header was not nls-enabled when used
              for access of detail group
21-jul-2003   Peter Ebell
  2.19        Fixed bug (no value for selectText) in tableSelection template when
              master layout style = table
05-jun-2003   Steven Davelaar
  2.18
05-jun-2003   Steven Davelaar
  2.17        No rows found now generated as nlstext attribute
22-may-2003   Steven Davelaar
  2.16        Fixed error jar: XSL-1047: (Error) Invalid instantiation of 'Attribute' in
              'Element' context. Caused by detailDisclosure attribute added AFTER tableData
              Also check for detailDisclosure is true instead of not null!
15-mei-2003   Steven Davelaar
  2.15        changed @nls to @jheadstart:nls
03-mei-2003   Steven Davelaar
  2.14        Improved nls support
01-mei-2003   Steven Davelaar
  2.13        Added nls support
17-apr-2003   Steven Davelaar
  2.11        cleaned up revision history
16-apr-2003   Steven Davelaar
  2.10        Added support for detailDisclosure
17-mrt-2003   Steven Davelaar
  2.9         .
19-dec-2002   Peter Ebell
  2.8         .
28-okt-2002   Peter Ebell
  2.7         Set displayGrid=true
02-aug-2002   Peter Ebell
  2.6         Added hidden form field "inserting" to hold a "N" for existing rows,
              and "Y" for empty rows, so that we can make this distinction in Javascript
              functions.
01-jul-2002   Peter Ebell
  2.5         Changed references to formValues 'targetInfoAlias(Value)' to 'targetCondition(Value)'
              because infoAliases do not exist in the SimpleProcessRouter.
14-jun-2002   Peter Ebell
  2.4         Use language-specific column header for delete column
11-jun-2002   Peter Ebell
  2.3         Disable singleSelection items for rows that are Inserting
10-jun-2002   Peter Ebell
  2.2         - Use DISPLAY_TABLE only in table-form layout
              - When table is master group, add formvalues 'targetGroup' and 'targetInfoAlias'
15-mei-2002   Peter Ebell
  2.1         Always use template getDisplayTitle for buttons etc.
14-mei-2002   Peter Ebell
  2.0         Pre-prod
07-feb-2002   Peter Ebell
  1.11        Fixed bug when locating the entity file when entity usage name not
              equal to entity name
22-jan-2002   Peter Ebell
  1.10        Changed globalHeaderName to displayTitle
22-jan-2002   Steven Davelaar
  1.9         Do not render Delete? checkbox in table when in Viewing mode
21-jan-2002   Steven Davelaar
  1.8         Removed xsl:message which also resolved strange error with redundant
              <table> tag!
18-jan-2002   Steven Davelaar
  1.7         Changed UIX structure of table. Now using <column> element to
              encapsulate all elements and attributes that impact a columns
              layout and behavior
              Columns are now only sortable when the Group sortable attribute
              is set to true AND the VO attribute as well as the underlying EO attribute
              have queriable set to true (or to be exact: not set to false)
17-jan-2002   Peter Ebell
  1.6         Added explicit parameter passing between templates for compatibility with
              JDeveloper 9i
18-dec-2001   Steven Davelaar
  1.5         Added calls to XSLTUtils.getNlsKey for Delete column header
              and Single Selection text
10-dec-2001   Steven Davelaar
  1.4         Replaced hardcoded page text with calls to
              XSLTUtils.getNlsKey
26-nov-2001   Steven Davelaar
  1.3         Removed references to appStruc variable since the application
              structure file is now the source document for the transformation
02-nov-2001   Steven Davelaar
  1.2         Changed package name XSLTUtils class
31-okt-2001   Steven Davelaar
  1.1         Added datascope elements to display empty rows in
              table displayed in new master page
              Added value binding of hasChanges
25-sep-2001   Steven Davelaar
  1.0         initial creation (copied most part from obsolete
              VOToUIXTable.xsl)
*******************************************************************************
$add_to_revision_history
$
-->
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0"
  xmlns:data="http://xmlns.oracle.com/uix/ui"
  xmlns:utils="http://www.oracle.com/XSL/Transform/java/oracle.jheadstart.tools.util.XSLTUtils"
  xmlns:string="http://www.oracle.com/XSL/Transform/java/java.lang.String"
  exclude-result-prefixes="utils, string">
  <xsl:import href="UIXLibrary.xsl"/>


  <xsl:template name="tableLayout">
    <xsl:param name="voDoc"/>
    <xsl:param name="masterDataObject"/>
    <xsl:param name="masterTabName"/>
    <xsl:param name="masterContextAttribute"/>
    <xsl:param name="display"/>
    <xsl:param name="layoutStyle"/>
    <xsl:param name="groupLayoutStyle"/>

    <xsl:variable name="dataObjectSetKey" select="concat(@name,'Set')"/>
    <xsl:variable name="useTableRange" select="@useTableRange"/>

    <xsl:variable name="width">
      <xsl:choose>
        <xsl:when test="@tableWidth!=''">
          <xsl:value-of select="@tableWidth"/>
        </xsl:when>
        <xsl:otherwise>
          <xsl:value-of select="'100%'"/>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:variable>

    <!-- this used to be defined against body tag,
         check whetehr we can put it lower in hierarchy -->
    <script>
      <xsl:attribute name="text">
        <xsl:text>ignoreChangedFields=['</xsl:text>
        <xsl:value-of select="$dataObjectSetKey"/>
        <xsl:text>:selected'];</xsl:text>
      </xsl:attribute>
    </script>

    <xsl:if test="@samePage!='true' or not(@samePage)">
      <xsl:call-template name="masterContext">
         <xsl:with-param name="masterDataObject" select="$masterDataObject"/>
         <xsl:with-param name="masterTabName" select="$masterTabName"/>
         <xsl:with-param name="masterContextAttribute" select="$masterContextAttribute"/>
      </xsl:call-template>
    </xsl:if>
    <spacer height="14"/>

    <xsl:choose>
      <xsl:when test="@samePage='true'">
        <dataScope>
          <provider>
            <data name="newTableData">
              <inline>
                <xsl:if test="@newRows!=''">
                  <xsl:value-of disable-output-escaping="yes"
                    select="utils:getNewRowTags(@newRows)"/>
                </xsl:if>    
              </inline>
            </data>
          </provider>
          <contents>
            <xsl:call-template name="table">
              <xsl:with-param name="voDoc" select="$voDoc"/>
              <xsl:with-param name="width" select="$width"/>
              <xsl:with-param name="tableDataSet" select="$dataObjectSetKey"/>
              <xsl:with-param name="useTableRange" select="$useTableRange"/>
              <xsl:with-param name="deleteAllowed" select="@delete"/>
              <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
              <xsl:with-param name="groupLayoutStyle" select="$groupLayoutStyle"/>
            </xsl:call-template>
          </contents>
        </dataScope>
      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="table">
          <xsl:with-param name="voDoc" select="$voDoc"/>
          <xsl:with-param name="width" select="$width"/>
          <xsl:with-param name="tableDataSet" select="$dataObjectSetKey"/>
          <xsl:with-param name="useTableRange" select="$useTableRange"/>
          <xsl:with-param name="deleteAllowed" select="@delete"/>
          <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
          <xsl:with-param name="groupLayoutStyle" select="$groupLayoutStyle"/>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>

  </xsl:template>

  <!-- template to create javascript array of required fields
       in a table -->
  <xsl:template name="requiredFieldsInTable">
    <xsl:param name="groupLayoutStyle"/>
    <xsl:choose>
      <xsl:when test="$layoutMode='table'">
        <xsl:call-template name="requiredFieldsArray">
          <xsl:with-param name="viewObject" select="@viewObject"/>
          <xsl:with-param name="groupLayoutStyle" select="$groupLayoutStyle"/>
        </xsl:call-template>
      </xsl:when>
      <xsl:otherwise>
        <!-- check whether group has child groups with samePage is true,
             if so, add required fields array for each child group -->
        <xsl:for-each select="Group[@samePage='true']">
          <xsl:call-template name="requiredFieldsArray">
            <xsl:with-param name="viewObject" select="@viewObject"/>
            <xsl:with-param name="groupLayoutStyle" select="$groupLayoutStyle"/>
          </xsl:call-template>
        </xsl:for-each>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <xsl:template name="requiredFieldsArray">
    <xsl:param name="viewObject"/>
    <xsl:param name="groupLayoutStyle"/>

    <xsl:variable name="vofile" select="utils:getURL(concat($bc4jDir,$viewObject,'.xml'))"/>
    <xsl:variable name="voDoc" select="document($vofile)"/>

    <script>
      <xsl:attribute name="text">
        <xsl:text>requiredFields=['</xsl:text>

        <xsl:for-each select="$voDoc/ViewObject/ViewAttribute">
          <!-- get corresponding entity attribute node (if any) -->  
          <xsl:variable name="eoFile">
            <xsl:call-template name="getEoFileName">
              <xsl:with-param name="voDoc" select="$voDoc"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="entityUsage" select="@EntityUsage"/>
          <xsl:variable name="eoAttributeName" select="@EntityAttrName"/>
          <xsl:variable name="eoDoc" select="document($eoFile)"/>
          <xsl:variable name="entityAttributeNode"  select="$eoDoc/Entity/Attribute[$entityUsage!='' and @Name=$eoAttributeName]|current()[$entityUsage='']"/>

          <!-- exclude attribute with custom property DISPLAY set to false -->
          <xsl:variable name="display">
            <xsl:call-template name="setDisplayVariable">
              <xsl:with-param name="entityAttributeNode" select="$entityAttributeNode"/>
              <xsl:with-param name="groupLayoutStyle" select="$groupLayoutStyle"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="required"
            select="$entityAttributeNode/@IsNotNull"/>
          <xsl:if test="$display='true' and $required='true'">
            <xsl:value-of select="@Name"/>
            <xsl:text>','</xsl:text>
          </xsl:if>
        </xsl:for-each>

        <xsl:text>'];</xsl:text>
      </xsl:attribute>
    </script>

  </xsl:template>
  <!-- template to add onSubmit attribute to form
       This should be added to all forms that contain a table -->
  <xsl:template name="formOnSubmit">
    <!-- add onSubmit attribute that invokes javascript that checks for
         changes. the hidden form field hasChanges will be populated for
         each row, so SaveMarlinTable will only save changed rows -->
    <xsl:choose>
      <xsl:when test="$layoutMode='table'">
        <xsl:attribute name="onSubmit">
          <xsl:text>return checkForChanges('</xsl:text>
          <xsl:value-of select="$formName"/>
          <xsl:text>','</xsl:text>
          <xsl:value-of select="@name"/>
          <xsl:text>Set')</xsl:text>
        </xsl:attribute>
      </xsl:when>
      <xsl:when test="$layoutMode='form' 
                      and count(Group[@samePage='true'])>0">
        <!-- check whether group has child groups with samePage is true,
             if so, add checkForChanges call for each child group
             S. davelaar, 29-07-2003, fix for bug 2745305:
             Must be single return statement, with && beween all
             checkForChanges for each child group sets!!-->
        <xsl:attribute name="onSubmit">
          <!-- start onSubmit statement -->
          <xsl:text>return </xsl:text>
          <xsl:for-each select="Group[@samePage='true']">
             <!-- if not first child group, start with && -->
            <xsl:if test="position()>1">
              <xsl:text> &amp;&amp; </xsl:text>
            </xsl:if>
            <xsl:text>checkForChanges('</xsl:text>
            <xsl:value-of select="$formName"/>
            <xsl:text>','</xsl:text>
            <xsl:value-of select="@name"/>
            <xsl:text>Set')</xsl:text>
          </xsl:for-each>
          <!-- close onSubmit statement -->
          <xsl:text>;</xsl:text>
        </xsl:attribute>
      </xsl:when>
    </xsl:choose>
  </xsl:template>

  <!-- template for adding master context -->
  <xsl:template name="masterContext">
    <xsl:param name="masterDataObject"/>
    <xsl:param name="masterTabName"/>
    <xsl:param name="masterContextAttribute"/>
    <xsl:choose>
      <xsl:when test="$masterDataObject!=''">
        <spacer height="14"/>
        <messageStyledText vAlign="bottom" styleClass="OraLightHeaderSub">

          <xsl:call-template name="nlsTextAttribute">
            <xsl:with-param name="attributeName" select="'prompt'"/>
            <xsl:with-param name="key">
              <xsl:value-of select="concat('MASTER_CONTEXT_',../@name)"/>
            </xsl:with-param>
            <xsl:with-param name="value">
              <xsl:value-of select="$masterTabName"/>
            </xsl:with-param>
            <xsl:with-param name="addToNlsBundle">true</xsl:with-param>
          </xsl:call-template>
           
          <xsl:call-template name="dataBoundAttribute">
            <xsl:with-param name="name">data:text</xsl:with-param>
            <xsl:with-param name="value">
              <xsl:value-of select="concat($masterContextAttribute,'@jheadstart:',$masterDataObject)"/>
            </xsl:with-param>
          </xsl:call-template>
        </messageStyledText>
      </xsl:when>
    </xsl:choose>
    <xsl:copy-of select="masterContext"/>
  </xsl:template>


  <xsl:template name="setDisplayVariable">
    <xsl:param name="entityAttributeNode"/>
    <xsl:param name="groupLayoutStyle"/>

    <xsl:variable name="displayAll">
      <xsl:call-template name="getCustomProperty">
        <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
        <xsl:with-param name="propertyName" select="'DISPLAY'"/>
        <xsl:with-param name="defaultValue" select="'true'"/>
      </xsl:call-template>
    </xsl:variable>
    <xsl:variable name="displayTable">
      <xsl:call-template name="getCustomProperty">
        <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
        <xsl:with-param name="propertyName" select="'DISPLAY_TABLE'"/>
        <xsl:with-param name="defaultValue" select="$displayAll"/>
      </xsl:call-template>
    </xsl:variable>
    <!-- LJ only when display/displayAll=true should the value returned be DISPLAY_TABLE -->
    <xsl:choose>
      <xsl:when test="$displayAll='true'">
        <xsl:choose>
          <!-- S. Davelaar: groupLayoutStyle is form when called from section
               that creates <detail> element for detail disclosure! -->
          <xsl:when test="$groupLayoutStyle='form'">
            <xsl:value-of select="$displayAll"/>
          </xsl:when>
          <xsl:otherwise>
            <xsl:value-of select="$displayTable"/>
          </xsl:otherwise>
        </xsl:choose>  
      </xsl:when>
      <xsl:when test="$displayAll='hidden'">
        <xsl:value-of select="'hidden'"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="'false'"/>
      </xsl:otherwise>
    </xsl:choose>
<!-- obsolete because we now use displayAll as default for for displayTable
    <xsl:choose>
      <xsl:when test="$displayAll='true' and $displayTable='true'">
        <xsl:value-of select="'true'"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:value-of select="'false'"/>
      </xsl:otherwise>
    </xsl:choose>
-->
  </xsl:template>

  <xsl:template name="tableDataAttribute">
    <xsl:param name="tableDataSet"/>

    <!-- add detailDicalosure attribute -->
    <xsl:if test="@detailDisclosure='true'">
        <xsl:call-template name="dataBoundAttribute">
          <xsl:with-param name="name">data:detailDisclosure</xsl:with-param>
          <xsl:with-param name="value">
            <xsl:value-of select="concat($tableDataSet,'@jheadstart:sessionData')"/>
          </xsl:with-param>
        </xsl:call-template>
    </xsl:if>

     <!-- Here we have the only place where we generate different code based on
          cvontroller type. For STruts, we support default dataobject set, so
          we do not need to bound to in page newRows dataProvider when master
          is inserting -->
    <xsl:choose>
      <xsl:when test="@samePage='true' and $controllerType='MVC Framework'">
       <xsl:variable name="masterDataObjectKey" select="../@name"/>
         <boundAttribute name="tableData">
           <if>
             <dataObject source="{concat('jheadstart:',$masterDataObjectKey)}" select="isInserting"/>
             <dataObject source="newTableData" select="newRow"/>
             <dataObject source="jheadstart:sessionData">
               <xsl:attribute name="select">
                 <xsl:value-of select="$tableDataSet"/>
               </xsl:attribute>  
             </dataObject>
           </if>
         </boundAttribute>

      </xsl:when>
      <xsl:otherwise>
        <xsl:call-template name="dataBoundAttribute">
          <xsl:with-param name="name">data:tableData</xsl:with-param>
          <xsl:with-param name="value">
            <xsl:value-of select="concat($tableDataSet,'@jheadstart:sessionData')"/>
          </xsl:with-param>
        </xsl:call-template>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:template>

  <!-- main template for adding the table element -->
  <xsl:template name="table">
    <xsl:param name="voDoc"/>
    <xsl:param name="width"/>
    <xsl:param name="tableDataSet"/>
    <xsl:param name="useTableRange"/>
    <xsl:param name="deleteAllowed"/>
    <xsl:param name="layoutStyle"/>
    <xsl:param name="groupLayoutStyle"/>

    <!-- we need to store the group node in a variable because we will
         loose the "Group" context from here on
    -->
    
    <xsl:variable name="group" select="current()"/>

    <xsl:variable name="dataObjectName">
      <xsl:value-of select="@name"/>
    </xsl:variable>
    
    
    
    <xsl:variable name="sortable">
      <xsl:value-of select="@sortable"/>
    </xsl:variable>

    <table proxied="true"
          formSubmitted="true">


      <xsl:call-template name="nlsTextAttribute">
        <xsl:with-param name="attributeName" select="'alternateText'"/>
        <xsl:with-param name="key">
          <xsl:value-of select="utils:getNlsKey('NO_ROWS_FOUND')"/>
        </xsl:with-param>
      </xsl:call-template>

      
      <!-- destination -->
      <xsl:call-template name="dataBoundAttribute">
        <xsl:with-param name="name">data:destination</xsl:with-param>
        <xsl:with-param name="value">destination@jheadstart:sessionData</xsl:with-param>
      </xsl:call-template>

      <!-- table width -->
      <xsl:attribute name="width">
        <xsl:value-of select="$width"/>
      </xsl:attribute>
      <!-- table name must be equal to tabledata dataset!! -->
      <xsl:attribute name="name">
        <xsl:value-of select="$tableDataSet"/>
      </xsl:attribute>

      <!-- add value, blocksize and maxValue if ranges must be supported -->
      <xsl:choose>
        <xsl:when test="$useTableRange='true'">
          <!-- bind value -->
          <xsl:call-template name="dataBoundAttribute">
            <xsl:with-param name="name">data:value</xsl:with-param>
            <xsl:with-param name="value">
              <xsl:value-of select="concat('rangeStart@jheadstart:',$tableDataSet)"/>
            </xsl:with-param>
          </xsl:call-template>

          <!-- bind blockSize -->
          <xsl:call-template name="dataBoundAttribute">
            <xsl:with-param name="name">data:blockSize</xsl:with-param>
            <xsl:with-param name="value">
              <xsl:value-of select="concat('rangeSize@jheadstart:',$tableDataSet)"/>
            </xsl:with-param>
          </xsl:call-template>

          <!-- bind maxValue -->
          <xsl:call-template name="dataBoundAttribute">
            <xsl:with-param name="name">data:maxValue</xsl:with-param>
            <xsl:with-param name="value">
              <xsl:value-of select="concat('rowCount@jheadstart:',$tableDataSet)"/>
            </xsl:with-param>
          </xsl:call-template>

        </xsl:when>
      </xsl:choose>

      <!-- table data attribute must be added at the end because
           it uses boundAttribute child element when table is displayed
           on samep page as master -->
      <xsl:call-template name="tableDataAttribute">
        <xsl:with-param name="tableDataSet" select="$tableDataSet"/>
      </xsl:call-template>  

      <xsl:call-template name="tableSelection">
        <xsl:with-param name="groupLayoutStyle" select="$groupLayoutStyle"/>
        <xsl:with-param name="dataObjectName" select="$dataObjectName"/>
        <xsl:with-param name="tableDataSet" select="$tableDataSet"/>
      </xsl:call-template>


      <tableFormat tableBanding="rowBanding"/>

      <contents>
        <xsl:for-each select="$voDoc/ViewObject/ViewAttribute">
 <!--          <xsl:message>Processing columnformat <xsl:value-of select="@Name"/></xsl:message> -->
          <!-- get corresponding entity attribute node (if any) -->  
          <xsl:variable name="eoFile">
            <xsl:call-template name="getEoFileName">
              <xsl:with-param name="voDoc" select="$voDoc"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="entityUsage" select="@EntityUsage"/>
          <xsl:variable name="eoAttributeName" select="@EntityAttrName"/>
          <xsl:variable name="eoDoc" select="document($eoFile)"/>
          <xsl:variable name="entityAttributeNode"  select="$eoDoc/Entity/Attribute[$entityUsage!='' and @Name=$eoAttributeName]|current()[$entityUsage='']"/>

          <!-- exclude attribute with custom property DISPLAY set to false -->
          <xsl:variable name="display">
            <xsl:call-template name="setDisplayVariable">
              <xsl:with-param name="entityAttributeNode" select="$entityAttributeNode"/>
              <xsl:with-param name="groupLayoutStyle" select="$groupLayoutStyle"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:if test="$display='true'">
             <column>
               <!-- set column format -->
               <columnFormat displayGrid="true" columnDataFormat="textFormat"/>
               <!-- set column header -->
               <xsl:call-template name="columnHeader">
                  <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
                  <xsl:with-param name="sortable" select="$sortable"/>
                  <xsl:with-param name="dataObjectName" select="$dataObjectName"/>
               </xsl:call-template>
               <!-- set column content -->
               <contents>
                  <xsl:call-template name="createFormElement">
                    <xsl:with-param name="attributeName" select="@Name"/>
                    <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
                    <xsl:with-param name="operator" select="''"/>
                    <xsl:with-param name="isFindElement">false</xsl:with-param>
                    <xsl:with-param name="display" select="$display"/>
                    <xsl:with-param name="tableDataSet" select="$tableDataSet"/>
                    <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
                    <xsl:with-param name="group" select="$group"/>
                    <xsl:with-param name="dataObjectName" select="$dataObjectName"/>
                  </xsl:call-template>
               </contents>   
             </column> 
          </xsl:if>
      </xsl:for-each>

<!--  <xsl:message>deleteAllowed=<xsl:value-of select="$deleteAllowed"/></xsl:message>  -->
        <!-- add column for Delete checkbox -->
        <xsl:choose>
          <xsl:when test="not($deleteAllowed='false')">
            <column>
              <xsl:call-template name="dataBoundAttribute">
                <xsl:with-param name="name">data:rendered</xsl:with-param>
                <xsl:with-param name="value">
                  <xsl:value-of select="'isNotViewing@jheadstart:staticData'"/>
                </xsl:with-param>
              </xsl:call-template>

              <columnFormat displayGrid="true" columnDataFormat="iconButtonFormat"/>
              <columnHeader>
                <text>
                  <xsl:call-template name="nlsTextAttribute">
                    <xsl:with-param name="attributeName" select="'text'"/>
                    <xsl:with-param name="key">
                      <xsl:value-of select="utils:getNlsKey('DELETE_COLUMN_HEADER')"/>
                    </xsl:with-param>
                  </xsl:call-template>
               </text>
              </columnHeader>
              <contents>
                <checkBox name="deleteRow" value="ok">
                  <!-- no longer bind readOnly, also enabled for new rows: bug 2683576 
                  <xsl:call-template name="dataBoundAttribute">
                    <xsl:with-param name="name">data:readOnly</xsl:with-param>
                    <xsl:with-param name="value">isInserting</xsl:with-param>
                  </xsl:call-template>
                  -->
                </checkBox>
              </contents>
            </column>  
          </xsl:when>
        </xsl:choose>


        <xsl:call-template name="hiddenFormFieldsInTable"/>

        <!-- add separate loop to add hidden view attributes,
             they must be added at the end, otherwise the display of
             column header prompts gets out of msynch (cabo bug...) -->

        <xsl:for-each select="$voDoc/ViewObject/ViewAttribute">
<!--           <xsl:message>Processing hidden field <xsl:value-of select="@Name"/></xsl:message> -->
          <xsl:variable name="eoFile">
            <xsl:call-template name="getEoFileName">
              <xsl:with-param name="voDoc" select="$voDoc"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="entityUsage" select="@EntityUsage"/>
          <xsl:variable name="eoAttributeName" select="@EntityAttrName"/>
          <xsl:variable name="eoDoc" select="document($eoFile)"/>
          <xsl:variable name="entityAttributeNode"  select="$eoDoc/Entity/Attribute[$entityUsage!='' and @Name=$eoAttributeName]|current()[$entityUsage='']"/>

          <xsl:variable name="display">
            <xsl:call-template name="setDisplayVariable">
              <xsl:with-param name="entityAttributeNode" select="$entityAttributeNode"/>
              <xsl:with-param name="groupLayoutStyle" select="$groupLayoutStyle"/>
            </xsl:call-template>
          </xsl:variable>

          <xsl:choose>
            <!-- Add displayed as well as hidden attributes! -->
            <xsl:when test="$display='hidden'">
              <xsl:call-template name="createFormElement">
                <xsl:with-param name="attributeName" select="@Name"/>
                <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
                <xsl:with-param name="operator" select="''"/>
                <xsl:with-param name="isFindElement">false</xsl:with-param>
                <xsl:with-param name="display" select="$display"/>
                <xsl:with-param name="tableDataSet" select="$tableDataSet"/>
                <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
                <xsl:with-param name="group" select="$group"/>
                <xsl:with-param name="dataObjectName" select="$dataObjectName"/>
              </xsl:call-template>
            </xsl:when>
          </xsl:choose>
        </xsl:for-each>
      </contents>  

     <!-- add <detail> section of detailDisclosure is set to true -->
     <xsl:if test="@detailDisclosure='true'">
      <detail> 
        <labeledFieldLayout>
          <xsl:attribute name="columns">
            <xsl:choose>
              <xsl:when test="@columns!=''">
                <xsl:value-of select="@columns"/>
              </xsl:when>
              <xsl:otherwise>1</xsl:otherwise>
           </xsl:choose>   
          </xsl:attribute>  
          <xsl:attribute name="width">
            <xsl:choose>
              <xsl:when test="@formWidth!=''">
                <xsl:value-of select="@formWidth"/>
              </xsl:when>
              <xsl:otherwise>10%</xsl:otherwise>
           </xsl:choose>   
          </xsl:attribute>  
          <contents>
          
        <xsl:for-each select="$voDoc/ViewObject/ViewAttribute">
 <!--          <xsl:message>Processing columnformat <xsl:value-of select="@Name"/></xsl:message> -->
          <!-- get corresponding entity attribute node (if any) -->  
          <xsl:variable name="eoFile">
            <xsl:call-template name="getEoFileName">
              <xsl:with-param name="voDoc" select="$voDoc"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="entityUsage" select="@EntityUsage"/>
          <xsl:variable name="eoAttributeName" select="@EntityAttrName"/>
          <xsl:variable name="eoDoc" select="document($eoFile)"/>
          <xsl:variable name="entityAttributeNode"  select="$eoDoc/Entity/Attribute[$entityUsage!='' and @Name=$eoAttributeName]|current()[$entityUsage='']"/>

          <xsl:variable name="displayAll">
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
              <xsl:with-param name="propertyName" select="'DISPLAY'"/>
              <xsl:with-param name="defaultValue" select="'true'"/>
            </xsl:call-template>
          </xsl:variable>
          <xsl:variable name="displayTable">
            <xsl:call-template name="getCustomProperty">
              <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
              <xsl:with-param name="propertyName" select="'DISPLAY_TABLE'"/>
              <xsl:with-param name="defaultValue" select="$displayAll"/>
            </xsl:call-template>
          </xsl:variable>

          <!-- only include attribute with custom property DISPLAY_TABLE set to false
               and Display all set to true -->
          <xsl:if test="$displayAll='true' and $displayTable='false'">
            <xsl:call-template name="createFormElement">
              <xsl:with-param name="attributeName" select="@Name"/>
              <xsl:with-param name="entityAttribute" select="$entityAttributeNode"/>
              <xsl:with-param name="operator" select="''"/>
              <xsl:with-param name="isFindElement">false</xsl:with-param>
              <xsl:with-param name="display" select="'true'"/>
              <xsl:with-param name="tableDataSet" select="$tableDataSet"/>
              <xsl:with-param name="layoutStyle" select="$layoutStyle"/>
              <xsl:with-param name="group" select="$group"/>
              <xsl:with-param name="dataObjectName" select="$dataObjectName"/>
            </xsl:call-template>
          </xsl:if>
      </xsl:for-each>
      </contents>
      </labeledFieldLayout>
      </detail> 
     </xsl:if>

     
    </table>

  </xsl:template>

  <!-- Set singleselectionbean if layout style is
       table-form OR layoutstyule is table and group has child
       group(s). In this case, we add a button for each child group -->
  <xsl:template name="tableSelection">
    <xsl:param name="groupLayoutStyle"/>
    <xsl:param name="dataObjectName"/>
    <xsl:param name="tableDataSet"/>


    <xsl:variable name="displayTitle">
      <xsl:call-template name="getDisplayTitle"/>
    </xsl:variable>

    <xsl:choose>
      <xsl:when test="$groupLayoutStyle='table-form'">
        <tableSelection>
          <singleSelection data:disabled="isInserting">
            <xsl:call-template name="nlsTextAttribute">
              <xsl:with-param name="attributeName" select="'text'"/>
              <xsl:with-param name="key">
                <xsl:value-of select="utils:getNlsKey('SELECT_TITLE', $displayTitle,concat('SELECT_TITLE_',@name))"/>
              </xsl:with-param>
            </xsl:call-template>
            <contents>
           
              <!-- button to go to details= form layout -->
              <!-- This dummy text element is required to get proper escaping of the
                   ampersands used in property files that contain button labels
                   The ampersand is used to indicate the access key -->
              <xsl:text disable-output-escaping="no">
              </xsl:text>
              <submitButton name="details" value="go">

                <xsl:call-template name="nlsTextAttribute">
                  <xsl:with-param name="attributeName" select="'textAndAccessKey'"/>
                  <xsl:with-param name="key">
                    <xsl:value-of select="utils:getNlsKey('DETAIL_VIEW_BUTTON_LABEL')"/>
                  </xsl:with-param>
                </xsl:call-template>

                <xsl:attribute name="onClick">
                  <xsl:text>return checkSelectedRow('</xsl:text>
                  <xsl:value-of select="@name"/>
                  <xsl:text>Form','</xsl:text>
                  <xsl:value-of select="$tableDataSet"/>
                  <xsl:text>');</xsl:text>
                </xsl:attribute>
              </submitButton>
            </contents>
          </singleSelection>
        </tableSelection>
      </xsl:when>
      <xsl:when test="Group/@name!=''">
        <!-- group is parent group, add buttons for each child group -->
        <xsl:call-template name="childGroupSelection">
          <xsl:with-param name="displayTitle" select="$displayTitle"/>
          <xsl:with-param name="tableDataSet" select="$tableDataSet"/>
        </xsl:call-template>
      </xsl:when>
    </xsl:choose>
  </xsl:template>

  <!-- Set singleselectionbean if layout style is
       table-form OR layoutstyule is table and group has child
       group(s). In this case, we add a button for each child group -->
  <xsl:template name="childGroupSelection">
    <xsl:param name="displayTitle"/>
    <xsl:param name="tableDataSet"/>

   <tableSelection>
     <singleSelection data:disabled="isInserting">
        <xsl:call-template name="nlsTextAttribute">
          <xsl:with-param name="attributeName" select="'text'"/>
          <xsl:with-param name="key">
            <xsl:value-of select="utils:getNlsKey('SELECT_TITLE', $displayTitle,concat('SELECT_TITLE_',@name))"/>
          </xsl:with-param>
        </xsl:call-template>

       <contents>

         <xsl:for-each select="Group">
           <!-- button to go to detail group -->
           <button value="go">
             <xsl:attribute name="text">
               <xsl:call-template name="getDisplayTitle"/>
             </xsl:attribute>
             <!-- set name of button to name of child group -->
             <xsl:attribute name="name">
               <xsl:value-of select="@name"/>
             </xsl:attribute>

             <xsl:attribute name="onClick">
               <xsl:text>javascript:if (checkSelectedRow('</xsl:text>
               <xsl:value-of select="$formName"/>
               <xsl:text>','</xsl:text>
               <xsl:value-of select="$tableDataSet"/>
               <xsl:text>')) go3('</xsl:text>
               <xsl:value-of select="$formName"/>
               <xsl:text>',['targetGroup','targetCondition'],['</xsl:text>
               <xsl:value-of select="@name"/>
               <xsl:text>','selectMasterRow']);</xsl:text>
             </xsl:attribute>
           </button>

         </xsl:for-each>
       </contents>
     </singleSelection>
   </tableSelection>
  </xsl:template>

  <!-- Set column header for each column to the prompt
   -->
  <xsl:template name="columnHeader">
    <xsl:param name="entityAttribute"/>
    <xsl:param name="sortable"/>
    <xsl:param name="dataObjectName"/>

    
    <xsl:variable name="prompt">
        <xsl:call-template name="getCustomProperty">
          <xsl:with-param name="entityAttribute" select="$entityAttribute"/>
          <xsl:with-param name="propertyName" select="'PROMPT'"/>
          <xsl:with-param name="defaultValue" select="@Name"/>
        </xsl:call-template>
    </xsl:variable>
    <!-- Set column header 
          If the table is sortable, we check whether the attribute is
          queryable. It must be queriable at both EO and VO level!
          If it is, we make the column header sortable
    -->
    <columnHeader>
       <xsl:choose>
         <xsl:when test="$sortable='true' and (not (@IsQueriable='false')) and (not ($entityAttribute/@IsQueriable='false'))">
           <sortableHeader sortable="yes">
             <xsl:call-template name="columnHeaderTextAttribute">
              <xsl:with-param name="prompt">            
                <xsl:value-of select="$prompt"/>
               </xsl:with-param>
              <xsl:with-param name="dataObjectName">            
                <xsl:value-of select="$dataObjectName"/>
               </xsl:with-param>
             </xsl:call-template>
             <xsl:attribute name="value">
               <xsl:value-of select="@Name"/>
             </xsl:attribute>
           </sortableHeader>
         </xsl:when>
         <xsl:otherwise>

           <!-- just the column header label -->
            <text>
            <xsl:call-template name="columnHeaderTextAttribute">
              <xsl:with-param name="prompt">            
                <xsl:value-of select="$prompt"/>
              </xsl:with-param>
              <xsl:with-param name="dataObjectName">            
                <xsl:value-of select="$dataObjectName"/>
               </xsl:with-param>
            </xsl:call-template>
            </text>
         </xsl:otherwise>
       </xsl:choose>  
    </columnHeader>

  </xsl:template> <!-- end columnHeader -->

  <xsl:template name="columnHeaderTextAttribute">
    <xsl:param name="prompt"/>
    <xsl:param name="dataObjectName"/>

    <!-- Use _TABLE_ as part of key so we can use different prompt in table layout
         This allows for shorter prompts, amd also prompts without & because
         promptAndAccessKey only applies to form layout -->
    <xsl:variable name="promptKey">
      <xsl:value-of select="string:toUpperCase(concat($dataObjectName,'_TABLE_',@Name))"/>
    </xsl:variable>

    <xsl:call-template name="nlsTextAttribute">
      <xsl:with-param name="attributeName" select="'text'"/>
      <xsl:with-param name="key">
        <xsl:value-of select="$promptKey"/>
      </xsl:with-param>
      <xsl:with-param name="value">
        <xsl:value-of select="$prompt"/>
      </xsl:with-param>
      <xsl:with-param name="addToNlsBundle">true</xsl:with-param>
    </xsl:call-template>
    
  </xsl:template> <!-- end columnHeaderText -->
  
  <!-- Add hidden form field for saveChanges field required by
       javascript changes check -->
  <xsl:template name="hiddenFormFieldsInTable">

     <formValue name="hasChanges">
        <xsl:call-template name="dataBoundAttribute">
          <xsl:with-param name="name">data:value</xsl:with-param>
          <xsl:with-param name="value">hasChanges</xsl:with-param>
        </xsl:call-template>
     </formValue>
     <formValue name="inserting">
       <boundAttribute name="value">
         <if>
           <dataObject select="isInserting"/>
           <fixed text="Y"/>
           <fixed text="N"/>
         </if>
       </boundAttribute>  
     </formValue>   
  </xsl:template>


  <xsl:template name="tableButtons">
    <!-- determine the display title -->
    <xsl:variable name="displayTitle">
      <xsl:call-template name="getDisplayTitle"/>
    </xsl:variable>
    
    <xsl:attribute name="formName">
      <xsl:value-of select="$formName"/>
    </xsl:attribute>

    <xsl:call-template name="nlsTextAttribute">
      <xsl:with-param name="attributeName" select="'newButtonLabel'"/>
      <xsl:with-param name="key">
        <xsl:value-of select="utils:getNlsKey('NEW_BUTTON_LABEL',$displayTitle,concat('NEW_BUTTON_LABEL_',@name))"/>
      </xsl:with-param>
    </xsl:call-template>

    <xsl:call-template name="nlsTextAttribute">
      <xsl:with-param name="attributeName" select="'saveButtonLabel'"/>
      <xsl:with-param name="key">
        <xsl:value-of select="utils:getNlsKey('SAVE_BUTTON_LABEL')"/>
      </xsl:with-param>
    </xsl:call-template>

<!--
    <xsl:attribute name="saveButtonLabel">
      <xsl:value-of disable-output-escaping="yes" select="utils:getNlsKey('SAVE_BUTTON_LABEL')"/>
    </xsl:attribute>
-->
    <xsl:attribute name="showInsertButton">
      <xsl:choose>
        <xsl:when test="@layoutStyle='table-form' and (not(@newRows) or @newRows='0')">
          <xsl:value-of select="'true'"/>
        </xsl:when>  
        <xsl:otherwise>
          <xsl:value-of select="'false'"/>
        </xsl:otherwise>  
      </xsl:choose>
    </xsl:attribute>

  </xsl:template>

</xsl:stylesheet>
